-- MySQL dump 8.21
--
-- Host: localhost    Database: voctrainer
---------------------------------------------------------
-- Server version	3.23.49a-log

--
-- Table structure for table 'Articles'
--

DROP TABLE IF EXISTS Articles;
CREATE TABLE Articles (
  code varchar(4) NOT NULL default '',
  langcode char(2) NOT NULL default '',
  article varchar(16) NOT NULL default '',
  PRIMARY KEY  (code,langcode)
);



--
-- Table structure for table 'Conjugationcodes'
--

DROP TABLE IF EXISTS Conjugationcodes;
CREATE TABLE Conjugationcodes (
  code varchar(4) NOT NULL default '',
  description varchar(64) NOT NULL default '',
  PRIMARY KEY  (code)
);



--
-- Table structure for table 'Conjugations'
--

DROP TABLE IF EXISTS Conjugations;
CREATE TABLE Conjugations (
  entryid int(11) NOT NULL default '0',
  langcode char(2) NOT NULL default '',
  conjugationcode varchar(4) NOT NULL default '',
  conjugation varchar(64) NOT NULL default '',
  PRIMARY KEY  (entryid,langcode,conjugationcode)
);



--
-- Table structure for table 'Entries'
--

DROP TABLE IF EXISTS Entries;
CREATE TABLE Entries (
  id int(11) NOT NULL default '0',
  langcode char(2) NOT NULL default '',
  word varchar(64) NOT NULL default '',
  article varchar(8) NOT NULL default '',
  typeid int(11) NOT NULL default '1',
  remark varchar(255) default NULL,
  pronunciation varchar(255) default NULL,
  antonyms varchar(255) default NULL,
  synonyms varchar(255) default NULL,
  example varchar(255) default NULL,
  paraphrase varchar(255) default NULL,
  entryusage varchar(255) default NULL,
  createdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id,langcode),
  KEY word_idx (word)
);



--
-- Table structure for table 'Entries_in_Lessions'
--

DROP TABLE IF EXISTS Entries_in_Lessions;
CREATE TABLE Entries_in_Lessions (
  lessionid int(11) NOT NULL default '0',
  entryid int(11) NOT NULL default '0',
  entrylangcode char(2) NOT NULL default '',
  PRIMARY KEY  (lessionid,entryid,entrylangcode)
);



--
-- Table structure for table 'Entries_in_Levels'
--

DROP TABLE IF EXISTS Entries_in_Levels;
CREATE TABLE Entries_in_Levels (
  levelid int(11) NOT NULL default '0',
  entryid int(11) NOT NULL default '0',
  PRIMARY KEY  (levelid,entryid)
);



--
-- Table structure for table 'Languages'
--

DROP TABLE IF EXISTS Languages;
CREATE TABLE Languages (
  code char(2) NOT NULL default '',
  language varchar(32) NOT NULL default '',
  PRIMARY KEY  (code)
);



--
-- Table structure for table 'Lessions'
--

DROP TABLE IF EXISTS Lessions;
CREATE TABLE Lessions (
  id int(11) NOT NULL auto_increment,
  name varchar(32) NOT NULL default '-',
  level int(11) NOT NULL default '0',
  createdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
);



--
-- Table structure for table 'Levels'
--

DROP TABLE IF EXISTS Levels;
CREATE TABLE Levels (
  id int(11) NOT NULL auto_increment,
  name varchar(128) NOT NULL default '',
  seqnr int(11) NOT NULL default '0',
  status char(1) NOT NULL default 'N',
  PRIMARY KEY  (id)
);



--
-- Table structure for table 'Pronouns'
--

DROP TABLE IF EXISTS Pronouns;
CREATE TABLE Pronouns (
  conjugationcode varchar(4) NOT NULL default '',
  langcode char(2) NOT NULL default '',
  pronoun varchar(16) NOT NULL default '',
  common int(1) NOT NULL default '0',
  PRIMARY KEY  (conjugationcode,langcode)
);



--
-- Table structure for table 'Types'
--

DROP TABLE IF EXISTS Types;
CREATE TABLE Types (
  id int(11) NOT NULL auto_increment,
  langcode char(2) NOT NULL default '',
  name varchar(64) NOT NULL default '',
  PRIMARY KEY  (id,langcode)
);



--
-- Table structure for table 'User_Lessions'
--

DROP TABLE IF EXISTS User_Lessions;
CREATE TABLE User_Lessions (
  id int(11) NOT NULL auto_increment,
  userid int(11) NOT NULL default '0',
  lessionid int(11) NOT NULL default '0',
  lessiongrade decimal(5,2) NOT NULL default '0.00',
  lessiondate timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
);



--
-- Table structure for table 'User_Lessions_Entries'
--

DROP TABLE IF EXISTS User_Lessions_Entries;
CREATE TABLE User_Lessions_Entries (
  userlessionid int(11) NOT NULL default '0',
  entryid int(11) NOT NULL default '0',
  entrylangcode char(2) NOT NULL default '',
  correct int(1) NOT NULL default '0',
  addpoint int(1) NOT NULL default '0',
  PRIMARY KEY  (userlessionid,entryid,entrylangcode)
);



--
-- Table structure for table 'Users'
--

DROP TABLE IF EXISTS Users;
CREATE TABLE Users (
  id int(11) NOT NULL auto_increment,
  name varchar(12) NOT NULL default '',
  password varchar(12) NOT NULL default '',
  firstname varchar(32) NOT NULL default '',
  lastname varchar(32) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  level int(11) default NULL,
  isadmin int(1) NOT NULL default '0',
  reminder int(1) default NULL,
  sessionid varchar(16) NOT NULL default '',
  PRIMARY KEY  (id)
);



