#!/usr/bin/perl -w

use strict;

use VocTrainer::Database;
use VocTrainer::Utils;
use VocTrainer::Users;
use VocTrainer::Params;
use VocTrainer::Layout;

use CGI;

my $q = new CGI;
my $dbh = DB_open();

my %in = VocTrainer::Params::GetParams(QUERY => $q);
$in{levelid} ||= 21;
$in{q} ||= "";
$in{format} ||= "";
my @languages = ('de', 'es');
my %langstrings = ('de' => 'Deutsch', 'es' => 'Espaol');

my $limit = 20;

if ($in{format} eq "csv") {
	print $q->header('text/plain');
} else {
	print $q->header;
}

my $user = VocTrainer::Users::CheckUser(DBH => $dbh);

VocTrainer::Layout::printhtmlheader(TITLE => "Levels", USER => $user) unless $in{format} eq "csv";

#if (!$user->{isadmin}) {
#
#	print "Du bist kein admin!<br>";
#	exit;
#}


if ($in{action}) {
	if ($in{action}[0] eq "save" && $user->{isadmin})  {
		&save_levels;
	}
}
# elsif ($in{action}[0] eq "search") {
#		&searchentries();
#	} else {
#		&getentries;
#	}
#} else {
#	if ($in{q}) {
#		&searchentries();
#	} else {
		&getentries;
#	}
#}

	#print "LEVELID: $in{levelid}";
my $stmt = "select id, name from Levels order by seqnr";
my @levels = DB_getdata(STMT => $stmt, DBH => $dbh);

unless ($in{format} eq "csv") {

	print qq|<table border="0" cellpadding="3" cellspacing="0" width="600"><tr>
	<td>
	<form method="GET">
	<select name="levelid" onChange="submit()">
	|;
	#	foreach (sort { $levels{$a} cmp $levels{$b} }  keys %levels) {
		foreach (@levels) {
			my $sel = ($in{levelid} == $_->[0]) ? "selected" : "";
			print qq|<option value="$_->[0]" $sel> $_->[1]\n|;
		}
	print qq|
	</select>
	</form>
	</td>
	|;

	if ($user->{isadmin}) {
		print qq|
	<td>oder</td>
	<td>
	<form method="POST">
			<input type="text" name="q" value="$in{q}">
			<input type="submit" name="action_search" value="Suchen">
	</form>
	</td>
	|;
	}

	print qq|
	</tr></table>
	|;
}
	if ($in{entries}) {

		unless ($in{format} eq "csv") {
		my $cnt = keys %{$in{entries}};

		print qq|<form method="POST">
<input type="hidden" name="levelid" value="$in{levelid}">
<input type="hidden" name="q" value="$in{q}">
<table border="0" cellpadding="3" cellspacing="0" width="600"><tr>
	<td colspan="3">$cnt Eintr&auml;ge gefunden</td>
<tr>
<tr>
	<td class="tableheader" width="200">$langstrings{$languages[0]}</td>
	<td class="tableheader" width="200">$langstrings{$languages[1]}</td>
	<td class="tableheader" width="100">&nbsp;</td>
|;
		if ($user->{isadmin}) {
			print qq|<td class="tableheader" width="100">Level</td>|;
		}
		print qq|
</tr>
|;
		}

	my $i = 0;
	foreach my $id (sort { uc($in{entries}->{$a}->{$languages[1]}->{word}) cmp uc($in{entries}->{$b}->{$languages[1]}->{word}) } keys %{$in{entries}} ) {
		print qq|<tr class="row| . ($i % 2) . qq|">| unless $in{format} eq "csv";
		foreach my $l (@languages) {
			print qq|<td>| unless $in{format} eq "csv";
			print $in{entries}->{$id}->{$l}->{article} . " " if $in{entries}->{$id}->{$l}->{article};
			print $in{entries}->{$id}->{$l}->{word};
			print qq|<input type="hidden" name="entries{$id}{$l}{article}" value="$in{entries}->{$id}->{$l}->{article}">\n| unless $in{format} eq "csv"; 
			print qq|<input type="hidden" name="entries{$id}{$l}{word}" value="$in{entries}->{$id}->{$l}->{word}">\n| unless $in{format} eq "csv"; 
			print qq|</td>\n| unless $in{format} eq "csv";
			print "\t" if $in{format} eq "csv";
		}
		unless ($in{format} eq "csv") {
		print qq|<td><a href="javascript:details('$id')">Details</a></td>|;

		if ($user->{isadmin}) {
			print qq|<td>
	<select name="level{$id}">|;
			foreach (@levels) {
				$in{entries}->{$id}->{$languages[0]}->{level} ||= 21;
				my $sel = ($in{entries}->{$id}->{$languages[0]}->{level} == $_->[0]) ? "selected" : "";
				print qq|<option value="$_->[0]" $sel> $_->[1]\n|;
			}

			print qq|\t</select>
</td>|;
		}

		print qq|</tr>|;
		} else {
			print "\n";
		}
		$i++;
	}

	if ($user->{isadmin} && $in{format} ne "csv") {
		print qq|<tr><td colspan="3">
<br>
<input type="submit" name="action_save" value="Level speichern">

</td></tr>|;
	}

	unless ($in{format} eq "csv") {
		print qq|</table>
</form>|;
	}
} else {
	print qq|
Keine Eintr&auml;ge in diesem Level<br>
<br>
<a href="dict.pl?edit=new">Neuer Eintrag </a>
|;
}
DB_close(DBH => $dbh); 


sub save_levels {

	dprint "Levels speichern\n";
	dprint ($in{level});

	my @changed;
	foreach my $eid (keys %{$in{level}}) {
		next if ($in{level}->{$eid} == $in{levelid});
		push @changed, $eid;
#		print "Geaendert: $eid : $in{level}->{$eid}<br>";
		
	}

	my $chids = join(",", @changed);

	if ($chids) {
		my $stmt = "delete from Entries_in_Levels where entryid in ($chids)";
		DB_insertdata(STMT => $stmt, DBH => $dbh);

		foreach (@changed) {
			my $ins = "insert into Entries_in_Levels values ($in{level}->{$_}, $_)";
			DB_insertdata(STMT => $ins, DBH => $dbh);
		}
	}

	undef $in{entries};

}


sub getentries {
	if ($in{q}) {
		&searchentries;
	} else {
		&getentriesinlevel;
	}
} 

sub getentriesinlevel {
	my $stmt = "select entryid from Entries_in_Levels where levelid = $in{levelid}";
	my @data = DB_getdata(STMT => $stmt, DBH => $dbh, ONECOLUMN => 1);
	my $eids = join(",", @data);

	if ($eids) {
		$stmt = "select id, langcode, word, article from Entries where id in ($eids)";
		@data = DB_getdata(STMT => $stmt, DBH => $dbh);
		foreach (@data) {
			$in{entries}->{$_->[0]}->{$_->[1]} = {
				langcode => $_->[1],
				word => $_->[2],
				article => $_->[3] || "",
				level => $in{levelid}
			}
		}
	}

	$in{entries} = VocTrainer::Utils::unicode2html($in{entries});

}

sub searchentries {

	my $stmt = "select id, langcode, word, article from Entries where ";

	$in{q} =~ s/^\s+//;
	$in{q} =~ s/\s+$//;
	my $w = $in{q};

	$w =~ s/\*/%/g;
	$stmt .= " word like " . $dbh->quote(VocTrainer::Utils::to_unicode($w)); #   . " and langcode = '$in{lang}'";

	my @data = DB_getdata(STMT => $stmt, DBH => $dbh);

	my %entries;

	foreach (@data) {
		$entries{$_->[0]}->{$_->[1]} = {
			langcode => $_->[1],
			word => $_->[2],
			article => $_->[3],
		};
	}

	my $eids = join(",", keys %entries);

	if ($eids) {
		my $stmt = "select id, langcode, word, article from Entries";
		$stmt .= " where id in ($eids) "; #  and langcode != '$in{lang}'";
		my @data = DB_getdata(STMT => $stmt, DBH => $dbh);
		foreach (@data) {
			$in{entries}->{$_->[0]}->{$_->[1]} = {
				langcode => $_->[1],
				word => $_->[2],
				article => $_->[3],
			};
		}

		$stmt = "select levelid, entryid from Entries_in_Levels where entryid in ($eids)";
		@data = DB_getdata(STMT => $stmt, DBH => $dbh);
		foreach (@data) {
			$in{entries}->{$_->[1]}->{$languages[0]}->{level} = $_->[0];
		}	
	}

	$in{entries} = VocTrainer::Utils::unicode2html($in{entries});
}
