#!/usr/bin/perl -w

use strict;


use VocTrainer::Database;
use VocTrainer::Layout;
use VocTrainer::Config;
use VocTrainer::Users;

use CGI;
use CGI::Cookie;

use Data::Dumper;

my %conf = VocTrainer::Config::returnconf();

my $q = new CGI;
my %in = map { $_ => $q->param($_) } $q->param;

my $dbh = DB_open;
my $user = VocTrainer::Users::CheckUser(DBH => $dbh);

$in{username} ||= "";
$in{back} = $ENV{HTTP_REFERER} unless defined $in{back}; 

print STDERR Dumper(\%in);

if ($in{sent}) {
	my $error = &check_user(NAME => $in{username}, PASS => $in{password}, DBH => $dbh);
	if ($error) {
		&formout($error);
	} else {
		my $sessionid = &create_session_id(UID => $in{userid}, DBH => $dbh);
		my $cookie = new CGI::Cookie (
				-NAME => "voctrainersession",
				-VALUE => $sessionid,
				-PATH => $conf{cgibasepath});

		print $q->header(-COOKIE => $cookie);
		&login_ok();

	}
} elsif ($in{logout}) {
		my $cookie = new CGI::Cookie (
				-NAME => "voctrainersession",
				-VALUE => "",
				-PATH => $conf{cgibasepath});

		print $q->header(-COOKIE => $cookie);
		&logout_ok();
} else {
	if ($user->{uid}) {
		print $q->header();
		&login_ok('isloggedin');
	} else {
		&formout;
	}
}


DB_close(DBH => $dbh);

sub login_ok {
	my $isloggedin = shift;
	&VocTrainer::Layout::printhtmlheader(TITLE => "Login", USER => $user);

	$in{back} ||= "lession.pl";

	print qq|
<table border="0" cellpadding="3" cellspacing="0" width="600">
<tr>
	<td align="center">|;

	if ($isloggedin) {
		print qq|Du bist bereits eingeloggt.<br>|;
	} else {
		print qq|Login successfull!|;
	} 
	print qq|
		<br><br>
		<a href="$in{back}">weiter</a><br>
	</td>
</tr>
</table>
<script language="JavaScript">
parent.navig.location.reload();
self.location.href = '$in{back}';
</script>
|;
}


sub logout_ok {
	&VocTrainer::Layout::printhtmlheader(TITLE => "Logout", USER => $user);

	print qq|
<table border="0" cellpadding="3" cellspacing="0" width="600">
<tr>
	<td align="center">
		Logout successfull!
	</td>
</tr>
</table>
<script language="JavaScript">
parent.navig.location.reload();
</script>

|;
}

sub create_session_id {
	my %args = (UID => 0,
				DBH => '',
				@_);

	die "No UID or/and DBH" unless ($args{DBH} && $args{UID});
	my $uid = shift;
	my @chars = ( "A" .. "Y", "a" .. "z", 0 .. 9 );
	my $usersession = join("", @chars[ map { rand @chars } (1 .. 11) ]);
	my $sessionid = $usersession . "Z" . $args{UID};

	my $stmt = "update Users set sessionid = " . $args{DBH}->quote($sessionid) . " where id = $args{UID}";
	DB_insertdata(STMT => $stmt, DBH => $args{DBH});
	return $sessionid;
}

sub check_user {
	my %args = (NAME => "",
				PASS => "",
				DBH => "",
				@_);
		
	die "No DBH" unless $args{DBH};
	my $dbh = $args{DBH};
	return "Bitte Username und Passwort ausf&uuml;llen!" unless ($args{NAME} && $args{PASS});

	my $stmt = "select id, firstname, lastname from Users where " . 
		"name = " . $dbh->quote($args{NAME}) . " and " . 
		"password = " . $dbh->quote($args{PASS});
	my @data = DB_getdata(STMT => $stmt, DBH => $dbh);
	if ($#data == 0) {
		my @cols = qw(userid firstname lastname);
		my $i = 0;
		foreach (@cols) {
			$in{$_} = $data[0][$i++];
		}
		return 0;
	} else {	
		return "No such user ...";
	}
}

sub formout {
	my $error = shift;

	print $q->header;
	&VocTrainer::Layout::printhtmlheader(TITLE => "Login", USER => $user);


	print qq|
<form method="POST">
<input type="hidden" name="sent" value="1">
<input type="hidden" name="back" value="$in{back}">
<table border="0" cellpadding="3" cellspacing="0">
|;

	print qq|<tr><td colspan="2"><div class='error'>| . $error . "</div></td></tr>" if $error;
	print qq|
<tr>
	<td>Username:&nbsp;</td>
	<td><input type="text" name="username" value="$in{username}"></td>
</tr>
<tr>
	<td>Password:&nbsp;</td>
	<td><input type="password" name="password"></td>
</tr>
<tr>
	<td></td>
	<td><input type="submit" value="Login"></td>
</tr>
</table>
</form>
	|;

}
