#!/usr/bin/perl -w

use strict;


use VocTrainer::Database;
use VocTrainer::Users;
use VocTrainer::Config;

use CGI;

my $q = new CGI;
my %in = map { $_ => $q->param($_) } $q->param;
my %conf = VocTrainer::Config::returnconf();

my $dbh = DB_open;
my $user = VocTrainer::Users::CheckUser(DBH => $dbh);

$in{username} ||= "";

DB_close(DBH => $dbh);

print $q->header();


print qq|
<html>
<head>
	<title>VocTrainer :: Navig</title>
	<link rel="StyleSheet" type="text/css" href="$conf{htmlbasepath}/css/voctrainer.css">
</head>
<body marginwidth="0" marginheight="0" topmargin="0" leftmargin="0">

<table border="0" cellpadding="10" cellspacing="0" width="100%" height="100%">
<tr>
	<td class="navig" valign="top">
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td ><a href="/cgi-bin/voctrainer/dict.pl" target="main" class="navig">W&ouml;rterbuch<br>Diccionario</a></td>
			<td align="right" ><a href="/cgi-bin/voctrainer/dict.pl" target="main" class="navig">&raquo;</a></td>
		</tr>
		<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br></td></tr>
		<tr>
			<td ><a href="/cgi-bin/voctrainer/lession.pl" target="main" class="navig">&Uuml;bungen<br>Ejercicios</a></td>
			<td  align="right"><a href="/cgi-bin/voctrainer/lession.pl" target="main" class="navig">&raquo;</a></td>
		</tr>
		<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br><br></td></tr>
|;
if ($user->{uid}) {
	print qq|
	<tr>
		<td ><a href="/cgi-bin/voctrainer/register.pl" target="main" class="navig">Einstellungen<br>Preferencias</a></td>
		<td  align="right"><a href="/cgi-bin/voctrainer/register.pl" target="main" class="navig">&raquo;</a></td>
	</tr>
	<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br></td></tr>
	<tr>
		<td ><a href="/cgi-bin/voctrainer/voclist.pl" target="main" class="navig">Vokabellisten<br>Lista de Vocables</a></td>
		<td  align="right"><a href="/cgi-bin/voctrainer/voclist.pl" target="main" class="navig">&raquo;</a></td>
	</tr>
	<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br></td></tr>
	<tr>
		<td ><a href="/cgi-bin/voctrainer/login.pl?logout=1" target="main" class="navig">Logout</a></td>
		<td  align="right"><a href="/cgi-bin/voctrainer/login.pl?logout=1" target="main" class="navig">&raquo;</a></td>
	</tr>
|;
} else {
	print qq|
	<tr>
		<td><a href="/cgi-bin/voctrainer/register.pl" target="main" class="navig">Registrieren<br>Registrarse</a></td>
		<td  align="right"><a href="/cgi-bin/voctrainer/register.pl" target="main" class="navig">&raquo;</a></td>
	</tr>
	<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br></td></tr>
	<tr>
		<td ><a href="/cgi-bin/voctrainer/login.pl?back=0" target="main" class="navig">Login</a></td>
		<td  align="right"><a href="/cgi-bin/voctrainer/login.pl?back=0" target="main" class="navig">&raquo;</a></td>
	</tr>
|;
}
my $f = "$ENV{DOCUMENT_ROOT}/$conf{htmlbasepath}/voctrainer.tgz";
my @stat = stat($f);
my @lt = localtime($stat[9]);
$lt[4]++;
$lt[5]-=100;
my $date = join(".", map { sprintf("%02d", $_) } @lt[3,4,5]);
my $size = int($stat[7]/1024);

print qq|
	<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br></td></tr>
	<tr>
		<td colspan="2"><br>
			<a href="$conf{htmlbasepath}/voctrainer.tgz" class="navig" style="font-size:10px;line-height:10px;">Sourcecode &raquo;</a><br>
			<span class="footer" style="line-height:10px;">($date, $size kb)</span><br>
			<a href="http://www.weirdoz.net/cgi-bin/cvsweb/cvsweb.cgi/?hidenonreadable=1&f=h&logsort=date&hidecvsroot=1&sortby=file&hideattic=1&cvsroot=VocTrainer" target="cvs" class="navig" style="font-size:10px;">CVS Tree &raquo;</a><br>
			<br>
|;
if ($user->{uid}) {
	print qq|	<div class="footer">Logged in as <b>$user->{firstname} $user->{lastname}</b></div>\n|;
}
print qq|
		</td>
	</tr>
	<tr><td colspan="2" style="font-size:6px;line-height:6px;"><br></td></tr>
|;

print qq|	</table>
	</td>
</tr>
</table>

</body>

</html>
|;
