#!/usr/bin/perl -w

use strict;

BEGIN {
	use FindBin;
	my $bindir = $FindBin::RealBin;
	push @INC, "$bindir/..";
}

use Mail::Bulkmail;
use VocTrainer::Database;


my $dbh = DB_open();

my $stmt = "select u.id, u.firstname, u.lastname, u.email from Users u where u.reminder = 1";
my @users = DB_getdata(STMT => $stmt, DBH => $dbh);

my $uids = join(",", map { $_->[0] } @users);

if ($uids)  {
	my @lt = localtime();
	$lt[4]++; $lt[5]+=1900;
	my $today = $lt[5] . sprintf("%02d", $lt[4]) . sprintf("%02d", $lt[3]); 
#	print "Today: $today\n";
	my $stmt = 'select distinct userid from User_Lessions where userid in (' . $uids . ') and ' . 
		' date_format(lessiondate, "%Y%m%d") = "' . $today . '"';
	my @today = DB_getdata(STMT => $stmt, DBH => $dbh, ONECOLUMN => 1);
#	my %today = map { $_ => 1 } @today;
	my @sendto;
	foreach my $u (@users) {
		next if grep /^$u->[0]$/, @today;
#		print "U1: " . $u->[0] . " ? $today{$u->[0]} \n";
#		next if $today{$u->[0]};
		push @sendto, qq|"$u->[1] $u->[2]" <$u->[3]>|;
	}

	if ($#sendto != -1) {
#		print "Send mail to ";
#		print "$_\n" for @sendto;

#		@sendto = ('"Markus Koppenberger" <koppi@action.at>');
		my $mail = qq|

Liebe(r) Spanisch Lernende(r)

Du hast heute schon wieder mal vergessen, zumindestens eine Vokabel-Uebung
zu machen. Also ab auf die VocTrainer Homepage
http://www.weirdoz.net/voctrainer/ 
und Vokabel lernen.

mlg Dein VocTrainer

--
to unsubscribe, do at least one lession a day :-)

|;

		my $bulk = Mail::Bulkmail->new(
			From => 'voctrainer@weirdoz.net',
			Smtp	=> 'localhost',
			Subject	=> '[voctrainer] Reminder',
			Message	=> $mail,
			LIST	=> \@sendto,
			HTML	=> 0
		);

		$bulk->bulkmail;
	}
}

DB_close(DBH => $dbh);

