-- MySQL dump 8.21
--
-- Host: localhost    Database: voctrainer
---------------------------------------------------------
-- Server version	3.23.49a-log

--
-- Table structure for table 'Articles'
--

DROP TABLE IF EXISTS Articles;
CREATE TABLE Articles (
  code varchar(4) NOT NULL default '',
  langcode char(2) NOT NULL default '',
  article varchar(16) NOT NULL default '',
  PRIMARY KEY  (code,langcode)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Articles DISABLE KEYS */;

--
-- Dumping data for table 'Articles'
--


LOCK TABLES Articles WRITE;
INSERT INTO Articles VALUES ('fd','de','die'),('fi','de','eine'),('md','de','der'),('mi','de','einer'),('nd','de','das'),('ni','de','ein'),('fd','es','la'),('fi','es','una'),('md','es','el'),('mi','es','un'),('nd','es','lo');

/*!40000 ALTER TABLE Articles ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Conjugationcodes'
--

DROP TABLE IF EXISTS Conjugationcodes;
CREATE TABLE Conjugationcodes (
  code varchar(4) NOT NULL default '',
  description varchar(64) NOT NULL default '',
  PRIMARY KEY  (code)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Conjugationcodes DISABLE KEYS */;

--
-- Dumping data for table 'Conjugationcodes'
--


LOCK TABLES Conjugationcodes WRITE;
INSERT INTO Conjugationcodes VALUES ('p1','1. Pers. plu.'),('p2','2. Pers. plu.'),('p3f','3. Pers. plu. fem.'),('p3m','3. Pers. plu. mask.'),('p3n','3. Pers. plu. neut.'),('s1','1. Pers. sing.'),('s2','2. Pers. sing.'),('s3f','3. Pers. sing. fem.'),('s3m','3. Pers. sing. mask.'),('s3n','3. Pers. sing. neut.');

/*!40000 ALTER TABLE Conjugationcodes ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Conjugations'
--

DROP TABLE IF EXISTS Conjugations;
CREATE TABLE Conjugations (
  entryid int(11) NOT NULL default '0',
  langcode char(2) NOT NULL default '',
  conjugationcode varchar(4) NOT NULL default '',
  conjugation varchar(64) NOT NULL default '',
  PRIMARY KEY  (entryid,langcode,conjugationcode)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Conjugations DISABLE KEYS */;

--
-- Dumping data for table 'Conjugations'
--


LOCK TABLES Conjugations WRITE;
INSERT INTO Conjugations VALUES (404,'es','s1','caigo'),(404,'es','p3f','caen'),(404,'es','s2','caes'),(404,'es','s3f','cae'),(404,'es','p1','caemos'),(404,'es','p2','caéis'),(409,'es','s1','pregunto'),(409,'es','p3f','preguntan'),(409,'es','s2','preguntas'),(409,'es','s3f','pregunta'),(409,'es','p1','preguntamos'),(409,'es','p2','preguntáis'),(419,'es','s1','doy'),(419,'es','p3f','dan'),(419,'es','s2','das'),(419,'es','s3f','da'),(419,'es','p1','damos'),(419,'es','p2','dáis'),(445,'es','s1','traigo'),(445,'es','p3f','traen'),(445,'es','s2','traes'),(445,'es','s3f','trae'),(445,'es','p1','traemos'),(445,'es','p2','traéis'),(693,'es','p2','pronunciais'),(693,'es','p1','pronunciamos'),(553,'es','s1','soy'),(553,'es','s3f','es'),(553,'es','p3f','son'),(554,'es','s1','estoy'),(554,'es','p3f','están'),(554,'es','s2','estás'),(554,'es','s3f','está'),(554,'es','p1','estamos'),(554,'es','p2','estáis'),(560,'es','s1','me acuerdo'),(560,'es','p3f','se acuerdan'),(560,'es','s2','te acuerdas'),(560,'es','s3f','se acuerda'),(560,'es','p1','nos acordamos'),(560,'es','p2','os acordáis'),(573,'es','s1','hablo'),(573,'es','p3f','hablan'),(573,'es','s2','hablas'),(573,'es','s3f','habla'),(573,'es','p1','hablamos'),(573,'es','p2','habláis'),(576,'es','s1','pongo'),(576,'es','p3f','ponen'),(576,'es','s2','pones'),(576,'es','s3f','pone'),(576,'es','p1','ponemos'),(576,'es','p2','ponéis'),(610,'es','s1','comprendo'),(610,'es','p3f','comprenden'),(610,'es','s2','comprendes'),(610,'es','s3f','comprende'),(610,'es','p1','comprendemos'),(610,'es','p2','comprendéis'),(660,'es','s1','abro'),(660,'es','p3f','abren'),(660,'es','s2','abres'),(660,'es','s3f','abre'),(660,'es','p1','abrimos'),(660,'es','p2','abrís'),(663,'es','s1','traduzco'),(663,'es','p3f','traducen'),(663,'es','s2','traduces'),(663,'es','s3f','traduce'),(663,'es','p1','traducimos'),(663,'es','p2','traducís'),(553,'es','p1','somos'),(553,'es','s2','eres'),(553,'es','p2','sois'),(443,'es','s1','me llamo'),(443,'es','s3m','el llama'),(443,'es','p3f','llaman'),(443,'es','s3f','ella llama'),(443,'es','s2','te llamas'),(443,'es','p1','llamamos'),(443,'es','p2','llamais'),(693,'es','s1','pronuncio'),(693,'es','p3f','pronuncian'),(693,'es','s3f','pronuncia'),(693,'es','s2','pronuncias'),(539,'es','s1','digo'),(539,'es','p3f','dicen'),(539,'es','s3f','dice'),(539,'es','s2','dices'),(539,'es','p1','decimos'),(539,'es','p2','decis');

/*!40000 ALTER TABLE Conjugations ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Entries'
--

DROP TABLE IF EXISTS Entries;
CREATE TABLE Entries (
  id int(11) NOT NULL default '0',
  langcode char(2) NOT NULL default '',
  word varchar(64) NOT NULL default '',
  article varchar(8) NOT NULL default '',
  typeid int(11) NOT NULL default '1',
  remark varchar(255) default NULL,
  pronunciation varchar(255) default NULL,
  antonyms varchar(255) default NULL,
  synonyms varchar(255) default NULL,
  example varchar(255) default NULL,
  paraphrase varchar(255) default NULL,
  entryusage varchar(255) default NULL,
  createdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id,langcode),
  KEY word_idx (word)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Entries DISABLE KEYS */;

--
-- Dumping data for table 'Entries'
--


LOCK TABLES Entries WRITE;
INSERT INTO Entries VALUES (1,'de','aber','',0,'','','','','','','','2002-11-29 15:40:17'),(1,'es','pero','',0,'','','','','','','','2002-11-29 15:40:17'),(2,'de','abfahren','',0,'','','','','','','','2002-11-29 15:40:17'),(2,'es','salir','',0,'','','','','','','','2002-11-29 15:40:17'),(3,'de','abholen','',0,'','','','','','','','2002-11-29 15:40:17'),(3,'es','recoger','',0,'','','','','','','','2002-11-29 15:40:17'),(4,'de','abschicken','',0,'','','','','','','','2002-11-29 15:40:17'),(4,'es','enviar','',0,'','','','','','','','2002-11-29 15:40:17'),(5,'de','aktuell','',0,'','','','','','','','2002-11-29 15:40:17'),(5,'es','actual','',0,'','','','','','','','2002-11-29 15:40:17'),(6,'de','alles','',0,'','','','','','','','2002-11-29 15:40:17'),(6,'es','todo','',0,'','','','','','','','2002-11-29 15:40:17'),(7,'de','also','',0,'','','','','','','','2002-11-29 15:40:17'),(7,'es','así que','',0,'','','','','','','','2002-11-29 15:40:17'),(8,'de','also','',0,'','','','','','','','2002-11-29 15:40:17'),(8,'es','entonces','',0,'','','','','','','','2002-11-29 15:40:17'),(9,'de','am darauffolgenden Tag','',0,'','','','','','','','2002-11-29 15:40:17'),(9,'es','al día siguinte','',0,'','','','','','','','2002-11-29 15:40:17'),(10,'de','amtlich','',0,'','','','','','','','2002-11-29 15:40:17'),(10,'es','oficial','',0,'','','','','','','','2002-11-29 15:40:17'),(11,'de','anders','',0,'','','','','','','','2002-11-29 15:40:17'),(11,'es','distinto','',0,'','','','','','','','2002-11-29 15:40:17'),(12,'de','anfangen','',0,'','','','','','','','2002-11-29 15:40:17'),(12,'es','empezar','',0,'','','','','','','','2002-11-29 15:40:17'),(13,'de','angenehm','',0,'','','','','','','','2002-11-29 15:40:17'),(13,'es','me alegro','',0,'','','','','','','','2002-11-29 15:40:17'),(14,'de','anhalten','',0,'','','','stoppen','','','','2002-11-29 15:40:17'),(14,'es','parar','',0,'','','','','','','','2002-11-29 15:40:17'),(15,'de','ankommen','',0,'','','','','','','','2002-11-29 15:40:17'),(15,'es','llegar','',0,'','','','','','','','2002-11-29 15:40:17'),(16,'de','anscheinend','',0,'','','','','','','','2002-11-29 15:40:17'),(16,'es','al parecer','',0,'','','','','','','','2002-11-29 15:40:17'),(17,'de','anscheinend','',0,'','','','','','','','2002-11-29 15:40:17'),(17,'es','parece que','',0,'','','','','','','','2002-11-29 15:40:17'),(18,'de','anstatt','',0,'','','','','','','','2002-11-29 15:40:17'),(18,'es','en lugar de','',0,'','','','','','','','2002-11-29 15:40:17'),(19,'de','antik','',0,'','','','','','','','2002-11-29 15:40:17'),(19,'es','antiguo','',0,'','','','','','','','2002-11-29 15:40:17'),(20,'de','arabisch','',0,'','','','','','','','2002-11-29 15:40:17'),(20,'es','árabe','',0,'','','','','','','','2002-11-29 15:40:17'),(21,'de','arbeiten','',0,'','','','','','','','2002-11-29 15:40:17'),(21,'es','trabajar','',0,'','','','','','','','2002-11-29 15:40:17'),(22,'de','atlantisch','',0,'','','','','','','','2002-11-29 15:40:17'),(22,'es','atlántico','',0,'','','','','','','','2002-11-29 15:40:17'),(23,'de','auch','',0,'','','','','','','','2002-11-29 15:40:17'),(23,'es','también','',0,'','','','','','','','2002-11-29 15:40:17'),(24,'de','auch nicht','',0,'','','','','','','','2002-11-29 15:40:17'),(24,'es','tampoco','',0,'','','','','','','','2002-11-29 15:40:17'),(25,'de','auf Wiedersehen','',0,'','','','','','','','2002-11-29 15:40:17'),(25,'es','adiós','',0,'','','','','','','','2002-11-29 15:40:17'),(26,'de','ausführen','',0,'','','','','','','','2002-11-29 15:40:17'),(26,'es','realizar','',0,'','','','','','','','2002-11-29 15:40:17'),(27,'de','ausfüllen','',0,'','','','','','','','2002-11-29 15:40:17'),(27,'es','rellenar','',0,'','','','','','','','2002-11-29 15:40:17'),(28,'de','ausgezeichnet','',0,'','','','','','','','2002-11-29 15:40:17'),(28,'es','excelente','',0,'','','','','','','','2002-11-29 15:40:17'),(29,'de','außer','',0,'','','','','','','','2002-11-29 15:40:17'),(29,'es','aparte de','',0,'','','','','','','','2002-11-29 15:40:17'),(30,'de','außerdem','',0,'','','','','','','','2002-11-29 15:40:17'),(30,'es','además','',0,'','','','','','','','2002-11-29 15:40:17'),(31,'de','außergewöhnlich','',0,'','','','','','','','2002-11-29 15:40:17'),(31,'es','extraordinario','',0,'','','','','','','','2002-11-29 15:40:17'),(32,'de','baden','',0,'','','','','','','','2002-11-29 15:40:17'),(32,'es','bañarse','',0,'','','','','','','','2002-11-29 15:40:17'),(33,'de','bauen','',0,'','','','konstruieren','','','','2002-11-29 15:40:17'),(33,'es','construir','',0,'','','','','','','','2002-11-29 15:40:17'),(34,'de','bedeuten','',0,'','','','','','','','2002-11-29 15:40:17'),(34,'es','significar','',0,'','','','','¿Qué significa ... ?','','','2002-11-29 15:40:17'),(35,'de','beeindrucken','',0,'','','','','','','','2002-11-29 15:40:17'),(35,'es','impresionar','',0,'','','','','','','','2002-11-29 15:40:17'),(36,'de','begrenzt','',0,'','','','','','','','2002-11-29 15:40:17'),(36,'es','limitado','',0,'','','','','','','','2002-11-29 15:40:17'),(37,'de','bei vielen Leuten','',0,'','','','','','','','2002-11-29 15:40:17'),(37,'es','en mucha gente','',0,'','','','','','','','2002-11-29 15:40:17'),(38,'de','beim Einkaufen','',0,'','','','','','','','2002-11-29 15:40:17'),(38,'es','de compras','',0,'','','','','','','','2002-11-29 15:40:17'),(39,'de','bekannt','',0,'','','','','','','','2002-11-29 15:40:17'),(39,'es','conocido','',0,'','','','','','','','2002-11-29 15:40:17'),(40,'de','benutzen','',0,'','','','','','','','2002-11-29 15:40:17'),(40,'es','usar','',0,'','','','','','','','2002-11-29 15:40:17'),(41,'de','bequem','',0,'','','','','','','','2002-11-29 15:40:17'),(41,'es','cómodo','',0,'','','','','','','','2002-11-29 15:40:17'),(42,'de','besonders','',0,'','','','','','','','2002-11-29 15:40:17'),(42,'es','especialmente','',0,'','','','','','','','2002-11-29 15:40:17'),(43,'de','besser','',0,'','','','','','','','2002-11-29 15:40:17'),(43,'es','mejor','',0,'','','','','','','','2002-11-29 15:40:17'),(44,'de','besser gesagt','',0,'','','','','','','','2002-11-29 15:40:17'),(44,'es','mejor dicho','',0,'','','','','','','','2002-11-29 15:40:17'),(45,'de','bestimmt','',0,'','','','','','','','2002-11-29 15:40:17'),(45,'es','determinado','',0,'','','','','','','','2002-11-29 15:40:17'),(46,'de','besuchen','',0,'','','','','','','','2002-11-29 15:40:17'),(46,'es','visitar','',0,'','','','','','','','2002-11-29 15:40:17'),(47,'de','beträchtlich','',0,'','','','','','','','2002-11-29 15:40:17'),(47,'es','considerable','',0,'','','','','','','','2002-11-29 15:40:17'),(48,'de','bewußt','',0,'','','','','','','','2002-11-29 15:40:17'),(48,'es','consciente','',0,'','','','','','','','2002-11-29 15:40:17'),(49,'de','billig','',0,'','','','','','','','2002-11-29 15:40:17'),(49,'es','barato','',0,'','','','','','','','2002-11-29 15:40:17'),(50,'de','bis zum nächsten Mal','',0,'','','','','','','','2002-11-29 15:40:17'),(50,'es','hasta la próxima vez','',0,'','','','','','','','2002-11-29 15:40:17'),(51,'de','bitte','',0,'','','','','','','','2002-11-29 15:40:17'),(51,'es','por favor','',0,'','','','','','','','2002-11-29 15:40:17'),(52,'de','bitten','',0,'','','','','','','','2002-11-29 15:40:17'),(52,'es','pedir','',0,'','','','','','','','2002-11-29 15:40:17'),(53,'de','bleiben','',0,'','','','','','','','2002-11-29 15:40:17'),(53,'es','quedarse','',0,'','','','','','','','2002-11-29 15:40:17'),(54,'de','bleifrei','',0,'','','','','','','','2002-11-29 15:40:17'),(54,'es','sin plomo','',0,'','','','','','','','2002-11-29 15:40:17'),(55,'de','brauchen','',0,'','','','','','','','2002-11-29 15:40:17'),(55,'es','necesitar','',0,'','','','','','','','2002-11-29 15:40:17'),(56,'de','danke','',0,'','','','','','','','2002-11-29 15:40:17'),(56,'es','gracias','',0,'','','','','','','','2002-11-29 15:40:17'),(57,'de','danach','',0,'','','','nach; dann','','','','2002-11-29 15:40:17'),(57,'es','después','',0,'','','','luego','','','','2002-11-29 15:40:17'),(58,'de','darin','',0,'','','','','','','','2002-11-29 15:40:17'),(58,'es','dentro','',0,'','','','','','','','2002-11-29 15:40:17'),(59,'de','Angebot','das',0,'','','','','','','','2002-11-29 15:40:17'),(59,'es','oferta','la',0,'','','','','','','','2002-11-29 15:40:17'),(60,'de','Automobil','das',0,'','','','','','','','2002-11-29 15:40:17'),(60,'es','automóvil','el',0,'','','','','','','','2002-11-29 15:40:17'),(61,'de','Bad','das',0,'','','','','','','','2002-11-29 15:40:17'),(61,'es','baño','el',0,'','','','','','','','2002-11-29 15:40:17'),(62,'de','Bankkonto','das',0,'','','','','','','','2002-11-29 15:40:17'),(62,'es','cuenta bancaria','la',0,'','','','','','','','2002-11-29 15:40:17'),(63,'de','Beförderungsmittel','das',0,'','','','','','','','2002-11-29 15:40:17'),(63,'es','medio de locomoción','el',0,'','','','','','','','2002-11-29 15:40:17'),(64,'de','Benzin','das',0,'','','','','','','','2002-11-29 15:40:17'),(64,'es','gasolina','la',0,'','','','','','','','2002-11-29 15:40:17'),(65,'de','Bett','das',0,'','','','','','','','2002-11-29 15:40:17'),(65,'es','cama','la',0,'','','','','','','','2002-11-29 15:40:17'),(66,'de','Buch','das',0,'','','','','','','','2002-11-29 15:40:17'),(66,'es','libro','el',0,'','','','','','','','2002-11-29 15:40:17'),(67,'de','Darlehen','das',0,'','','','','','','','2002-11-29 15:40:17'),(67,'es','préstamo','el',0,'','','','','','','','2002-11-29 15:40:17'),(68,'de','Doppelzimmer','das',0,'','','','','','','','2002-11-29 15:40:17'),(68,'es','habitación doble','la',0,'','','','','','','','2002-11-29 15:40:17'),(69,'de','Ehepaar','das',0,'','','','','','','','2002-11-29 15:40:17'),(69,'es','matrimonio','el',0,'','','','','','','','2002-11-29 15:40:17'),(70,'de','Einzelzimmer','das',0,'','','','','','','','2002-11-29 15:40:17'),(70,'es','habitación individual','la',0,'','','','','','','','2002-11-29 15:40:17'),(71,'de','Fleisch','das',0,'','','','','','','','2002-11-29 15:40:17'),(71,'es','carne','la',0,'','','','','','','','2002-11-29 15:40:17'),(72,'de','Formular','das',0,'','','','','','','','2002-11-29 15:40:17'),(72,'es','formulario','el',0,'','','','','','','','2002-11-29 15:40:17'),(73,'de','Frühstück','das',0,'','','','','','','','2002-11-29 15:40:17'),(73,'es','desayuno','el',0,'','','','','','','','2002-11-29 15:40:17'),(74,'de','Gebirge','das',0,'','','','der Berg','','','','2002-11-29 15:40:17'),(74,'es','montaña','la',0,'','','','','','','','2002-11-29 15:40:17'),(75,'de','Gebäude','das',0,'','','','','','','','2002-11-29 15:40:17'),(75,'es','edificio','el',0,'','','','','','','','2002-11-29 15:40:17'),(76,'de','Geld','das',0,'','','','','','','','2002-11-29 15:40:17'),(76,'es','dinero','el',0,'','','','','','','','2002-11-29 15:40:17'),(77,'de','Gepäck','das',0,'','','','','','','','2002-11-29 15:40:17'),(77,'es','equipaje','el',0,'','','','','','','','2002-11-29 15:40:17'),(78,'de','Glas','das',0,'','','','','','','','2002-11-29 15:40:17'),(78,'es','copa','la',0,'','','','','','','','2002-11-29 15:40:17'),(79,'de','Haus','das',0,'','','','','','','','2002-11-29 15:40:17'),(79,'es','casa','la',0,'','','','','','','','2002-11-29 15:40:17'),(80,'de','heißt','das',0,'','','','','','','','2002-11-29 15:40:17'),(80,'es','o sea','',0,'','','','','','','','2002-11-29 15:40:17'),(81,'de','Hotel','das',0,'','','','','','','','2002-11-29 15:40:17'),(81,'es','hotel','el',0,'','','','','','','','2002-11-29 15:40:17'),(82,'de','Ideal','das',0,'','','','','','','','2002-11-29 15:40:17'),(82,'es','ideal','el',0,'','','','','','','','2002-11-29 15:40:17'),(83,'de','Innere','das',0,'','','','','','','','2002-11-29 15:40:17'),(83,'es','interior','el',0,'','','','','','','','2002-11-29 15:40:17'),(84,'de','Instrument','das',0,'','','','','','','','2002-11-29 15:40:17'),(84,'es','instrumento','el',0,'','','','','','','','2002-11-29 15:40:17'),(85,'de','Jahr','das',0,'','','','','','','','2002-11-29 15:40:17'),(85,'es','año','el',0,'','','','','','','','2002-11-29 15:40:17'),(86,'de','jetzige','das',0,'','','','','','','','2002-11-29 15:40:17'),(86,'es','esto de ahora','',0,'','','','','','','','2002-11-29 15:40:17'),(87,'de','Kastilische','das',0,'','','','','','','','2002-11-29 15:40:17'),(87,'es','castellano','el',0,'','','','','','','','2002-11-29 15:40:17'),(88,'de','Kind','das',0,'','','','','','','','2002-11-29 15:40:17'),(88,'es','niño','el',0,'','','','','','','','2002-11-29 15:40:17'),(89,'de','Klima','das',0,'','','','','','','','2002-11-29 15:40:17'),(89,'es','clima','el',0,'','','','','','','','2002-11-29 15:40:17'),(90,'de','Kompliment','das',0,'','','','','','','','2002-11-29 15:40:17'),(90,'es','piropo','el',0,'','','','','','','','2002-11-29 15:40:17'),(91,'de','Kunstwerk','das',0,'','','','','','','','2002-11-29 15:40:17'),(91,'es','obra de arte','la',0,'','','','','','','','2002-11-29 15:40:17'),(92,'de','Land','das',0,'','','','','','','','2002-11-29 15:40:17'),(92,'es','país','el',0,'','','','','','','','2002-11-29 15:40:17'),(93,'de','Licht','das',0,'','','','','','','','2002-11-29 15:40:17'),(93,'es','luz','la',0,'','','','','','','','2002-11-29 15:40:17'),(94,'de','Mineralwasser','das',0,'','','','','','','','2002-11-29 15:40:17'),(94,'es','agua mineral','la',0,'','','','','','','','2002-11-29 15:40:17'),(95,'de','Mittagessen','das',0,'','','','','','','','2002-11-29 15:40:17'),(95,'es','comida','la',0,'','','','','','','','2002-11-29 15:40:17'),(96,'de','Obst','das',0,'','','','','','','','2002-11-29 15:40:17'),(96,'es','fruta','la',0,'','','','','','','','2002-11-29 15:40:17'),(97,'de','Paar','das',0,'','','','','','','','2002-11-29 15:40:17'),(97,'es','par','el',0,'','','','','','','','2002-11-29 15:40:17'),(98,'de','Papier','das',0,'','','','','','','','2002-11-29 15:40:17'),(98,'es','papel','el',0,'','','','','','','','2002-11-29 15:40:17'),(99,'de','Parken','das',0,'','','','Parkplatz','','','','2002-11-29 15:40:17'),(99,'es','aparcamiento','el',0,'','','','','','','','2002-11-29 15:40:17'),(100,'de','Problem','das',0,'','','','','','','','2002-11-29 15:40:17'),(100,'es','problema','el',0,'','','','','','','','2002-11-29 15:40:17'),(101,'de','Programm','das',0,'','','','','','','','2002-11-29 15:40:17'),(101,'es','programa','el',0,'','','','','','','','2002-11-29 15:40:17'),(102,'de','Restaurant','das',0,'','','','','','','','2002-11-29 15:40:17'),(102,'es','restaurante','el',0,'','','','','','','','2002-11-29 15:40:17'),(103,'de','Sonderangebot','das',0,'','','','','','','','2002-11-29 15:40:17'),(103,'es','oferta especial','la',0,'','','','','','','','2002-11-29 15:40:17'),(104,'de','Spanische','das',0,'','','','Spanisch','','','','2002-11-29 15:40:17'),(104,'es','español','el',0,'','','','','','','','2002-11-29 15:40:17'),(105,'de','Speiseeis','das',0,'','','','','','','','2002-11-29 15:40:17'),(105,'es','helado','el',0,'','','','','','','','2002-11-29 15:40:17'),(106,'de','Symbol','das',0,'','','','','','','','2002-11-29 15:40:17'),(106,'es','símbolo','el',0,'','','','','','','','2002-11-29 15:40:17'),(107,'de','Taxi','das',0,'','','','','','','','2002-11-29 15:40:17'),(107,'es','taxi','el',0,'','','','','','','','2002-11-29 15:40:17'),(108,'de','Telefon','das',0,'','','','','','','','2002-11-29 15:40:17'),(108,'es','teléfono','el',0,'','','','','','','','2002-11-29 15:40:17'),(109,'de','Telegramm','das',0,'','','','','','','','2002-11-29 15:40:17'),(109,'es','telegrama','el',0,'','','','','','','','2002-11-29 15:40:17'),(110,'de','Thema','das',0,'','','','','','','','2002-11-29 15:40:17'),(110,'es','tema','el',0,'','','','','','','','2002-11-29 15:40:17'),(111,'de','Tier','das',0,'','','','','','','','2002-11-29 15:40:17'),(111,'es','animal','el',0,'','','','','','','','2002-11-29 15:40:17'),(112,'de','Trinkgeld','das',0,'','','','','','','','2002-11-29 15:40:17'),(112,'es','propina','la',0,'','','','','','','','2002-11-29 15:40:17'),(113,'de','Trinkglas','das',0,'','','','das Glas','','','','2002-11-29 15:40:17'),(113,'es','vaso','el',0,'','','','','','','','2002-11-29 15:40:17'),(114,'de','Viertel','das',0,'','','','','','','','2002-11-29 15:40:17'),(114,'es','cuarto','el',0,'','','','','','','','2002-11-29 15:40:17'),(115,'de','Volk','das',0,'','','','','','','','2002-11-29 15:40:17'),(115,'es','pueblo','el',0,'','','','','','','','2002-11-29 15:40:17'),(116,'de','Wasser','das',0,'','','','','','','','2002-11-29 15:40:17'),(116,'es','agua','la',0,'','','','','','','','2002-11-29 15:40:17'),(117,'de','Wetter','das',0,'','','','','','','','2002-11-29 15:40:17'),(117,'es','tiempo','el',0,'','','','','','','','2002-11-29 15:40:17'),(118,'de','Wochenende','das',0,'','','','','','','','2002-11-29 15:40:17'),(118,'es','fin de semana','el',0,'','','','','','','','2002-11-29 15:40:17'),(119,'de','Wort','das',0,'','','','','','','','2002-11-29 15:40:17'),(119,'es','palabra','la',0,'','','','','','','','2002-11-29 15:40:17'),(120,'de','Wunder','das',0,'','','','','','','','2002-11-29 15:40:17'),(120,'es','maravilla','la',0,'','','','','','','','2002-11-29 15:40:17'),(121,'de','Zentrum','das',0,'','','','','','','','2002-11-29 15:40:17'),(121,'es','centro','el',0,'','','','','','','','2002-11-29 15:40:17'),(122,'de','Zimmer','das',0,'','','','','','','','2002-11-29 15:40:17'),(122,'es','habitación','la',0,'','','','','','','','2002-11-29 15:40:17'),(123,'de','öffentliche Transportmittel','das',0,'','','','','','','','2002-11-29 15:40:17'),(123,'es','medio de transporte público','el',0,'','','','','','','','2002-11-29 15:40:17'),(124,'de','Öl','das',0,'','','','','','','','2002-11-29 15:40:17'),(124,'es','aceite','el',0,'','','','','','','','2002-11-29 15:40:17'),(125,'de','dein','',0,'','','','','','','','2002-11-29 15:40:17'),(125,'es','tuyo','',0,'','','','','','','','2002-11-29 15:40:17'),(126,'de','denken','',0,'','','','','','','','2002-11-29 15:40:17'),(126,'es','pensar','',0,'','','','','','','','2002-11-29 15:40:17'),(127,'de','Abflug','der',0,'','','','','','','','2002-11-29 15:40:17'),(127,'es','salida del avión','la',0,'','','','','','','','2002-11-29 15:40:17'),(128,'de','Anfang','der',0,'','','','','','','','2002-11-29 15:40:17'),(128,'es','principio','el',0,'','','','','','','','2002-11-29 15:40:17'),(129,'de','Angestellte','der',0,'','','','','','','','2002-11-29 15:40:17'),(129,'es','empleado','el',0,'','','','','','','','2002-11-29 15:40:17'),(130,'de','Anreiz','der',0,'','','','','','','','2002-11-29 15:40:17'),(130,'es','estímulo','el',0,'','','','','','','','2002-11-29 15:40:17'),(131,'de','Aperitif','der',0,'','','','','','','','2002-11-29 15:40:17'),(131,'es','aperitivo','el',0,'','','','','','','','2002-11-29 15:40:17'),(132,'de','Araber','der',0,'','','','','','','','2002-11-29 15:40:17'),(132,'es','árabe','el',0,'','','','','','','','2002-11-29 15:40:17'),(133,'de','Artikel','der',0,'','','','','','','','2002-11-29 15:40:17'),(133,'es','articulo','el',0,'','','','','','','','2002-11-29 15:40:17'),(134,'de','Ausdruck','der',0,'','','','','','','','2002-11-29 15:40:17'),(134,'es','expresión','la',0,'','','','','','','','2002-11-29 15:40:17'),(135,'de','Ausflug','der',0,'','','','','','','','2002-11-29 15:40:17'),(135,'es','excursión','la',0,'','','','','','','','2002-11-29 15:40:17'),(136,'de','Ausländer','der',0,'','','','','','','','2002-11-29 15:40:17'),(136,'es','extranjero','el',0,'','','','','','','','2002-11-29 15:40:17'),(137,'de','Autobus','der',0,'','','','','','','','2002-11-29 15:40:17'),(137,'es','autobús','el',0,'','','','','','','','2002-11-29 15:40:17'),(138,'de','Bahnhof','der',0,'','','','','','','','2002-11-29 15:40:17'),(138,'es','estación','la',0,'','','','','','','','2002-11-29 15:40:17'),(139,'de','Beauftragte','der',0,'','','','','','','','2002-11-29 15:40:17'),(139,'es','encargado','el',0,'','','','','','','','2002-11-29 15:40:17'),(140,'de','Bekannte','der',0,'','','','','','','','2002-11-29 15:40:17'),(140,'es','conocido','el',0,'','','','','','','','2002-11-29 15:40:17'),(141,'de','Brief','der',0,'','','','die Speisekarte','','','','2002-11-29 15:40:17'),(141,'es','carta','la',0,'','','','','','','','2002-11-29 15:40:17'),(142,'de','Briefkasten','der',0,'','','','','','','','2002-11-29 15:40:17'),(142,'es','buzón','el',0,'','','','','','','','2002-11-29 15:40:17'),(143,'de','Bungalow','der',0,'','','','','','','','2002-11-29 15:40:17'),(143,'es','chalet','el',0,'','','','','','','','2002-11-29 15:40:17'),(144,'de','Effekt','der',0,'','','','','','','','2002-11-29 15:40:17'),(144,'es','efecto','el',0,'','','','','','','','2002-11-29 15:40:17'),(145,'de','Ehemann','der',0,'','','','','','','','2002-11-29 15:40:17'),(145,'es','marido','el',0,'','','','','','','','2002-11-29 15:40:17'),(146,'de','Eigenname','der',0,'','','','','','','','2002-11-29 15:40:17'),(146,'es','nombre propio','el',0,'','','','','','','','2002-11-29 15:40:17'),(147,'de','Einkauf','der',0,'','','','','','','','2002-11-29 15:40:17'),(147,'es','compra','la',0,'','','','','','','','2002-11-29 15:40:17'),(148,'de','Einwohner','der',0,'','','','','','','','2002-11-29 15:40:17'),(148,'es','habitante','el',0,'','','','','','','','2002-11-29 15:40:17'),(149,'de','Empfangsangestellte','der',0,'','','','','','','','2002-11-29 15:40:17'),(149,'es','recepcionista','el',0,'','','','','','','','2002-11-29 15:40:17'),(150,'de','Erwachsene','der',0,'','','','','','','','2002-11-29 15:40:17'),(150,'es','mayor','el',0,'','','','','','','','2002-11-29 15:40:17'),(151,'de','Familienname','der',0,'','','','','','','','2002-11-29 15:40:17'),(151,'es','apellido','el',0,'','','','','','','','2002-11-29 15:40:17'),(152,'de','Fehler','der',0,'','','','','','','','2002-11-29 15:40:17'),(152,'es','falta','la',0,'','','','','','','','2002-11-29 15:40:17'),(153,'de','Festpreis','der',0,'','','','','','','','2002-11-29 15:40:17'),(153,'es','precio fijo','el',0,'','','','','','','','2002-11-29 15:40:17'),(154,'de','Fisch','der',0,'','','','','','','','2002-11-29 15:40:17'),(154,'es','pescado','el',0,'','','','','','','','2002-11-29 15:40:17'),(155,'de','Flug','der',0,'','','','','','','','2002-11-29 15:40:17'),(155,'es','vuelo','el',0,'','','','','','','','2002-11-29 15:40:17'),(156,'de','Flughafen','der',0,'','','','','','','','2002-11-29 15:40:17'),(156,'es','aeropuerto','el',0,'','','','','','','','2002-11-29 15:40:17'),(157,'de','Fluss','der',0,'','','','','','','','2002-11-29 15:40:17'),(157,'es','río','el',0,'','','','','','','','2002-11-29 15:40:17'),(158,'de','Freund','der',0,'','','','','','','','2002-11-29 15:40:17'),(158,'es','amigo','el',0,'fem: la amiga','','','','','','','2002-11-29 15:40:17'),(159,'de','Fußgänger','der',0,'','','','','','','','2002-11-29 15:40:17'),(159,'es','peatón','el',0,'','','','','','','','2002-11-29 15:40:17'),(160,'de','Herr','der',0,'','','','','','','','2002-11-29 15:40:17'),(160,'es','caballero','el',0,'','','','','','','','2002-11-29 15:40:17'),(161,'de','Kampf','der',0,'','','','','','','','2002-11-29 15:40:17'),(161,'es','lucha','la',0,'','','','','','','','2002-11-29 15:40:17'),(162,'de','Kellner','der',0,'','','','','','','','2002-11-29 15:40:17'),(162,'es','camarero','el',0,'','','','','','','','2002-11-29 15:40:17'),(163,'de','Kognak','der',0,'','','','','','','','2002-11-29 15:40:17'),(163,'es','coñac','el',0,'','','','','','','','2002-11-29 15:40:17'),(164,'de','Kontakt','der',0,'','','','','','','','2002-11-29 15:40:17'),(164,'es','contacto','el',0,'','','','','','','','2002-11-29 15:40:17'),(165,'de','Kopf','der',0,'','','','','','','','2002-11-29 15:40:17'),(165,'es','cabeza','la',0,'','','','','','','','2002-11-29 15:40:17'),(166,'de','Kopfschmerz','der',0,'','','','','','','','2002-11-29 15:40:17'),(166,'es','dolor de cabeza','el',0,'','','','','','','','2002-11-29 15:40:17'),(167,'de','Kredit','der',0,'','','','','','','','2002-11-29 15:40:17'),(167,'es','crédito','el',0,'','','','','','','','2002-11-29 15:40:17'),(168,'de','Kunde','der',0,'','','','','','','','2002-11-29 15:40:17'),(168,'es','cliente','el',0,'','','','','','','','2002-11-29 15:40:17'),(169,'de','König','der',0,'','','','','','','','2002-11-29 15:40:17'),(169,'es','rey','el',0,'fem: la reina','','','','','','','2002-11-29 15:40:17'),(170,'de','Lehrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(170,'es','maestro','el',0,'','','','','','','','2002-11-29 15:40:17'),(171,'de','Lehrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(171,'es','profesor','el',0,'','','','','','','','2002-11-29 15:40:17'),(172,'de','Liegewagenplatz','der',0,'','','','','','','','2002-11-29 15:40:17'),(172,'es','litera','la',0,'','','','','','','','2002-11-29 15:40:17'),(173,'de','Liter','der',0,'','','','','','','','2002-11-29 15:40:17'),(173,'es','litro','el',0,'','','','','','','','2002-11-29 15:40:17'),(174,'de','Lärm','der',0,'','','','','','','','2002-11-29 15:40:17'),(174,'es','ruido','el',0,'','','','','','','','2002-11-29 15:40:17'),(175,'de','Monat','der',0,'','','','','','','','2002-11-29 15:40:17'),(175,'es','mes','el',0,'','','','','','','','2002-11-29 15:40:17'),(176,'de','Musiklehrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(176,'es','profesor de música','el',0,'','','','','','','','2002-11-29 15:40:17'),(177,'de','Nachmittag','der',0,'','','','der Abend','','','','2002-11-29 15:40:17'),(177,'es','tarde','la',0,'','','','','','','','2002-11-29 15:40:17'),(178,'de','Name','der',0,'','','','','','','','2002-11-29 15:40:17'),(178,'es','nombre','el',0,'','','','','','','','2002-11-29 15:40:17'),(179,'de','Norden','der',0,'','','','','','','','2002-11-29 15:40:17'),(179,'es','norte','el',0,'','','','','','','','2002-11-29 15:40:17'),(180,'de','Ort','der',0,'','','','','','','','2002-11-29 15:40:17'),(180,'es','lugar','el',0,'','','','','','','','2002-11-29 15:40:17'),(181,'de','Osten','der',0,'','','','','','','','2002-11-29 15:40:17'),(181,'es','oeste','el',0,'','','','','','','','2002-11-29 15:40:17'),(182,'de','Plan','der',0,'','','','','','','','2002-11-29 15:40:17'),(182,'es','plan','el',0,'','','','','','','','2002-11-29 15:40:17'),(183,'de','Preis','der',0,'','','','','','','','2002-11-29 15:40:17'),(183,'es','precio','el',0,'','','','','','','','2002-11-29 15:40:17'),(184,'de','Preisnachlass','der',0,'','','','','','','','2002-11-29 15:40:17'),(184,'es','descuento','el',0,'','','','','','','','2002-11-29 15:40:17'),(185,'de','Punkt','der',0,'','','','','','','','2002-11-29 15:40:17'),(185,'es','punto','el',0,'','','','','','','','2002-11-29 15:40:17'),(186,'de','Quadratkilometer','der',0,'','','','','','','','2002-11-29 15:40:17'),(186,'es','kilómetro cuadrado','el',0,'','','','','','','','2002-11-29 15:40:17'),(187,'de','Rabatt','der',0,'','','','','','','','2002-11-29 15:40:17'),(187,'es','rebaja','la',0,'','','','','','','','2002-11-29 15:40:17'),(188,'de','Raum','der',0,'','','','','','','','2002-11-29 15:40:17'),(188,'es','espacio','el',0,'','','','','','','','2002-11-29 15:40:17'),(189,'de','Regen','der',0,'','','','','','','','2002-11-29 15:40:17'),(189,'es','lluvia','la',0,'','','','','','','','2002-11-29 15:40:17'),(190,'de','Reisende','der',0,'','','','','','','','2002-11-29 15:40:17'),(190,'es','viajero','el',0,'','','','','','','','2002-11-29 15:40:17'),(191,'de','Reisescheck','der',0,'','','','','','','','2002-11-29 15:40:17'),(191,'es','cheque de viaje','el',0,'','','','','','','','2002-11-29 15:40:17'),(192,'de','Rotwein','der',0,'','','','','','','','2002-11-29 15:40:17'),(192,'es','vino tinto','el',0,'','','','','','','','2002-11-29 15:40:17'),(193,'de','Saft','der',0,'','','','','','','','2002-11-29 15:40:17'),(193,'es','zumo','el',0,'','','','','','','','2002-11-29 15:40:17'),(194,'de','Salat','der',0,'','','','','','','','2002-11-29 15:40:17'),(194,'es','ensalada','la',0,'','','','','','','','2002-11-29 15:40:17'),(195,'de','Satz','der',0,'','','','','','','','2002-11-29 15:40:17'),(195,'es','frase','la',0,'','','','','','','','2002-11-29 15:40:17'),(196,'de','Schalter','der',0,'','','','','','','','2002-11-29 15:40:17'),(196,'es','ventanilla','la',0,'','','','','','','','2002-11-29 15:40:17'),(197,'de','Schlüssel','der',0,'','','','','','','','2002-11-29 15:40:17'),(197,'es','llave','la',0,'','','','','','','','2002-11-29 15:40:17'),(198,'de','Schmerz','der',0,'','','','','','','','2002-11-29 15:40:17'),(198,'es','dolor','el',0,'','','','','','','','2002-11-29 15:40:17'),(199,'de','Schnee','der',0,'','','','','','','','2002-11-29 15:40:17'),(199,'es','nieve','la',0,'','','','','','','','2002-11-29 15:40:17'),(200,'de','Schuh','der',0,'','','','','','','','2002-11-29 15:40:17'),(200,'es','zapato','el',0,'','','','','','','','2002-11-29 15:40:17'),(201,'de','Schüler','der',0,'','','','Student','','','','2002-11-29 15:40:17'),(201,'es','estudiante','el',0,'','','','','','','','2002-11-29 15:40:17'),(202,'de','See','der',0,'','','','','','','','2002-11-29 15:40:17'),(202,'es','lago','el',0,'','','','','','','','2002-11-29 15:40:17'),(203,'de','Service','der',0,'','','','','','','','2002-11-29 15:40:17'),(203,'es','servicio','el',0,'','','','','','','','2002-11-29 15:40:17'),(204,'de','Sinn','der',0,'','','','','','','','2002-11-29 15:40:17'),(204,'es','sentido','el',0,'','','','','','','','2002-11-29 15:40:17'),(205,'de','Sitz','der',0,'','','','','','','','2002-11-29 15:40:17'),(205,'es','asiento','el',0,'','','','','','','','2002-11-29 15:40:17'),(206,'de','Ski','der',0,'','','','','','','','2002-11-29 15:40:17'),(206,'es','esquí','el',0,'','','','','','','','2002-11-29 15:40:17'),(207,'de','Sportlehrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(207,'es','profesor de deporte','el',0,'','','','','','','','2002-11-29 15:40:17'),(208,'de','Sprachenlehrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(208,'es','profesor de idiomas','el',0,'','','','','','','','2002-11-29 15:40:17'),(209,'de','Staat','der',0,'','','','','','','','2002-11-29 15:40:17'),(209,'es','estado','el',0,'','','','','','','','2002-11-29 15:40:17'),(210,'de','Stau','der',0,'','','','','','','','2002-11-29 15:40:17'),(210,'es','atasco','el',0,'','','','','','','','2002-11-29 15:40:17'),(211,'de','Stierkampf','der',0,'','','','','','','','2002-11-29 15:40:17'),(211,'es','corrida de toros','la',0,'','','','','','','','2002-11-29 15:40:17'),(212,'de','Süden','der',0,'','','','','','','','2002-11-29 15:40:17'),(212,'es','sur','el',0,'','','','','','','','2002-11-29 15:40:17'),(213,'de','Tagesablauf','der',0,'','','','','','','','2002-11-29 15:40:17'),(213,'es','horario','el',0,'','','','','','','','2002-11-29 15:40:17'),(214,'de','Taxifahrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(214,'es','taxista','el',0,'','','','','','','','2002-11-29 15:40:17'),(215,'de','Teil','der',0,'','','','','','','','2002-11-29 15:40:17'),(215,'es','parte','la',0,'','','','','','','','2002-11-29 15:40:17'),(216,'de','Tisch','der',0,'','','','','','','','2002-11-29 15:40:17'),(216,'es','mesa','la',0,'','','','','','','','2002-11-29 15:40:17'),(217,'de','Titel','der',0,'','','','','','','','2002-11-29 15:40:17'),(217,'es','título','el',0,'','','','','','','','2002-11-29 15:40:17'),(218,'de','Tourist','der',0,'','','','','','','','2002-11-29 15:40:17'),(218,'es','turista','el',0,'','','','','','','','2002-11-29 15:40:17'),(219,'de','Turnlehrer','der',0,'','','','','','','','2002-11-29 15:40:17'),(219,'es','profesor de gimnasia','el',0,'','','','','','','','2002-11-29 15:40:17'),(220,'de','Unfall','der',0,'','','','','','','','2002-11-29 15:40:17'),(220,'es','accidente','el',0,'','','','','','','','2002-11-29 15:40:17'),(221,'de','Urlaub','der',0,'','','','','','','','2002-11-29 15:40:17'),(221,'es','vacaciones','las',0,'','','','','','','','2002-11-29 15:40:17'),(222,'de','Vergleich','der',0,'','','','','','','','2002-11-29 15:40:17'),(222,'es','comparación','la',0,'','','','','','','','2002-11-29 15:40:17'),(223,'de','Verkehr','der',0,'','','','','','','','2002-11-29 15:40:17'),(223,'es','tráfico','el',0,'','','','','','','','2002-11-29 15:40:17'),(224,'de','Verkäufer','der',0,'','','','','','','','2002-11-29 15:40:17'),(224,'es','vendedor','el',0,'','','','','','','','2002-11-29 15:40:17'),(225,'de','Vogel','der',0,'','','','','','','','2002-11-29 15:40:17'),(225,'es','pájaro','el',0,'','','','','','','','2002-11-29 15:40:17'),(226,'de','Wagen','der',0,'','','','','','','','2002-11-29 15:40:17'),(226,'es','coche','el',0,'','','','','','','','2002-11-29 15:40:17'),(227,'de','Wechselkurs','der',0,'','','','','','','','2002-11-29 15:40:17'),(227,'es','cambio','el',0,'','','','','','','','2002-11-29 15:40:17'),(228,'de','Weg','der',0,'','','','','','','','2002-11-29 15:40:17'),(228,'es','camino','el',0,'','','','','','','','2002-11-29 15:40:17'),(229,'de','Winter','der',0,'','','','','','','','2002-11-29 15:40:17'),(229,'es','invierno','el',0,'','','','','','','','2002-11-29 15:40:17'),(230,'de','Zins','der',0,'','','','','','','','2002-11-29 15:40:17'),(230,'es','interés','el',0,'','','','','','','','2002-11-29 15:40:17'),(231,'de','Zug','der',0,'','','','','','','','2002-11-29 15:40:17'),(231,'es','tren','el',0,'','','','','','','','2002-11-29 15:40:17'),(232,'de','Ärger','der',0,'','','','','','','','2002-11-29 15:40:17'),(232,'es','disgusto','el',0,'','','','','','','','2002-11-29 15:40:17'),(233,'de','deshalb','',0,'','','','','','','','2002-11-29 15:40:17'),(233,'es','por eso','',0,'','','','','','','','2002-11-29 15:40:17'),(234,'de','deutsch','',0,'','','','','','','','2002-11-29 15:40:17'),(234,'es','alemán','',0,'','','','','','','','2002-11-29 15:40:17'),(235,'de','Abfahrt','die',0,'','','','','','','','2002-11-29 15:40:17'),(235,'es','salida','la',0,'','','','','','','','2002-11-29 15:40:17'),(236,'de','Abteilung','die',0,'','','','','','','','2002-11-29 15:40:17'),(236,'es','departamento','el',0,'','','','','','','','2002-11-29 15:40:17'),(237,'de','Angelegenheit','die',0,'','','','','','','','2002-11-29 15:40:17'),(237,'es','asunto','el',0,'','','','','','','','2002-11-29 15:40:17'),(238,'de','Antwort','die',0,'','','','','','','','2002-11-29 15:40:17'),(238,'es','respuesta','la',0,'','','','','','','','2002-11-29 15:40:17'),(239,'de','Anwendung','die',0,'','','','','','','','2002-11-29 15:40:17'),(239,'es','uso','el',0,'','','','','','','','2002-11-29 15:40:17'),(240,'de','Art','die',0,'','','','','','','','2002-11-29 15:40:17'),(240,'es','manera','la',0,'','','','','','','','2002-11-29 15:40:17'),(241,'de','Art','die',0,'','','','','','','','2002-11-29 15:40:17'),(241,'es','tipo','el',0,'','','','','','','','2002-11-29 15:40:17'),(242,'de','Ausdehnung','die',0,'','','','','','','','2002-11-29 15:40:17'),(242,'es','extensión','la',0,'','','','','','','','2002-11-29 15:40:17'),(243,'de','Banknote','die',0,'','','','','','','','2002-11-29 15:40:17'),(243,'es','billete de banco','el',0,'','','','','','','','2002-11-29 15:40:17'),(244,'de','Besessenheit','die',0,'','','','','','','','2002-11-29 15:40:17'),(244,'es','obsesión','la',0,'','','','','','','','2002-11-29 15:40:17'),(245,'de','Diskothek','die',0,'','','','','','','','2002-11-29 15:40:17'),(245,'es','discoteca','la',0,'','','','','','','','2002-11-29 15:40:17'),(246,'de','Distanzierung','die',0,'','','','','','','','2002-11-29 15:40:17'),(246,'es','distanciamiento','el',0,'','','','','','','','2002-11-29 15:40:17'),(247,'de','Dusche','die',0,'','','','','','','','2002-11-29 15:40:17'),(247,'es','ducha','la',0,'','','','','','','','2002-11-29 15:40:17'),(248,'de','Ecke','die',0,'','','','','','','','2002-11-29 15:40:17'),(248,'es','vuelta','la',0,'','','','','','','','2002-11-29 15:40:17'),(249,'de','Einbahnstraße','die',0,'','','','','','','','2002-11-29 15:40:17'),(249,'es','calle de dirección única','la',0,'','','','','','','','2002-11-29 15:40:17'),(250,'de','Epoche','die',0,'','','','','','','','2002-11-29 15:40:17'),(250,'es','época','la',0,'','','','','','','','2002-11-29 15:40:17'),(251,'de','Erde','die',0,'','','','','','','','2002-11-29 15:40:17'),(251,'es','tierra','la',0,'','','','','','','','2002-11-29 15:40:17'),(252,'de','Erfrischung','die',0,'','','','','','','','2002-11-29 15:40:17'),(252,'es','refresco','el',0,'','','','','','','','2002-11-29 15:40:17'),(253,'de','Fabrikation','die',0,'','','','','','','','2002-11-29 15:40:17'),(253,'es','fabricación','la',0,'','','','','','','','2002-11-29 15:40:17'),(254,'de','Flasche','die',0,'','','','','','','','2002-11-29 15:40:17'),(254,'es','botella','la',0,'','','','','','','','2002-11-29 15:40:17'),(255,'de','Form','die',0,'','','','','','','','2002-11-29 15:40:17'),(255,'es','forma','la',0,'','','','','','','','2002-11-29 15:40:17'),(256,'de','Frage','die',0,'','','','','','','','2002-11-29 15:40:17'),(256,'es','pregunta','la',0,'','','','','','','','2002-11-29 15:40:17'),(257,'de','Frau','die',0,'','','','','','','','2002-11-29 15:40:17'),(257,'es','mujer','la',0,'','','','','','','','2002-11-29 15:40:17'),(258,'de','Freizeit','die',0,'','','','','','','','2002-11-29 15:40:17'),(258,'es','tiempo libre','el',0,'','','','','','','','2002-11-29 15:40:17'),(259,'de','Garnele','die',0,'','','','','','','','2002-11-29 15:40:17'),(259,'es','gamba','la',0,'','','','','','','','2002-11-29 15:40:17'),(260,'de','Gattin','die',0,'','','','','','','','2002-11-29 15:40:17'),(260,'es','esposa','la',0,'','','','','','','','2002-11-29 15:40:17'),(261,'de','Geburt','die',0,'','','','','','','','2002-11-29 15:40:17'),(261,'es','nacimiento','el',0,'','','','','','','','2002-11-29 15:40:17'),(262,'de','Geldstrafe','die',0,'','','','','','','','2002-11-29 15:40:17'),(262,'es','multa','la',0,'','','','','','','','2002-11-29 15:40:17'),(263,'de','Gelegenheit','die',0,'','','','','','','','2002-11-29 15:40:17'),(263,'es','ocasión','la',0,'','','','','','','','2002-11-29 15:40:17'),(264,'de','Gepäckaufbewahrung','die',0,'','','','','','','','2002-11-29 15:40:17'),(264,'es','consigna','el',0,'','','','','','','','2002-11-29 15:40:17'),(265,'de','Geschwindigkeitsbeschränkung','die',0,'','','','','','','','2002-11-29 15:40:17'),(265,'es','restricción de velocidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(266,'de','Gesellschaft','die',0,'','','','','','','','2002-11-29 15:40:17'),(266,'es','compañía','la',0,'','','','','','','','2002-11-29 15:40:17'),(267,'de','Gesundheit','die',0,'','','','','','','','2002-11-29 15:40:17'),(267,'es','salud','la',0,'','','','','','','','2002-11-29 15:40:17'),(268,'de','Grammatik','die',0,'','','','','','','','2002-11-29 15:40:17'),(268,'es','gramática','la',0,'','','','','','','','2002-11-29 15:40:17'),(269,'de','Grippe','die',0,'','','','','','','','2002-11-29 15:40:17'),(269,'es','gripe','la',0,'','','','','','','','2002-11-29 15:40:17'),(270,'de','Halbinsel','die',0,'','','','','','','','2002-11-29 15:40:17'),(270,'es','península','la',0,'','','','','','','','2002-11-29 15:40:17'),(271,'de','Hand','die',0,'','','','','','','','2002-11-29 15:40:17'),(271,'es','mano','la',0,'','','','','','','','2002-11-29 15:40:17'),(272,'de','Hauptstadt','die',0,'','','','','','','','2002-11-29 15:40:17'),(272,'es','capital','la',0,'','','','','','','','2002-11-29 15:40:17'),(273,'de','Havarie','die',0,'','','','','','','','2002-11-29 15:40:17'),(273,'es','avería','la',0,'','','','','','','','2002-11-29 15:40:17'),(274,'de','Hypothek','die',0,'','','','','','','','2002-11-29 15:40:17'),(274,'es','hipoteca','la',0,'','','','','','','','2002-11-29 15:40:17'),(275,'de','Häppchen','die',0,'','','','','','','','2002-11-29 15:40:17'),(275,'es','tapas','las',0,'','','','','','','','2002-11-29 15:40:17'),(276,'de','Höflichkeit','die',0,'','','','','','','','2002-11-29 15:40:17'),(276,'es','cortesía','la',0,'','','','','','','','2002-11-29 15:40:17'),(277,'de','Hölle','die',0,'','','','','','','','2002-11-29 15:40:17'),(277,'es','infierno','el',0,'','','','','','','','2002-11-29 15:40:17'),(278,'de','Idee','die',0,'','','','','','','','2002-11-29 15:40:17'),(278,'es','idea','la',0,'','','','','','','','2002-11-29 15:40:17'),(279,'de','Information','die',0,'','','','','','','','2002-11-29 15:40:17'),(279,'es','información','la',0,'','','','','','','','2002-11-29 15:40:17'),(280,'de','Insel','die',0,'','','','','','','','2002-11-29 15:40:17'),(280,'es','isla','la',0,'','','','','','','','2002-11-29 15:40:17'),(281,'de','junge Dame','die',0,'','','','','','','','2002-11-29 15:40:17'),(281,'es','señorita','la',0,'','','','','','','','2002-11-29 15:40:17'),(282,'de','Kampagne','die',0,'','','','','','','','2002-11-29 15:40:17'),(282,'es','campaña','la',0,'','','','','','','','2002-11-29 15:40:17'),(283,'de','Karteikarte','die',0,'','','','','','','','2002-11-29 15:40:17'),(283,'es','ficha','la',0,'','','','','','','','2002-11-29 15:40:17'),(284,'de','Kasse','die',0,'','','','','','','','2002-11-29 15:40:17'),(284,'es','caja','la',0,'','','','','','','','2002-11-29 15:40:17'),(285,'de','Kathedrale','die',0,'','','','','','','','2002-11-29 15:40:17'),(285,'es','catedral','la',0,'','','','','','','','2002-11-29 15:40:17'),(286,'de','Kenntnis','die',0,'','','','','','','','2002-11-29 15:40:17'),(286,'es','conocimiento','el',0,'','','','','','','','2002-11-29 15:40:17'),(287,'de','Kontrolle','die',0,'','','','','','','','2002-11-29 15:40:17'),(287,'es','control','el',0,'','','','','','','','2002-11-29 15:40:17'),(288,'de','Kraft','die',0,'','','','','','','','2002-11-29 15:40:17'),(288,'es','fuerza','la',0,'','','','','','','','2002-11-29 15:40:17'),(289,'de','Kälte','die',0,'','','','','','','','2002-11-29 15:40:17'),(289,'es','frío','el',0,'','','','','','','','2002-11-29 15:40:17'),(290,'de','Küste','die',0,'','','','','','','','2002-11-29 15:40:17'),(290,'es','costa','la',0,'','','','','','','','2002-11-29 15:40:17'),(291,'de','Landstraße','die',0,'','','','','','','','2002-11-29 15:40:17'),(291,'es','carretera','la',0,'','','','','','','','2002-11-29 15:40:17'),(292,'de','Lektion','die',0,'','','','','','','','2002-11-29 15:40:17'),(292,'es','lección','la',0,'','','','','','','','2002-11-29 15:40:17'),(293,'de','Leute','die',0,'','','','','','','','2002-11-29 15:40:17'),(293,'es','gente','la',0,'','','','','','','','2002-11-29 15:40:17'),(294,'de','Meeresfrüchte','die',0,'','','','','','','','2002-11-29 15:40:17'),(294,'es','mariscos','los',0,'','','','','','','','2002-11-29 15:40:17'),(295,'de','Million','die',0,'','','','','','','','2002-11-29 15:40:17'),(295,'es','millón','el',0,'','','','','','','','2002-11-29 15:40:17'),(296,'de','Mittelmeerzone','die',0,'','','','','','','','2002-11-29 15:40:17'),(296,'es','zona mediterránea','la',0,'','','','','','','','2002-11-29 15:40:17'),(297,'de','Möglichkeit','die',0,'','','','','','','','2002-11-29 15:40:17'),(297,'es','posibilidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(298,'de','Münze','die',0,'','','','','','','','2002-11-29 15:40:17'),(298,'es','moneda','la',0,'','','','','','','','2002-11-29 15:40:17'),(299,'de','Nachrichten','die',0,'','','','','','','','2002-11-29 15:40:17'),(299,'es','noticias','las',0,'','','','','','','','2002-11-29 15:40:17'),(300,'de','Nachspeise','die',0,'','','','','','','','2002-11-29 15:40:17'),(300,'es','postre','el',0,'','','','','','','','2002-11-29 15:40:17'),(301,'de','Nacht','die',0,'','','','','','','','2002-11-29 15:40:17'),(301,'es','noche','la',0,'','','','','','','','2002-11-29 15:40:17'),(302,'de','Nationalität','die',0,'','','','','','','','2002-11-29 15:40:17'),(302,'es','nacionalidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(303,'de','Nervosität','die',0,'','','','','','','','2002-11-29 15:40:17'),(303,'es','nerviosismo','el',0,'','','','','','','','2002-11-29 15:40:17'),(304,'de','Ortschaft','die',0,'','','','','','','','2002-11-29 15:40:17'),(304,'es','población','la',0,'','','','','','','','2002-11-29 15:40:17'),(305,'de','Pause','die',0,'','','','','','','','2002-11-29 15:40:17'),(305,'es','descanso','el',0,'','','','','','','','2002-11-29 15:40:17'),(306,'de','Pension','die',0,'','','','','','','','2002-11-29 15:40:17'),(306,'es','pensión','la',0,'','','','','','','','2002-11-29 15:40:17'),(307,'de','Periode','die',0,'','','','','','','','2002-11-29 15:40:17'),(307,'es','período','el',0,'','','','','','','','2002-11-29 15:40:17'),(308,'de','Personalien','die',0,'','','','','','','','2002-11-29 15:40:17'),(308,'es','datos personales','los',0,'','','','','','','','2002-11-29 15:40:17'),(309,'de','Plauderei','die',0,'','','','','','','','2002-11-29 15:40:17'),(309,'es','charla','la',0,'','','','','','','','2002-11-29 15:40:17'),(310,'de','Politik','die',0,'','','','','','','','2002-11-29 15:40:17'),(310,'es','política','la',0,'','','','','','','','2002-11-29 15:40:17'),(311,'de','Post','die',0,'','','','','','','','2002-11-29 15:40:17'),(311,'es','correo','el',0,'','','','','','','','2002-11-29 15:40:17'),(312,'de','Postkarte','die',0,'','','','','','','','2002-11-29 15:40:17'),(312,'es','postal','el',0,'','','','','','','','2002-11-29 15:40:17'),(313,'de','Probe','die',0,'','','','','','','','2002-11-29 15:40:17'),(313,'es','prueba','la',0,'','','','','','','','2002-11-29 15:40:17'),(314,'de','Präposition','die',0,'','','','','','','','2002-11-29 15:40:17'),(314,'es','preposición','la',0,'','','','','','','','2002-11-29 15:40:17'),(315,'de','Rechnung','die',0,'','','','','','','','2002-11-29 15:40:17'),(315,'es','cuenta','la',0,'','','','','','','','2002-11-29 15:40:17'),(316,'de','Regel','die',0,'','','','','','','','2002-11-29 15:40:17'),(316,'es','regla','la',0,'','','','','','','','2002-11-29 15:40:17'),(317,'de','Region','die',0,'','','','','','','','2002-11-29 15:40:17'),(317,'es','región','la',0,'','','','','','','','2002-11-29 15:40:17'),(318,'de','Reinigung','die',0,'','','','','','','','2002-11-29 15:40:17'),(318,'es','limpieza','la',0,'','','','','','','','2002-11-29 15:40:17'),(319,'de','Reservierung','die',0,'','','','','','','','2002-11-29 15:40:17'),(319,'es','reserva','la',0,'','','','','','','','2002-11-29 15:40:17'),(320,'de','Rezeption','die',0,'','','','','','','','2002-11-29 15:40:17'),(320,'es','recepción','la',0,'','','','','','','','2002-11-29 15:40:17'),(321,'de','Richtung','die',0,'','','','Leitung; Regie','','','','2002-11-29 15:40:17'),(321,'es','dirección','la',0,'','','','','','','','2002-11-29 15:40:17'),(322,'de','Ruhe','die',0,'','','','','','','','2002-11-29 15:40:17'),(322,'es','tranquilidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(323,'de','Ruine','die',0,'','','','','','','','2002-11-29 15:40:17'),(323,'es','ruina','la',0,'','','','','','','','2002-11-29 15:40:17'),(324,'de','Rundreise','die',0,'','','','','','','','2002-11-29 15:40:17'),(324,'es','gira','la',0,'','','','','','','','2002-11-29 15:40:17'),(325,'de','Sache','die',0,'','','','','','','','2002-11-29 15:40:17'),(325,'es','cosa','la',0,'','','','','','','','2002-11-29 15:40:17'),(326,'de','Sardellen','die',0,'','','','','','','','2002-11-29 15:40:17'),(326,'es','anchoas','las',0,'','','','','','','','2002-11-29 15:40:17'),(327,'de','Schlagzeile','die',0,'','','','','','','','2002-11-29 15:40:17'),(327,'es','titular','el',0,'','','','','','','','2002-11-29 15:40:17'),(328,'de','Schule','die',0,'','','','','','','','2002-11-29 15:40:17'),(328,'es','escuela','la',0,'','','','el colegio','','','','2002-11-29 15:40:17'),(329,'de','Schwierigkeit','die',0,'','','','','','','','2002-11-29 15:40:17'),(329,'es','dificultad','la',0,'','','','','','','','2002-11-29 15:40:17'),(330,'de','Schönheit','die',0,'','','','','','','','2002-11-29 15:40:17'),(330,'es','belleza','la',0,'','','','','','','','2002-11-29 15:40:17'),(331,'de','Schülerin','die',0,'','','','','','','','2002-11-29 15:40:17'),(331,'es','alumna','la',0,'','','','','','','','2002-11-29 15:40:17'),(332,'de','Sitte','die',0,'','','','','','','','2002-11-29 15:40:17'),(332,'es','costumbre','la',0,'','','','','','','','2002-11-29 15:40:17'),(333,'de','Situation','die',0,'','','','','','','','2002-11-29 15:40:17'),(333,'es','situación','la',0,'','','','','','','','2002-11-29 15:40:17'),(334,'de','Sonne','die',0,'','','','','','','','2002-11-29 15:40:17'),(334,'es','sol','el',0,'','','','','','','','2002-11-29 15:40:17'),(335,'de','Spanierin','die',0,'','','','','','','','2002-11-29 15:40:17'),(335,'es','española','la',0,'','','','','','','','2002-11-29 15:40:17'),(336,'de','Speisekarte','die',0,'','','','der Brief','','','','2002-11-29 15:40:17'),(336,'es','carta','la',0,'','','','','','','','2002-11-29 15:40:17'),(337,'de','Spezialität','die',0,'','','','','','','','2002-11-29 15:40:17'),(337,'es','especialidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(338,'de','Sprache','die',0,'','','','','','','','2002-11-29 15:40:17'),(338,'es','lengua','la',0,'','','','','','','','2002-11-29 15:40:17'),(339,'de','Sprache','die',0,'','','','','','','','2002-11-29 15:40:17'),(339,'es','idioma','el',0,'','','','','','','','2002-11-29 15:40:17'),(340,'de','Stadt','die',0,'','','','','','','','2002-11-29 15:40:17'),(340,'es','ciudad','la',0,'','','','','','','','2002-11-29 15:40:17'),(341,'de','Stewardess','die',0,'','','','','','','','2002-11-29 15:40:17'),(341,'es','azafata','la',0,'','','','','','','','2002-11-29 15:40:17'),(342,'de','Straße','die',0,'','','','','','','','2002-11-29 15:40:17'),(342,'es','calle','la',0,'','','','','','','','2002-11-29 15:40:17'),(343,'de','Straßenbahn','die',0,'','','','','','','','2002-11-29 15:40:17'),(343,'es','tranvía','el',0,'','','','','','','','2002-11-29 15:40:17'),(344,'de','Stunde','die',0,'','','','','','','','2002-11-29 15:40:17'),(344,'es','hora','la',0,'','','','','','','','2002-11-29 15:40:17'),(345,'de','Störung','die',0,'','','','','','','','2002-11-29 15:40:17'),(345,'es','molestia','la',0,'','','','','','','','2002-11-29 15:40:17'),(346,'de','Suppe','die',0,'','','','','','','','2002-11-29 15:40:17'),(346,'es','sopa','la',0,'','','','','','','','2002-11-29 15:40:17'),(347,'de','Tankstelle','die',0,'','','','','','','','2002-11-29 15:40:17'),(347,'es','gasolinera','la',0,'','','','','','','','2002-11-29 15:40:17'),(348,'de','Telefonnummer','die',0,'','','','','','','','2002-11-29 15:40:17'),(348,'es','número de teléfono','el',0,'','','','','','','','2002-11-29 15:40:17'),(349,'de','Temperatur','die',0,'','','','','','','','2002-11-29 15:40:17'),(349,'es','temperatura','la',0,'','','','','','','','2002-11-29 15:40:17'),(350,'de','Uhr','die',0,'','','','','','','','2002-11-29 15:40:17'),(350,'es','reloj','el',0,'','','','','','','','2002-11-29 15:40:17'),(351,'de','Umarmung','die',0,'','','','','','','','2002-11-29 15:40:17'),(351,'es','abrazo','el',0,'','','','','','','','2002-11-29 15:40:17'),(352,'de','Umweltverschmutzung','die',0,'','','','','','','','2002-11-29 15:40:17'),(352,'es','contaminación','la',0,'','','','','','','','2002-11-29 15:40:17'),(353,'de','Universität','die',0,'','','','','','','','2002-11-29 15:40:17'),(353,'es','universidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(354,'de','Unterhaltung','die',0,'','','','','','','','2002-11-29 15:40:17'),(354,'es','conversación','la',0,'','','','','','','','2002-11-29 15:40:17'),(355,'de','Unterschrift','die',0,'','','','','','','','2002-11-29 15:40:17'),(355,'es','firma','la',0,'','','','','','','','2002-11-29 15:40:17'),(356,'de','Vegetation','die',0,'','','','','','','','2002-11-29 15:40:17'),(356,'es','vegetación','la',0,'','','','','','','','2002-11-29 15:40:17'),(357,'de','Vereinigung','die',0,'','','','','','','','2002-11-29 15:40:17'),(357,'es','unificación','la',0,'','','','','','','','2002-11-29 15:40:17'),(358,'de','Vorhersage','die',0,'','','','','','','','2002-11-29 15:40:17'),(358,'es','pronóstico','el',0,'','','','','','','','2002-11-29 15:40:17'),(359,'de','Vorliebe','die',0,'','','','','','','','2002-11-29 15:40:17'),(359,'es','afición','la',0,'','','','','','','','2002-11-29 15:40:17'),(360,'de','Vorspeise','die',0,'','','','','','','','2002-11-29 15:40:17'),(360,'es','primer plato','el',0,'','','','','','','','2002-11-29 15:40:17'),(361,'de','Werbung','die',0,'','','','','','','','2002-11-29 15:40:17'),(361,'es','propaganda','la',0,'','','','','','','','2002-11-29 15:40:17'),(362,'de','Windschutzscheibe','die',0,'','','','','','','','2002-11-29 15:40:17'),(362,'es','parabrisas','el',0,'','','','','','','','2002-11-29 15:40:17'),(363,'de','Wirklichkeit','die',0,'','','','','','','','2002-11-29 15:40:17'),(363,'es','realidad','la',0,'','','','','','','','2002-11-29 15:40:17'),(364,'de','Wirklichkeit','die',0,'','','','','','','','2002-11-29 15:40:17'),(364,'es','realidad','el',0,'','','','','','','','2002-11-29 15:40:17'),(365,'de','Wissenschaft','die',0,'','','','','','','','2002-11-29 15:40:17'),(365,'es','ciencia','la',0,'','','','','','','','2002-11-29 15:40:17'),(366,'de','Wohnung','die',0,'','','','','','','','2002-11-29 15:40:17'),(366,'es','piso','el',0,'','','','','','','','2002-11-29 15:40:17'),(367,'de','Wärme','die',0,'','','','','','','','2002-11-29 15:40:17'),(367,'es','calor','el',0,'','','','','','','','2002-11-29 15:40:17'),(368,'de','Zeitschrift','die',0,'','','','','','','','2002-11-29 15:40:17'),(368,'es','revista','la',0,'','','','','','','','2002-11-29 15:40:17'),(369,'de','Zeitung','die',0,'','','','','','','','2002-11-29 15:40:17'),(369,'es','periódico','el',0,'','','','','','','','2002-11-29 15:40:17'),(370,'de','Zivilisation','die',0,'','','','','','','','2002-11-29 15:40:17'),(370,'es','civilisación','la',0,'','','','','','','','2002-11-29 15:40:17'),(371,'de','Überweisung','die',0,'','','','','','','','2002-11-29 15:40:17'),(371,'es','transferencia','la',0,'','','','','','','','2002-11-29 15:40:17'),(372,'de','dieser','',0,'','','','','','','','2002-11-29 15:40:17'),(372,'es','esto','',0,'','','','','','','','2002-11-29 15:40:17'),(373,'de','direkt','',0,'','','','','','','','2002-11-29 15:40:17'),(373,'es','directo','',0,'','','','','','','','2002-11-29 15:40:17'),(374,'de','doppelt','',0,'','','','','','','','2002-11-29 15:40:17'),(374,'es','doble','',0,'','','','','','','','2002-11-29 15:40:17'),(375,'de','dort','',0,'','','','','','','','2002-11-29 15:40:17'),(375,'es','allí','',0,'','','','','','','','2002-11-29 15:40:17'),(376,'de','drei','',0,'','','','','','','','2002-11-29 15:40:17'),(376,'es','tres','',0,'','','','','','','','2002-11-29 15:40:17'),(377,'de','dreizehn','',0,'','','','','','','','2002-11-29 15:40:17'),(377,'es','trece','',0,'','','','','','','','2002-11-29 15:40:17'),(378,'de','eigentümlich','',0,'','','','','','','','2002-11-29 15:40:17'),(378,'es','original','',0,'','','','','','','','2002-11-29 15:40:17'),(379,'de','ein wenig','',0,'','','','','','','','2002-11-29 15:40:17'),(379,'es','un poco','',0,'','','','','','','','2002-11-29 15:40:17'),(380,'de','eine Weile','',0,'','','','','','','','2002-11-29 15:40:17'),(380,'es','un buen rato','',0,'','','','','','','','2002-11-29 15:40:17'),(381,'de','einfach','',0,'','','','','','','','2002-11-29 15:40:17'),(381,'es','simplemente','',0,'','','','','','','','2002-11-29 15:40:17'),(382,'de','einfach','',0,'','','','','','','','2002-11-29 15:40:17'),(382,'es','sencillamente','',0,'','','','','','','','2002-11-29 15:40:17'),(383,'de','einfach','',0,'','','','','','','','2002-11-29 15:40:17'),(383,'es','sencillo','',0,'','','','','','','','2002-11-29 15:40:17'),(384,'de','einheitlich','',0,'','','','','','','','2002-11-29 15:40:17'),(384,'es','uniforme','',0,'','','','','','','','2002-11-29 15:40:17'),(385,'de','einwerfen','',0,'','','','','','','','2002-11-29 15:40:17'),(385,'es','echar','',0,'','','','','','','','2002-11-29 15:40:17'),(386,'de','beenden','',0,'','','','','','','','2002-11-29 15:40:17'),(386,'es','terminar','',0,'','','','','','','','2002-11-29 15:40:17'),(387,'de','entschuldigen Sie','',0,'','','','','','','','2002-11-29 15:40:17'),(387,'es','disculpe usted','',0,'','','','','','','','2002-11-29 15:40:17'),(388,'de','erlauben','',0,'','','','','','','','2002-11-29 15:40:17'),(388,'es','permitir','',0,'','','','','','','','2002-11-29 15:40:17'),(389,'de','erledigen','',0,'','','','','','','','2002-11-29 15:40:17'),(389,'es','arreglar','',0,'','','','','','','','2002-11-29 15:40:17'),(390,'de','erläutern','',0,'','','','','','','','2002-11-29 15:40:17'),(390,'es','explicar','',0,'','','','','','','','2002-11-29 15:40:17'),(391,'de','erster','',0,'','','','zuerst','','','','2002-11-29 15:40:17'),(391,'es','primero','',0,'','','','','','','','2002-11-29 15:40:17'),(392,'de','erzeugen','',0,'','','','herstellen','','','','2002-11-29 15:40:17'),(392,'es','producir','',0,'','','','','','','','2002-11-29 15:40:17'),(393,'de','erzählen','',0,'','','','','','','','2002-11-29 15:40:17'),(393,'es','contar','',0,'','','','','','','','2002-11-29 15:40:17'),(394,'de','es gibt','',0,'','','','','','','','2002-11-29 15:40:17'),(394,'es','hay','',0,'','','','','','','','2002-11-29 15:40:17'),(395,'de','es ist fünf Uhr dreißig','',0,'','','','','','','','2002-11-29 15:40:17'),(395,'es','son las cinco y media','',0,'','','','','','','','2002-11-29 15:40:17'),(396,'de','es ist unwichtig','',0,'','','','','','','','2002-11-29 15:40:17'),(396,'es','no tiene importancia','',0,'','','','','','','','2002-11-29 15:40:17'),(397,'de','es tut mir leid','',0,'','','','','','','','2002-11-29 15:40:17'),(397,'es','lo siento','',0,'','','','','','','','2002-11-29 15:40:17'),(398,'de','essen','',0,'','','','','','','','2002-11-29 15:40:17'),(398,'es','comer','',0,'','','','','','','','2002-11-29 15:40:17'),(399,'de','etwas','',0,'','','','','','','','2002-11-29 15:40:17'),(399,'es','algo','',0,'','','','','','','','2002-11-29 15:40:17'),(400,'de','etwas anderes','',0,'','','','','','','','2002-11-29 15:40:17'),(400,'es','otra cosa','',0,'','','','','','','','2002-11-29 15:40:17'),(401,'de','euer','',0,'','','','','','','','2002-11-29 15:40:17'),(401,'es','vuestro','',0,'','','','','','','','2002-11-29 15:40:17'),(402,'de','existieren','',0,'','','','','','','','2002-11-29 15:40:17'),(402,'es','existir','',0,'','','','','','','','2002-11-29 15:40:17'),(403,'de','extrem','',0,'','','','','','','','2002-11-29 15:40:17'),(403,'es','extremo','',0,'','','','','','','','2002-11-29 15:40:17'),(404,'de','fallen','',0,'','','','','','','','2002-11-29 15:40:17'),(404,'es','caer','',0,'','','','','','','','2002-11-29 15:40:17'),(405,'de','falsch','',0,'','','','','','','','2002-11-29 15:40:17'),(405,'es','falso','',0,'','','','','','','','2002-11-29 15:40:17'),(406,'de','fast','',0,'','','','','','','','2002-11-29 15:40:17'),(406,'es','casi','',0,'','','','','','','','2002-11-29 15:40:17'),(407,'de','fehlen','',0,'','','','','','','','2002-11-29 15:40:17'),(407,'es','faltar','',0,'','','','','','','','2002-11-29 15:40:17'),(408,'de','fortsetzen','',0,'','','','','','','','2002-11-29 15:40:17'),(408,'es','continuar','',0,'','','','','','','','2002-11-29 15:40:17'),(409,'de','fragen','',0,'','','','','','','','2002-11-29 15:40:17'),(409,'es','preguntar','',0,'','','','','','','','2002-11-29 15:40:17'),(410,'de','frei','',0,'','','','','','','','2002-11-29 15:40:17'),(410,'es','libre','',0,'','','','','','','','2002-11-29 15:40:17'),(411,'de','fröhlich','',0,'','','','','','','','2002-11-29 15:40:17'),(411,'es','alegre','',0,'','','','','','','','2002-11-29 15:40:17'),(412,'de','frühstücken','',0,'','','','','','','','2002-11-29 15:40:17'),(412,'es','desayunar','',0,'','','','','','','','2002-11-29 15:40:17'),(413,'de','funktionieren','',0,'','','','','','','','2002-11-29 15:40:17'),(413,'es','funcionar','',0,'','','','','','','','2002-11-29 15:40:17'),(414,'de','fühlen','',0,'','','','','','','','2002-11-29 15:40:17'),(414,'es','sentir','',0,'','','','','','','','2002-11-29 15:40:17'),(415,'de','fünfhundert','',0,'','','','','','','','2002-11-29 15:40:17'),(415,'es','quinientos','',0,'','','','','','','','2002-11-29 15:40:17'),(416,'de','fünfundzwanzig','',0,'','','','','','','','2002-11-29 15:40:17'),(416,'es','veinticinco','',0,'','','','','','','','2002-11-29 15:40:17'),(417,'de','fünfzig','',0,'','','','','','','','2002-11-29 15:40:17'),(417,'es','cincuenta','',0,'','','','','','','','2002-11-29 15:40:17'),(418,'de','für','',0,'','','','','','','','2002-11-29 15:40:17'),(418,'es','para','',0,'','','','','','','','2002-11-29 15:40:17'),(419,'de','geben','',0,'','','','','','','','2002-11-29 15:40:17'),(419,'es','dar','',0,'','','','','','','','2002-11-29 15:40:17'),(420,'de','gefallen','',0,'','','','','','','','2002-11-29 15:40:17'),(420,'es','gustar','',0,'','','','','','','','2002-11-29 15:40:17'),(421,'de','gegen','',0,'','','','','','','','2002-11-29 15:40:17'),(421,'es','contra','',0,'','','','','','','','2002-11-29 15:40:17'),(422,'de','gegenüber','',0,'','','','','','','','2002-11-29 15:40:17'),(422,'es','enfrente','',0,'','','','','','','','2002-11-29 15:40:17'),(423,'de','gehen','',0,'','','','','','','','2002-11-29 15:40:17'),(423,'es','andar','',0,'','','','','','','','2002-11-29 15:40:17'),(424,'de','gehen','',0,'','','','fahren; reisen','','','','2002-11-29 15:40:17'),(424,'es','ir','',0,'','','','','','','','2002-11-29 15:40:17'),(425,'de','gelegentlich','',0,'','','','','','','','2002-11-29 15:40:17'),(425,'es','ocasional','',0,'','','','','','','','2002-11-29 15:40:17'),(426,'de','genau','',0,'','','','','','','','2002-11-29 15:40:17'),(426,'es','exactamente','',0,'','','','','','','','2002-11-29 15:40:17'),(427,'de','genügen','',0,'','','','','','','','2002-11-29 15:40:17'),(427,'es','bastar','',0,'','','','','','','','2002-11-29 15:40:17'),(428,'de','genügend','',0,'','','','','','','','2002-11-29 15:40:17'),(428,'es','bastante','',0,'','','','','','','','2002-11-29 15:40:17'),(429,'de','gerade','',0,'','','','','','','','2002-11-29 15:40:17'),(429,'es','precisamente','',0,'','','','','','','','2002-11-29 15:40:17'),(430,'de','glauben','',0,'','','','','','','','2002-11-29 15:40:17'),(430,'es','creer','',0,'','','','','','','','2002-11-29 15:40:17'),(431,'de','gleichfalls','',0,'','','','','','','','2002-11-29 15:40:17'),(431,'es','igualmente','',0,'','','','','','','','2002-11-29 15:40:17'),(432,'de','glücklich','',0,'','','','','','','','2002-11-29 15:40:17'),(432,'es','feliz','',0,'','','','','','','','2002-11-29 15:40:17'),(433,'de','groß','',0,'','','','','','','','2002-11-29 15:40:17'),(433,'es','grande','',0,'','','','','','','','2002-11-29 15:40:17'),(434,'de','grün','',0,'','','','','','','','2002-11-29 15:40:17'),(434,'es','verde','',0,'','','','','','','','2002-11-29 15:40:17'),(435,'de','grüßen','',0,'','','','','','','','2002-11-29 15:40:17'),(435,'es','saludar','',0,'','','','','','','','2002-11-29 15:40:17'),(436,'de','gut','',0,'','','','','','','','2002-11-29 15:40:17'),(436,'es','bueno','',0,'','','','','','','','2002-11-29 15:40:17'),(437,'de','gute Fahrt','',0,'','','','','','','','2002-11-29 15:40:17'),(437,'es','buen viaje','',0,'','','','','','','','2002-11-29 15:40:17'),(438,'de','guten Nachmittag','',0,'','','','Guten Abend; Guten Tag','','','','2002-11-29 15:40:17'),(438,'es','buenas tardes','',0,'','','','','','','','2002-11-29 15:40:17'),(439,'de','Guten Tag','',0,'','','','Guten Morgen','','','','2002-11-29 15:40:17'),(439,'es','buenos días','',0,'','','','','','','','2002-11-29 15:40:17'),(440,'de','haben','',0,'','','','','','','','2002-11-29 15:40:17'),(440,'es','tener','',0,'','','','','','','','2002-11-29 15:40:17'),(441,'de','hallo','',0,'','','','','','','','2002-11-29 15:40:17'),(441,'es','hola','',0,'','','','','','','','2002-11-29 15:40:17'),(442,'de','hart','',0,'','','','','','','','2002-11-29 15:40:17'),(442,'es','duro','',0,'','','','','','','','2002-11-29 15:40:17'),(443,'de','heißen','',0,'','','','','','wörtlich: sich nennen','','2002-11-29 15:40:17'),(443,'es','llamarse','',0,'','','','','(yo) me llamo','','','2002-11-29 15:40:17'),(444,'de','herausbilden','',0,'','','','','','','','2002-11-29 15:40:17'),(444,'es','formar','',0,'','','','','','','','2002-11-29 15:40:17'),(445,'de','herbringen','',0,'','','','','','','','2002-11-29 15:40:17'),(445,'es','traer','',0,'','','','','','','','2002-11-29 15:40:17'),(446,'de','heute','',0,'','','','','','','','2002-11-29 15:40:17'),(446,'es','hoy','',0,'','','','','','','','2002-11-29 15:40:17'),(447,'de','hier','',0,'','','','','','','','2002-11-29 15:40:17'),(447,'es','aquí','',0,'','','','','','','','2002-11-29 15:40:17'),(448,'de','hin und zurück','',0,'','','','','','','','2002-11-29 15:40:17'),(448,'es','ida y vuelta','',0,'','','','','','','','2002-11-29 15:40:17'),(449,'de','hineingehen','',0,'','','','','','','','2002-11-29 15:40:17'),(449,'es','entrar','',0,'','','','','','','','2002-11-29 15:40:17'),(450,'de','hoch','',0,'','','','','','','','2002-11-29 15:40:17'),(450,'es','alto','',0,'','','','','','','','2002-11-29 15:40:17'),(451,'de','hundert','',0,'','','','','','','','2002-11-29 15:40:17'),(451,'es','cien','',0,'','','','','','','','2002-11-29 15:40:17'),(452,'de','Hunger haben','',0,'','','','','','','','2002-11-29 15:40:17'),(452,'es','tener hambre','',0,'','','','','','','','2002-11-29 15:40:17'),(453,'de','höflich','',0,'','','','','','','','2002-11-29 15:40:17'),(453,'es','cortés','',0,'','','','','','','','2002-11-29 15:40:17'),(454,'de','hören','',0,'','','','','','','','2002-11-29 15:40:17'),(454,'es','oír','',0,'','','','','','','','2002-11-29 15:40:17'),(455,'de','ich danke ihnen','',0,'','','','','','','','2002-11-29 15:40:17'),(455,'es','yo le doy las gracias a usted','',0,'','','','','','','','2002-11-29 15:40:17'),(456,'de','ich möchte','',0,'','','','','','','','2002-11-29 15:40:17'),(456,'es','quisiera','',0,'','','','','','','','2002-11-29 15:40:17'),(457,'de','ich nehme sie','',0,'','','','','','','','2002-11-29 15:40:17'),(457,'es','me quedo con ellos','',0,'','','','','','','','2002-11-29 15:40:17'),(458,'de','ideal','',0,'','','','','','','','2002-11-29 15:40:17'),(458,'es','ideal','',0,'','','','','','','','2002-11-29 15:40:17'),(459,'de','ihrerseits','',0,'','','','','','','','2002-11-29 15:40:17'),(459,'es','de su parte','',0,'','','','','','','','2002-11-29 15:40:17'),(460,'de','im allgemeinen','',0,'','','','','','','','2002-11-29 15:40:17'),(460,'es','en general','',0,'','','','','','','','2002-11-29 15:40:17'),(461,'de','in','',0,'','','','','','','','2002-11-29 15:40:17'),(461,'es','en','',0,'','','','','','','','2002-11-29 15:40:17'),(462,'de','inbegriffen','',0,'','','','','','','','2002-11-29 15:40:17'),(462,'es','incluído','',0,'','','','','','','','2002-11-29 15:40:17'),(463,'de','innerhalb','',0,'','','','','','','','2002-11-29 15:40:17'),(463,'es','dentro de','',0,'','','','','','','','2002-11-29 15:40:17'),(464,'de','ja','',0,'','','','','','','','2002-11-29 15:40:17'),(464,'es','sí','',0,'','','','','','','','2002-11-29 15:40:17'),(465,'de','jener','',0,'','','','','','','','2002-11-29 15:40:17'),(465,'es','aquello','',0,'','','','','','','','2002-11-29 15:40:17'),(466,'de','jetzt','',0,'','','','','','','','2002-11-29 15:40:17'),(466,'es','ahora','',0,'','','','','','','','2002-11-29 15:40:17'),(798,'es','cocinero','el',1,'','','','','','','','2002-12-04 14:46:51'),(468,'de','Juni','',0,'','','','','','','','2002-11-29 15:40:17'),(468,'es','junio','',0,'','','','','','','','2002-11-29 15:40:17'),(469,'de','keine Ursache','',0,'','','','Nichts zu danken','','','','2002-11-29 15:40:17'),(469,'es','de nada','',0,'','','','','','','','2002-11-29 15:40:17'),(470,'de','keiner','',0,'','','','','','','','2002-11-29 15:40:17'),(470,'es','ninguno','',0,'','','','','','','','2002-11-29 15:40:17'),(471,'de','kennen','',0,'','','','','','','','2002-11-29 15:40:17'),(471,'es','conocer','',0,'','','','','','','','2002-11-29 15:40:17'),(472,'de','kennzeichnen','',0,'','','','','','','','2002-11-29 15:40:17'),(472,'es','caracterizar','',0,'','','','','','','','2002-11-29 15:40:17'),(473,'de','klar','',0,'','','','','','','','2002-11-29 15:40:17'),(473,'es','claro','',0,'','','','','','','','2002-11-29 15:40:17'),(474,'de','klein','',0,'','','','','','','','2002-11-29 15:40:17'),(474,'es','pequeño','',0,'','','','','','','','2002-11-29 15:40:17'),(475,'de','kommen','',0,'','','','','','','','2002-11-29 15:40:17'),(475,'es','venir','',0,'','','','','','','','2002-11-29 15:40:17'),(476,'de','kompliziert','',0,'','','','','','','','2002-11-29 15:40:17'),(476,'es','complicado','',0,'','','','','','','','2002-11-29 15:40:17'),(477,'de','kosten','',0,'','','','','','','','2002-11-29 15:40:17'),(477,'es','valer','',0,'','','','','','','','2002-11-29 15:40:17'),(478,'de','krank','',0,'','','','','','','','2002-11-29 15:40:17'),(478,'es','enfermo','',0,'','','','','','','','2002-11-29 15:40:17'),(479,'de','können','',0,'','','','','','','','2002-11-29 15:40:17'),(479,'es','poder','',0,'','','','','','','','2002-11-29 15:40:17'),(480,'de','lang','',0,'','','','','','','','2002-11-29 15:40:17'),(480,'es','largo','',0,'','','','','','','','2002-11-29 15:40:17'),(481,'de','lange brauchen','',0,'','','','','','','','2002-11-29 15:40:17'),(481,'es','tardar','',0,'','','','','','','','2002-11-29 15:40:17'),(482,'de','langweilig','',0,'','','','','','','','2002-11-29 15:40:17'),(482,'es','aburrido','',0,'','','','','','','','2002-11-29 15:40:17'),(483,'de','lassen','',0,'','','','','','','','2002-11-29 15:40:17'),(483,'es','dejar','',0,'','','','','','','','2002-11-29 15:40:17'),(484,'de','leben','',0,'','','','','','','','2002-11-29 15:40:17'),(484,'es','vivir','',0,'','','','','','','','2002-11-29 15:40:17'),(485,'de','leicht','',0,'','','','','','','','2002-11-29 15:40:17'),(485,'es','fácil','',0,'','','','','','','','2002-11-29 15:40:17'),(486,'de','lernen','',0,'','','','','','','','2002-11-29 15:40:17'),(486,'es','aprender','',0,'','','','','','','','2002-11-29 15:40:17'),(487,'de','lesen','',0,'','','','','','','','2002-11-29 15:40:17'),(487,'es','leer','',0,'','','','','','','','2002-11-29 15:40:17'),(488,'de','letztendlich','',0,'','','','','','','','2002-11-29 15:40:17'),(488,'es','al fin y al cabo','',0,'','','','','','','','2002-11-29 15:40:17'),(489,'de','letzter','',0,'','','','','','','','2002-11-29 15:40:17'),(489,'es','último','',0,'','','','','','','','2002-11-29 15:40:17'),(490,'de','liebenswürdig','',0,'','','','','','','','2002-11-29 15:40:17'),(490,'es','amable','',0,'','','','','','','','2002-11-29 15:40:17'),(491,'de','logisch','',0,'','','','','','','','2002-11-29 15:40:17'),(491,'es','lógico','',0,'','','','','','','','2002-11-29 15:40:17'),(492,'de','logischerweise','',0,'','','','','','','','2002-11-29 15:40:17'),(492,'es','lógicamente','',0,'','','','','','','','2002-11-29 15:40:17'),(493,'de','lösen','',0,'das Problem','','','','','','','2002-11-29 15:40:17'),(493,'es','resolver','',0,'','','','','','','','2002-11-29 15:40:17'),(494,'de','machen','',0,'','','','','','','','2002-11-29 15:40:17'),(494,'es','hacer','',0,'','','','','','','','2002-11-29 15:40:17'),(495,'de','manchmal','',0,'','','','','','','','2002-11-29 15:40:17'),(495,'es','alguna vez','',0,'','','','','','','','2002-11-29 15:40:17'),(496,'de','mein','',0,'','','','','','','','2002-11-29 15:40:17'),(496,'es','mío','',0,'','','','','','','','2002-11-29 15:40:17'),(497,'de','meistens','',0,'','','','','','','','2002-11-29 15:40:17'),(497,'es','generalmente','',0,'','','','','','','','2002-11-29 15:40:17'),(498,'de','mieten','',0,'','','','','','','','2002-11-29 15:40:17'),(498,'es','alquilar','',0,'','','','','','','','2002-11-29 15:40:17'),(499,'de','mit','',0,'','','','','','','','2002-11-29 15:40:17'),(499,'es','con','',0,'','','','','','','','2002-11-29 15:40:17'),(500,'de','modern','',0,'','','','','','','','2002-11-29 15:40:17'),(500,'es','moderno','',0,'','','','','','','','2002-11-29 15:40:17'),(501,'de','morgen','',0,'','','','','','','','2002-11-29 15:40:17'),(501,'es','mañana','',0,'','','','','','','','2002-11-29 15:40:17'),(502,'de','morgens','',0,'','','','','','','','2002-11-29 15:40:17'),(502,'es','por la mañana','',0,'','','','','','','','2002-11-29 15:40:17'),(503,'de','möglich','',0,'','','','','','','','2002-11-29 15:40:17'),(503,'es','posible','',0,'','','','','','','','2002-11-29 15:40:17'),(504,'de','möglicherweise','',0,'','','','','','','','2002-11-29 15:40:17'),(504,'es','posiblemente','',0,'','','','','','','','2002-11-29 15:40:17'),(505,'de','müssen','',0,'Notwendigkeit','','','','','','','2002-11-29 15:40:17'),(505,'es','tener que','',0,'','','','','','','','2002-11-29 15:40:17'),(506,'de','nach','',0,'','','','','','','','2002-11-29 15:40:17'),(506,'es','tras','',0,'','','','','','','','2002-11-29 15:40:17'),(507,'de','nachts','',0,'','','','','','','','2002-11-29 15:40:17'),(507,'es','de noche','',0,'','','','','','','','2002-11-29 15:40:17'),(508,'de','national','',0,'','','','staatlich','','','','2002-11-29 15:40:17'),(508,'es','nacional','',0,'','','','','','','','2002-11-29 15:40:17'),(509,'de','natürlich','',0,'','','','','','','','2002-11-29 15:40:17'),(509,'es','naturalmente','',0,'','','','','','','','2002-11-29 15:40:17'),(510,'de','natürlicher','',0,'','','','','','','','2002-11-29 15:40:17'),(510,'es','natural','',0,'','','','','','','','2002-11-29 15:40:17'),(511,'de','nehmen','',0,'','','','','','','','2002-11-29 15:40:17'),(511,'es','tomar','',0,'','','','','','','','2002-11-29 15:40:17'),(512,'de','neun','',0,'','','','','','','','2002-11-29 15:40:17'),(512,'es','nueve','',0,'','','','','','','','2002-11-29 15:40:17'),(513,'de','nicht','',0,'','','','','','','','2002-11-29 15:40:17'),(513,'es','no','',0,'','','','','','','','2002-11-29 15:40:17'),(514,'de','nicht ganz gut','',0,'','','','','','','','2002-11-29 15:40:17'),(514,'es','no bien del todo','',0,'','','','','','','','2002-11-29 15:40:17'),(515,'de','noch immer','',0,'','','','','','','','2002-11-29 15:40:17'),(515,'es','todavía','',0,'','','','','','','','2002-11-29 15:40:17'),(516,'de','normalerweise','',0,'','','','','','','','2002-11-29 15:40:17'),(516,'es','normalmente','',0,'','','','','','','','2002-11-29 15:40:17'),(517,'de','nur','',0,'','','','','','','','2002-11-29 15:40:17'),(517,'es','solamente','',0,'','','','','','','','2002-11-29 15:40:17'),(518,'de','nur','',0,'','','','','','','','2002-11-29 15:40:17'),(518,'es','sólo','',0,'','','','','','','','2002-11-29 15:40:17'),(519,'de','nächster','',0,'','','','','','','','2002-11-29 15:40:17'),(519,'es','próximo','',0,'','','','','','','','2002-11-29 15:40:17'),(520,'de','nützlich','',0,'','','','','','','','2002-11-29 15:40:17'),(520,'es','útil','',0,'','','','','','','','2002-11-29 15:40:17'),(521,'de','ob','',0,'','','','','','','','2002-11-29 15:40:17'),(521,'es','si','',0,'','','','','','','','2002-11-29 15:40:17'),(522,'de','obwohl','',0,'','','','','','','','2002-11-29 15:40:17'),(522,'es','aunque','',0,'','','','','','','','2002-11-29 15:40:17'),(523,'de','oder','',0,'','','','','','','','2002-11-29 15:40:17'),(523,'es','o','',0,'','','','','','','','2002-11-29 15:40:17'),(524,'de','oft','',0,'','','','','','','','2002-11-29 15:40:17'),(524,'es','muchas veces','',0,'','','','','','','','2002-11-29 15:40:17'),(525,'de','ohne','',0,'','','','','','','','2002-11-29 15:40:17'),(525,'es','sin','',0,'','','','','','','','2002-11-29 15:40:17'),(526,'de','organisiert','',0,'','','','','','','','2002-11-29 15:40:17'),(526,'es','organizado','',0,'','','','','','','','2002-11-29 15:40:17'),(527,'de','praktisch','',0,'','','','','','','','2002-11-29 15:40:17'),(527,'es','prácticamente','',0,'','','','','','','','2002-11-29 15:40:17'),(528,'de','preiswert','',0,'','','','','','','','2002-11-29 15:40:17'),(528,'es','económico','',0,'','','','','','','','2002-11-29 15:40:17'),(529,'de','Prozent','',0,'','','','','','','','2002-11-29 15:40:17'),(529,'es','por ciento','',0,'','','','','','','','2002-11-29 15:40:17'),(530,'de','prächtig','',0,'','','','','','','','2002-11-29 15:40:17'),(530,'es','grandioso','',0,'','','','','','','','2002-11-29 15:40:17'),(531,'de','pünktlich','',0,'','','','','','','','2002-11-29 15:40:17'),(531,'es','puntual','',0,'','','','','','','','2002-11-29 15:40:17'),(532,'de','rauchen','',0,'','','','','','','','2002-11-29 15:40:17'),(532,'es','fumar','',0,'','','','','','','','2002-11-29 15:40:17'),(533,'de','Recht haben','',0,'','','','','','','','2002-11-29 15:40:17'),(533,'es','tener razón','',0,'','','','','','','','2002-11-29 15:40:17'),(534,'de','rechts','',0,'','','','','','','','2002-11-29 15:40:17'),(534,'es','a la derecha','',0,'','','','','','','','2002-11-29 15:40:17'),(535,'de','regelmäßig','',0,'','','','','','','','2002-11-29 15:40:17'),(535,'es','regularmente','',0,'','','','','','','','2002-11-29 15:40:17'),(536,'de','regnen','',0,'','','','','','','','2002-11-29 15:40:17'),(536,'es','llover','',0,'','','','','','','','2002-11-29 15:40:17'),(537,'de','romanisch','',0,'','','','','','','','2002-11-29 15:40:17'),(537,'es','románico','',0,'','','','','','','','2002-11-29 15:40:17'),(538,'de','ruhig','',0,'','','','','','','','2002-11-29 15:40:17'),(538,'es','tranquilo','',0,'','','','','','','','2002-11-29 15:40:17'),(539,'de','sagen','',0,'','','','','','','','2002-11-29 15:40:17'),(539,'es','decir','',0,'','','','','','','','2002-11-29 15:40:17'),(540,'de','schlafen','',0,'','','','','','','','2002-11-29 15:40:17'),(540,'es','dormir','',0,'','','','','','','','2002-11-29 15:40:17'),(541,'de','schlecht','',0,'','','','','','','','2002-11-29 15:40:17'),(541,'es','malo','',0,'','','','','','','','2002-11-29 15:40:17'),(542,'de','schmeicheln','',0,'','','','','','','','2002-11-29 15:40:17'),(542,'es','halagar','',0,'','','','','','','','2002-11-29 15:40:17'),(543,'de','schmutzig','',0,'','','','','','','','2002-11-29 15:40:17'),(543,'es','sucio','',0,'','','','','','','','2002-11-29 15:40:17'),(544,'de','schnell','',0,'','','','','','','','2002-11-29 15:40:17'),(544,'es','rápido','',0,'','','','','','','','2002-11-29 15:40:17'),(545,'de','schon','',0,'','','','','','','','2002-11-29 15:40:17'),(545,'es','ya','',0,'','','','','','','','2002-11-29 15:40:17'),(546,'de','schwierig','',0,'','','','','','','','2002-11-29 15:40:17'),(546,'es','difícil','',0,'','','','','','','','2002-11-29 15:40:17'),(547,'de','schön','',0,'','','','','','','','2002-11-29 15:40:17'),(547,'es','bonito','',0,'','','','','','','','2002-11-29 15:40:17'),(548,'de','sechzig','',0,'','','','','','','','2002-11-29 15:40:17'),(548,'es','sesenta','',0,'','','','','','','','2002-11-29 15:40:17'),(549,'de','sehen','',0,'','','','','','','','2002-11-29 15:40:17'),(549,'es','ver','',0,'','','','','','','','2002-11-29 15:40:17'),(550,'de','sehr gut','',0,'','','','','','','','2002-11-29 15:40:17'),(550,'es','muy bien','',0,'','','','','','','','2002-11-29 15:40:17'),(551,'de','sein','',0,'','','','','','','','2002-11-29 15:40:17'),(551,'es','suyo','',0,'','','','','','','','2002-11-29 15:40:17'),(552,'de','sein','',0,'','','','','','','','2002-11-29 15:40:17'),(552,'es','estar','',0,'','','','','','','','2002-11-29 15:40:17'),(553,'de','sein','',0,'Herkunft, Material, Besitz, Form, Farbe','','','','','','','2002-11-29 15:40:17'),(553,'es','ser','',0,'','','','','','','','2002-11-29 15:40:17'),(554,'de','sein','',0,'sich befinden, sich fühlen','','','','','','','2002-11-29 15:40:17'),(554,'es','estar','',0,'','','','','','','','2002-11-29 15:40:17'),(555,'de','seitdem','',0,'','','','','','','','2002-11-29 15:40:17'),(555,'es','desde entonces','',0,'','','','','','','','2002-11-29 15:40:17'),(556,'de','selbst','',0,'','','','','','','','2002-11-29 15:40:17'),(556,'es','mismo','',0,'','','','','','','','2002-11-29 15:40:17'),(557,'de','seltsam','',0,'','','','','','','','2002-11-29 15:40:17'),(557,'es','extraño','',0,'','','','','','','','2002-11-29 15:40:17'),(558,'de','September','',0,'','','','','','','','2002-11-29 15:40:17'),(558,'es','septiembre','',0,'','','','','','','','2002-11-29 15:40:17'),(559,'de','sich befinden','',0,'','','','','','','','2002-11-29 15:40:17'),(559,'es','encontrarse','',0,'','','','','','','','2002-11-29 15:40:17'),(560,'de','sich erinnern','',0,'','','','','','','','2002-11-29 15:40:17'),(560,'es','acordarse','',0,'','','','','','','','2002-11-29 15:40:17'),(561,'de','sich freuen','',0,'','','','','','','','2002-11-29 15:40:17'),(561,'es','alegrarse','',0,'','','','','','','','2002-11-29 15:40:17'),(562,'de','sich unwohl fühlen','',0,'','','','','','','','2002-11-29 15:40:17'),(562,'es','sentirse disgusto','',0,'','','','','','','','2002-11-29 15:40:17'),(563,'de','sicher','',0,'','','','','','','','2002-11-29 15:40:17'),(563,'es','seguro','',0,'','','','','','','','2002-11-29 15:40:17'),(564,'de','sie sind mir zu klein','',0,'','','','','','','','2002-11-29 15:40:17'),(564,'es','me están pequeñas','',0,'','','','','','','','2002-11-29 15:40:17'),(565,'de','sieben','',0,'','','','','','','','2002-11-29 15:40:17'),(565,'es','siete','',0,'','','','','','','','2002-11-29 15:40:17'),(566,'de','so','',0,'','','','','','','','2002-11-29 15:40:17'),(566,'es','así','',0,'','','','','','','','2002-11-29 15:40:17'),(567,'de','so wie','',0,'so ... wie ...','','','','','','','2002-11-29 15:40:17'),(567,'es','tan como','',0,'','','','','','','','2002-11-29 15:40:17'),(568,'de','sondern','',0,'','','','','','','','2002-11-29 15:40:17'),(568,'es','sino','',0,'','','','','','','','2002-11-29 15:40:17'),(569,'de','soviel wie','',0,'soviel ... wie ...','','','','','','','2002-11-29 15:40:17'),(569,'es','tanto como','',0,'','','','','','','','2002-11-29 15:40:17'),(570,'de','soweit immer möglich','',0,'','','','','','','','2002-11-29 15:40:17'),(570,'es','a ser posible','',0,'','','','','','','','2002-11-29 15:40:17'),(571,'de','Spanien','',0,'','','','','','','','2002-11-29 15:40:17'),(571,'es','España','',0,'','','','','','','','2002-11-29 15:40:17'),(572,'de','sparen','',0,'','','','','','','','2002-11-29 15:40:17'),(572,'es','ahorrar','',0,'','','','','','','','2002-11-29 15:40:17'),(573,'de','sprechen','',0,'','','','','','','','2002-11-29 15:40:17'),(573,'es','hablar','',0,'','','','','','','','2002-11-29 15:40:17'),(574,'de','später','',0,'','','','','','','','2002-11-29 15:40:17'),(574,'es','más tarde','',0,'','','','','','','','2002-11-29 15:40:17'),(575,'de','staatlich','',0,'','','','','','','','2002-11-29 15:40:17'),(575,'es','estatal','',0,'','','','','','','','2002-11-29 15:40:17'),(576,'de','stellen','',0,'','','','','','','','2002-11-29 15:40:17'),(576,'es','poner','',0,'','','','','','','','2002-11-29 15:40:17'),(577,'de','studieren','',0,'','','','','','','','2002-11-29 15:40:17'),(577,'es','estudiar','',0,'','','','','','','','2002-11-29 15:40:17'),(578,'de','stören','',0,'','','','','','','','2002-11-29 15:40:17'),(578,'es','molestar','',0,'','','','','','','','2002-11-29 15:40:17'),(579,'de','sympatisch','',0,'','','','','','','','2002-11-29 15:40:17'),(579,'es','simpático','',0,'','','','','','','','2002-11-29 15:40:17'),(580,'de','Südamerika','',0,'','','','','','','','2002-11-29 15:40:17'),(580,'es','Sudamérica','',0,'','','','','','','','2002-11-29 15:40:17'),(581,'de','tatsächlich','',0,'','','','','','','','2002-11-29 15:40:17'),(581,'es','efectivamente','',0,'','','','','','','','2002-11-29 15:40:17'),(582,'de','tausend','',0,'','','','','','','','2002-11-29 15:40:17'),(582,'es','mil','',0,'','','','','','','','2002-11-29 15:40:17'),(583,'de','teuer','',0,'','','','','','','','2002-11-29 15:40:17'),(583,'es','caro','',0,'','','','','','','','2002-11-29 15:40:17'),(584,'de','trinken','',0,'','','','','','','','2002-11-29 15:40:17'),(584,'es','beber','',0,'','','','','','','','2002-11-29 15:40:17'),(585,'de','trotzdem','',0,'','','','','','','','2002-11-29 15:40:17'),(585,'es','sin embargo','',0,'','','','','','','','2002-11-29 15:40:17'),(586,'de','typisch','',0,'','','','','','','','2002-11-29 15:40:17'),(586,'es','típico','',0,'','','','','','','','2002-11-29 15:40:17'),(587,'de','täglich','',0,'','','','','','','','2002-11-29 15:40:17'),(587,'es','diario','',0,'','','','','','','','2002-11-29 15:40:17'),(588,'de','um','',0,'','','','','','','','2002-11-29 15:40:17'),(588,'es','a','',0,'','','','','','','','2002-11-29 15:40:17'),(589,'de','um diese Zeit','',0,'','','','','','','','2002-11-29 15:40:17'),(589,'es','a esta hora','',0,'','','','','','','','2002-11-29 15:40:17'),(590,'de','um Gottes willen','',0,'','','','','','','','2002-11-29 15:40:17'),(590,'es','por Dios','',0,'','','','','','','','2002-11-29 15:40:17'),(591,'de','umsteigen','',0,'','','','','','','','2002-11-29 15:40:17'),(591,'es','hacer transbordo','',0,'','','','','','','','2002-11-29 15:40:17'),(592,'de','umstritten','',0,'','','','','','','','2002-11-29 15:40:17'),(592,'es','discutido','',0,'','','','','','','','2002-11-29 15:40:17'),(593,'de','unabhängig','',0,'','','','','','','','2002-11-29 15:40:17'),(593,'es','independiente','',0,'','','','','','','','2002-11-29 15:40:17'),(594,'de','unbedeutend','',0,'','','','','','','','2002-11-29 15:40:17'),(594,'es','insignificante','',0,'','','','','','','','2002-11-29 15:40:17'),(595,'de','unbekannt','',0,'','','','','','','','2002-11-29 15:40:17'),(595,'es','desconocido','',0,'','','','','','','','2002-11-29 15:40:17'),(596,'de','ungefähr','',0,'','','','','','','','2002-11-29 15:40:17'),(596,'es','alrededor de','',0,'','','','','','','','2002-11-29 15:40:17'),(597,'de','unmittelbar','',0,'','','','','','','','2002-11-29 15:40:17'),(597,'es','inmediatamente','',0,'','','','','','','','2002-11-29 15:40:17'),(598,'de','unser','',0,'','','','','','','','2002-11-29 15:40:17'),(598,'es','nuestro','',0,'','','','','','','','2002-11-29 15:40:17'),(599,'de','unter anderem','',0,'','','','','','','','2002-11-29 15:40:17'),(599,'es','entre otros','',0,'','','','','','','','2002-11-29 15:40:17'),(600,'de','unterrichten','',0,'','','','','','','','2002-11-29 15:40:17'),(600,'es','enseñar','',0,'','','','','','','','2002-11-29 15:40:17'),(601,'de','unterscheiden','',0,'','','','','','','','2002-11-29 15:40:17'),(601,'es','distinguir','',0,'','','','','','','','2002-11-29 15:40:17'),(602,'de','unwiderstehlich','',0,'','','','','','','','2002-11-29 15:40:17'),(602,'es','irrestible','',0,'','','','','','','','2002-11-29 15:40:17'),(603,'de','verallgemeinert','',0,'','','','','','','','2002-11-29 15:40:17'),(603,'es','generalizado','',0,'','','','','','','','2002-11-29 15:40:17'),(604,'de','verboten','',0,'','','','','','','','2002-11-29 15:40:17'),(604,'es','prohibido','',0,'','','','','','','','2002-11-29 15:40:17'),(605,'de','vereinigen','',0,'','','','','','','','2002-11-29 15:40:17'),(605,'es','unir','',0,'','','','','','','','2002-11-29 15:40:17'),(606,'de','verhältnismäßig','',0,'','','','','','','','2002-11-29 15:40:17'),(606,'es','relativamente','',0,'','','','','','','','2002-11-29 15:40:17'),(607,'de','verkaufen','',0,'','','','','','','','2002-11-29 15:40:17'),(607,'es','vender','',0,'','','','','','','','2002-11-29 15:40:17'),(608,'de','verschieden','',0,'','','','','','','','2002-11-29 15:40:17'),(608,'es','variado','',0,'','','','','','','','2002-11-29 15:40:17'),(609,'de','verstehen','',0,'','','','','','','','2002-11-29 15:40:17'),(609,'es','entender','',0,'','','','','','','','2002-11-29 15:40:17'),(610,'de','verstehen','',0,'','','','','','','','2002-11-29 15:40:17'),(610,'es','comprender','',0,'','','','','','','','2002-11-29 15:40:17'),(611,'de','versuchen','',0,'','','','','','','','2002-11-29 15:40:17'),(611,'es','probar','',0,'','','','','','','','2002-11-29 15:40:17'),(612,'de','verursachen','',0,'','','','','','','','2002-11-29 15:40:17'),(612,'es','originar','',0,'','','','','','','','2002-11-29 15:40:17'),(613,'de','verzeihen','',0,'','','','','Entschuldigen Sie.','','','2002-11-29 15:40:17'),(613,'es','perdonar','',0,'','','','','Perdonen.','','','2002-11-29 15:40:17'),(614,'de','Verzeihung','',0,'','','','','','','','2002-11-29 15:40:17'),(614,'es','perdón','',0,'','','','','','','','2002-11-29 15:40:17'),(615,'de','viele','',0,'','','','','','','','2002-11-29 15:40:17'),(615,'es','muchos','',0,'','','','','','','','2002-11-29 15:40:17'),(616,'de','vier','',0,'','','','','','','','2002-11-29 15:40:17'),(616,'es','cuatro','',0,'','','','','','','','2002-11-29 15:40:17'),(617,'de','voll','',0,'','','','','','','','2002-11-29 15:40:17'),(617,'es','lleno','',0,'','','','','','','','2002-11-29 15:40:17'),(618,'de','von','',0,'','','','','','','','2002-11-29 15:40:17'),(618,'es','de','',0,'','','','','','','','2002-11-29 15:40:17'),(619,'de','vor','',0,'','','','','','','','2002-11-29 15:40:17'),(619,'es','antes de','',0,'','','','delante de','','','','2002-11-29 15:40:17'),(620,'de','vor Christus','',0,'','','','','','','','2002-11-29 15:40:17'),(620,'es','antes de Cristo','',0,'','','','','','','','2002-11-29 15:40:17'),(621,'de','vorstellen','',0,'','','','','','','','2002-11-29 15:40:17'),(621,'es','presentar','',0,'','','','','','','','2002-11-29 15:40:17'),(622,'de','vorziehen','',0,'','','','','','','','2002-11-29 15:40:17'),(622,'es','preferir','',0,'','','','','','','','2002-11-29 15:40:17'),(623,'de','wann','',0,'','','','','','','','2002-11-29 15:40:17'),(623,'es','cuándo','',0,'','','','','','','','2002-11-29 15:40:17'),(624,'de','warten','',0,'','','','','','','','2002-11-29 15:40:17'),(624,'es','esperar','',0,'','','','','','','','2002-11-29 15:40:17'),(625,'de','warum','',0,'','','','','','','','2002-11-29 15:40:17'),(625,'es','por qué','',0,'','','','','','','','2002-11-29 15:40:17'),(626,'de','was','',0,'','','','','','','','2002-11-29 15:40:17'),(626,'es','qué','',0,'','','','','','','','2002-11-29 15:40:17'),(627,'de','was gibt es','',0,'','','','','','','','2002-11-29 15:40:17'),(627,'es','qué hay','',0,'','','','','','','','2002-11-29 15:40:17'),(628,'de','was ist das','',0,'','','','','','','','2002-11-29 15:40:17'),(628,'es','qué es eso','',0,'','','','','','','','2002-11-29 15:40:17'),(629,'de','wechseln','',0,'','','','','','','','2002-11-29 15:40:17'),(629,'es','cambiar','',0,'','','','','','','','2002-11-29 15:40:17'),(630,'de','weil','',0,'','','','','','','','2002-11-29 15:40:17'),(630,'es','porque','',0,'','','','','','','','2002-11-29 15:40:17'),(631,'de','weit weg','',0,'','','','','','','','2002-11-29 15:40:17'),(631,'es','lejos','',0,'','','','','','','','2002-11-29 15:40:17'),(632,'de','weiterer','',0,'','','','anderer','','','','2002-11-29 15:40:17'),(632,'es','otro','',0,'','','','','','','','2002-11-29 15:40:17'),(633,'de','welche','',0,'','','','','','','','2002-11-29 15:40:17'),(633,'es','cuál','',0,'','','','','','','','2002-11-29 15:40:17'),(634,'de','wenn','',0,'','','','','','','','2002-11-29 15:40:17'),(634,'es','cuando','',0,'','','','','','','','2002-11-29 15:40:17'),(635,'de','wer','',0,'','','','','Wer is Pablo Picasso?','','','2002-11-29 15:40:17'),(635,'es','quién','',0,'','','','','¿Quién es Pablo Picasso?','','','2002-11-29 15:40:17'),(636,'de','wichtig','',0,'','','','','','','','2002-11-29 15:40:17'),(636,'es','importante','',0,'','','','','','','','2002-11-29 15:40:17'),(637,'de','wie geht es','',0,'','','','','','','','2002-11-29 15:40:17'),(637,'es','cómo va eso','',0,'','','','','','','','2002-11-29 15:40:17'),(638,'de','wie lange','',0,'','','','','','','','2002-11-29 15:40:17'),(638,'es','cuánto tiempo','',0,'','','','','','','','2002-11-29 15:40:17'),(640,'de','wiederholen','',0,'','','','','','','','2002-11-29 15:40:17'),(640,'es','repasar','',0,'','','','','','','','2002-11-29 15:40:17'),(641,'de','wieviel','',0,'','','','','','','','2002-11-29 15:40:17'),(641,'es','cuánto','',0,'','','','','','','','2002-11-29 15:40:17'),(642,'de','willkommen','',0,'','','','','','','','2002-11-29 15:40:17'),(642,'es','bienvenidos','',0,'','','','','','','','2002-11-29 15:40:17'),(643,'de','wissen','',0,'','','','','','','','2002-11-29 15:40:17'),(643,'es','saber','',0,'','','','','','','','2002-11-29 15:40:17'),(644,'de','witzig','',0,'','','','','','','','2002-11-29 15:40:17'),(644,'es','gracioso','',0,'','','','','','','','2002-11-29 15:40:17'),(645,'de','wo','',0,'','','','','','','','2002-11-29 15:40:17'),(645,'es','dónde','',0,'','','','','','','','2002-11-29 15:40:17'),(646,'de','wollen','',0,'','','','','','','','2002-11-29 15:40:17'),(646,'es','querer','',0,'','','','','','','','2002-11-29 15:40:17'),(647,'de','wunderschön','',0,'','','','','','','','2002-11-29 15:40:17'),(647,'es','maravilloso','',0,'','','','','','','','2002-11-29 15:40:17'),(648,'de','wählen','',0,'Telefon','','','markieren','','','','2002-11-29 15:40:17'),(648,'es','marcar','',0,'','','','','','','','2002-11-29 15:40:17'),(649,'de','während','',0,'','','','','','','','2002-11-29 15:40:17'),(649,'es','durante','',0,'','','','','','','','2002-11-29 15:40:17'),(650,'de','wünschen','',0,'','','','','','','','2002-11-29 15:40:17'),(650,'es','desear','',0,'','','','','','','','2002-11-29 15:40:17'),(651,'de','zahlen','',0,'','','','','','','','2002-11-29 15:40:17'),(651,'es','pagar','',0,'','','','','','','','2002-11-29 15:40:17'),(652,'de','zu Abend essen','',0,'','','','','','','','2002-11-29 15:40:17'),(652,'es','cenar','',0,'','','','','','','','2002-11-29 15:40:17'),(653,'de','zu Fuß gehen','',0,'','','','','','','','2002-11-29 15:40:17'),(653,'es','ir a pie','',0,'','','','','','','','2002-11-29 15:40:17'),(654,'de','zuerst','',0,'','','','','','','','2002-11-29 15:40:17'),(654,'es','primero','',0,'','','','','','','','2002-11-29 15:40:17'),(655,'de','zuhören','',0,'','','','','','','','2002-11-29 15:40:17'),(655,'es','escuchar','',0,'','','','','','','','2002-11-29 15:40:17'),(656,'de','zum Beispiel','',0,'','','','','','','','2002-11-29 15:40:17'),(656,'es','por ejemplo','',0,'','','','','','','','2002-11-29 15:40:17'),(657,'de','zumindest','',0,'','','','','','','','2002-11-29 15:40:17'),(657,'es','al menos','',0,'','','','','','','','2002-11-29 15:40:17'),(658,'de','zurückhaltend','',0,'','','','','','','','2002-11-29 15:40:17'),(658,'es','reservado','',0,'','','','','','','','2002-11-29 15:40:17'),(659,'de','zweihundert','',0,'','','','','','','','2002-11-29 15:40:17'),(659,'es','doscientos','',0,'','','','','','','','2002-11-29 15:40:17'),(660,'de','öffnen','',0,'','','','','','','','2002-11-29 15:40:17'),(660,'es','abrir','',0,'','','','','','','','2002-11-29 15:40:17'),(661,'de','üben','',0,'','','','','','','','2002-11-29 15:40:17'),(661,'es','practicar','',0,'','','','','','','','2002-11-29 15:40:17'),(662,'de','überraschen','',0,'','','','','','','','2002-11-29 15:40:17'),(662,'es','sorprendir','',0,'','','','','','','','2002-11-29 15:40:17'),(663,'de','übersetzen','',0,'','','','','','','','2002-11-29 15:40:17'),(663,'es','traducir','',0,'','','','','','','','2002-11-29 15:40:17'),(664,'de','übertreiben','',0,'','','','','','','','2002-11-29 15:40:17'),(664,'es','exagerar','',0,'','','','','','','','2002-11-29 15:40:17'),(665,'de','Maler','',1,'','','','','','','','2002-11-29 15:40:17'),(665,'es','pintor','',1,'','','','','','','','2002-11-29 15:40:17'),(666,'de','Hund','der',1,'','','','','','','','2002-11-29 15:40:17'),(666,'es','perro','el',1,'','','','','','','','2002-11-29 15:40:17'),(798,'de','Koch','der',1,'','','','','','','','2002-12-04 14:46:51'),(824,'de','viel','',1,'','','','','','','','2002-12-04 17:55:07'),(915,'es','lástima','',1,'','','','','','','','2002-12-06 14:51:45'),(915,'de','schade','',1,'','','','','','','','2002-12-06 14:51:45'),(667,'de','Wie geht\'s?','',1,'','','','','','','','2002-12-04 10:52:26'),(667,'es','¿Qué tal?','',1,'','','','','','','','2002-12-04 10:52:26'),(668,'de','Autor','der',1,'','','','','','','','2002-12-04 11:05:26'),(668,'es','autor','el',1,'','','','','','','','2002-12-04 11:05:26'),(669,'de','und','',1,'','','','','','','','2002-12-04 11:06:46'),(669,'es','y','',1,'','','','','','','','2002-12-04 11:06:46'),(670,'de','du','',1,'','','','','','','','2002-12-04 11:16:22'),(670,'es','tú','',1,'','','','','','','','2002-12-04 11:16:22'),(671,'de','Sie','',1,'','','','','','','','2002-12-04 11:18:53'),(671,'es','usted','',1,'','','','','','','','2002-12-04 11:18:53'),(672,'de','Wie heißen Sie?','',1,'','','','','','','','2002-12-04 11:19:34'),(672,'es','¿Cómo se llama usted?','',1,'','','','','','','','2002-12-04 11:19:34'),(673,'de','Wie heißt du?','',1,'','','','','','','','2002-12-04 11:20:09'),(673,'es','¿Cómo te llamas?','',1,'','','','','','','','2002-12-04 11:20:09'),(674,'de','Bis bald.','',1,'','','','','','','','2002-12-04 11:21:25'),(674,'es','Hasta luego.','',1,'','','','','','','','2002-12-04 11:21:25'),(675,'de','Tag','der',1,'','','','','','','','2002-12-04 11:22:43'),(675,'es','día','el',1,'','','','','','','','2002-12-04 11:22:43'),(676,'de','Guten Abend','',1,'','','','Gute Nacht','','','','2002-12-04 11:23:20'),(676,'es','Buenas noches','',1,'','','','','','','','2002-12-04 11:23:20'),(677,'de','Übung','die',1,'','','','','','','','2002-12-04 11:25:05'),(677,'es','ejercicio','el',1,'','','','','','','','2002-12-04 11:25:05'),(678,'de','Welt','die',1,'','','','','','','','2002-12-04 11:25:34'),(678,'es','mundo','el',1,'','','','','','','','2002-12-04 11:25:34'),(679,'de','Einheit','die',1,'','','','Lektion','','','','2002-12-04 11:27:03'),(679,'es','unidad','la',1,'','','','','','','','2002-12-04 11:27:03'),(680,'de','USA','',1,'','','','','','','','2002-12-04 11:27:47'),(680,'es','Estados Unidios','',1,'E.E.U.U.','','','','','','','2002-12-04 11:27:47'),(681,'de','Krankenhaus','das',1,'','','','','','','','2002-12-04 11:34:09'),(681,'es','hospital','el',1,'','','','','','','','2002-12-04 11:34:09'),(682,'de','Familie','die',1,'','','','','','','','2002-12-04 11:34:42'),(682,'es','familia','la',1,'','','','','','','','2002-12-04 11:34:42'),(683,'de','international','',1,'','','','','','','','2002-12-04 11:35:21'),(683,'es','internacional','',1,'','','','','','','','2002-12-04 11:35:21'),(684,'de','Industrie','die',1,'','','','','','','','2002-12-04 11:35:41'),(684,'es','industria','la',1,'','','','','','','','2002-12-04 11:35:41'),(685,'de','Musiker','der',1,'','','','','','','','2002-12-04 11:36:23'),(685,'es','músico','el',1,'','','','','','','','2002-12-04 11:36:23'),(686,'de','Produktion','die',1,'','','','','','','','2002-12-04 11:36:57'),(686,'es','produccíon','la',1,'','','','','','','','2002-12-04 11:36:57'),(687,'de','Fernsehen','das',1,'','','','','','','','2002-12-04 11:39:03'),(687,'es','televisión','la',1,'','','','','','','','2002-12-04 11:39:03'),(688,'de','Produkt','das',1,'','','','','','','','2002-12-04 11:43:01'),(688,'es','producto','el',1,'','','','','','','','2002-12-04 11:43:01'),(689,'de','neu','',1,'','','','','','','','2002-12-04 11:43:56'),(689,'es','nuevo','',1,'','','','','','','','2002-12-04 11:43:56'),(690,'de','Musik','die',1,'','','','','','','','2002-12-04 11:44:23'),(690,'es','música','la',1,'','','','','','','','2002-12-04 11:44:23'),(691,'de','Dialog','der',1,'','','','','','','','2002-12-04 11:44:51'),(691,'es','diálogo','el',1,'','','','','','','','2002-12-04 11:44:51'),(692,'de','ein','',1,'','','','','','','','2002-12-04 11:45:13'),(692,'es','un','',1,'','','','','','','','2002-12-04 11:45:13'),(693,'de','aussprechen','',1,'','','','','','','','2002-12-04 11:46:56'),(693,'es','pronunciar','',1,'','','','','¿Cómo se pronuncia ... ?','','','2002-12-04 11:46:56'),(694,'de','Person','die',1,'','','','','','','','2002-12-04 11:48:02'),(694,'es','persona','la',1,'','','','','','','','2002-12-04 11:48:02'),(695,'de','Politiker','der',1,'','','','','','','','2002-12-04 11:48:56'),(695,'es','politico','el',1,'','','','','','','','2002-12-04 11:48:56'),(696,'de','Sänger','der',1,'','','','','','','','2002-12-04 11:49:42'),(696,'es','cantante','el',1,'fem: la cantante','','','','','','','2002-12-04 11:49:42'),(697,'de','Nummer','die',1,'','','','','','','','2002-12-04 11:50:32'),(697,'es','número','el',1,'','','','','','','','2002-12-04 11:50:32'),(698,'de','Präsident','der',1,'','','','','','','','2002-12-04 11:51:14'),(698,'es','presidente','el',1,'fem.: la presidenta','','','','','','','2002-12-04 11:51:14'),(699,'de','der','',1,'','','','','','','','2002-12-04 11:51:33'),(699,'es','el','',1,'','','','','','','','2002-12-04 11:51:33'),(700,'de','die','',1,'','','','','','','','2002-12-04 11:51:52'),(700,'es','la','',1,'','','','','','','','2002-12-04 11:51:52'),(701,'de','Ich weiß nicht.','',1,'','','','','','','','2002-12-04 11:53:38'),(701,'es','No sé.','',1,'','','','','','','','2002-12-04 11:53:38'),(702,'de','männlich','',1,'','','','','','','','2002-12-04 11:54:03'),(702,'es','masculino','',1,'','','','','','','','2002-12-04 11:54:03'),(703,'de','weiblich','',1,'','','','','','','','2002-12-04 11:54:39'),(703,'es','femenino','',1,'','','','','','','','2002-12-04 11:54:39'),(704,'de','Anruf','',1,'','','','Telefonanruf','','','','2002-12-04 11:56:00'),(704,'es','llamada','',1,'','','','','','','','2002-12-04 11:56:00'),(705,'de','Woche','die',1,'','','','','','','','2002-12-04 11:56:26'),(705,'es','semana','la',1,'','','','','','','','2002-12-04 11:56:26'),(706,'de','vergangen','',1,'','','','','','','','2002-12-04 11:57:00'),(706,'es','pasado','',1,'','','','','','','','2002-12-04 11:57:00'),(707,'de','Foto','das',1,'','','','','','','','2002-12-04 11:58:05'),(707,'es','foto','el',1,'','','','','','','','2002-12-04 11:58:05'),(708,'de','Feuer','das',1,'','','','','','','','2002-12-04 11:59:04'),(708,'es','fuego','el',1,'','','','','','','','2002-12-04 11:59:04'),(709,'de','Moment','der',1,'','','','Augenblick','','','','2002-12-04 11:59:29'),(709,'es','momento','el',1,'','','','','','','','2002-12-04 11:59:29'),(710,'de','Büro','das',1,'','','','','','','','2002-12-04 12:00:05'),(710,'es','oficina','la',1,'','','','','','','','2002-12-04 12:00:06'),(711,'de','Reporter','der',1,'','','','','','','','2002-12-04 12:00:50'),(711,'es','reportero','el',1,'','','','','','','','2002-12-04 12:00:50'),(712,'de','Reportage','die',1,'','','','','','','','2002-12-04 12:02:19'),(712,'es','reportaje','el',1,'','','','','','','','2002-12-04 12:02:19'),(713,'de','Arbeit','die',1,'','','','','','','','2002-12-04 12:02:51'),(713,'es','trabajo','el',1,'','','','','','','','2002-12-04 12:02:51'),(714,'de','Fotograf','der',1,'','','','','','','','2002-12-04 12:03:23'),(714,'es','fotógrafo','el',1,'','','','','','','','2002-12-04 12:03:23'),(715,'de','Radio','das',1,'','','','','','','','2002-12-04 12:04:01'),(715,'es','radio','la',1,'','','','','','','','2002-12-04 12:04:01'),(716,'de','Herr','der',1,'','','','','','','','2002-12-04 12:04:40'),(716,'es','señor','el',1,'','','','','','','','2002-12-04 12:04:40'),(717,'de','Dame','die',1,'','','','','','','','2002-12-04 12:05:11'),(717,'es','señora','la',1,'','','','','','','','2002-12-04 12:05:11'),(718,'de','Prüfung','die',1,'','','','','','','','2002-12-04 12:05:47'),(718,'es','examen','el',1,'','','','','','','','2002-12-04 12:05:47'),(719,'de','Silbe','die',1,'','','','','die betonte S.','','','2002-12-04 12:07:43'),(719,'es','silaba','la',1,'','','','','la silaba fuerte','','','2002-12-04 12:07:43'),(720,'de','über','',1,'','','','','','','','2002-12-04 12:08:19'),(720,'es','sobre','',1,'','','','','','','','2002-12-04 12:08:19'),(721,'de','wie','',1,'','','','','','','','2002-12-04 12:47:09'),(721,'es','como','',1,'','','','','','','','2002-12-04 12:47:09'),(722,'de','Beispiel','das',1,'','','','','','','','2002-12-04 12:48:40'),(722,'es','ejemplo','el',1,'','','','','','','','2002-12-04 12:48:40'),(723,'de','Begegnung','die',1,'','','','','','','','2002-12-04 12:58:28'),(723,'es','encuentro','el',1,'','','','','','','','2002-12-04 12:58:28'),(724,'de','Mechaniker','der',1,'','','','','','','','2002-12-04 13:00:42'),(724,'es','mecánicio','el',1,'','','','','','','','2002-12-04 13:00:42'),(725,'de','Beruf','der',1,'','','','','','','','2002-12-04 13:02:02'),(725,'es','profesión','la',1,'','','','','','','','2002-12-04 13:02:02'),(726,'de','Architekt','der',1,'','','','','','','','2002-12-04 13:06:58'),(726,'es','arqitecto','el',1,'','','','','','','','2002-12-04 13:06:58'),(727,'de','Angenehm','',1,'','','','','','','','2002-12-04 13:08:36'),(727,'es','Mucho gusto','',1,'','','','','','','','2002-12-04 13:08:36'),(728,'de','begeistern','',1,'','','','','sehr erfreut','','','2002-12-04 13:10:00'),(728,'es','encantar','',1,'','','','','encantado/a','','','2002-12-04 13:10:00'),(729,'de','nicht wahr','',1,'','','','','','','','2002-12-04 13:10:51'),(729,'es','¿verdad?','',1,'','','','','','','','2002-12-04 13:10:51'),(730,'de','Bis morgen.','',1,'','','','','','','','2002-12-04 13:12:07'),(730,'es','Hasta mañana.','',1,'','','','','','','','2002-12-04 13:12:07'),(731,'de','Wie geht es Ihnen?','',1,'','','','','','','','2002-12-04 13:14:50'),(731,'es','¿Cómo está usted?','',1,'','','','','','','','2002-12-04 13:14:50'),(732,'de','Woher kommst du?','',1,'','','','','','','','2002-12-04 13:15:49'),(732,'es','¿De dónde eres?','',1,'','','','','','','','2002-12-04 13:15:49'),(733,'de','suchen','',1,'','','','','','','','2002-12-04 13:16:28'),(733,'es','buscar','',1,'','','','','','','','2002-12-04 13:16:28'),(734,'de','Seite','die',1,'','','','','','','','2002-12-04 13:16:50'),(734,'es','página','la',1,'','','','','','','','2002-12-04 13:16:50'),(735,'de','Wie geht es dir?','',1,'','','','','','','','2002-12-04 13:18:52'),(735,'es','¿Cómo estás?','',1,'','','','','','','','2002-12-04 13:18:52'),(736,'de','Es geht so','',1,'','','','','','','','2002-12-04 13:19:21'),(736,'es','Regular','',1,'','','','','','','','2002-12-04 13:19:21'),(737,'de','betrachten','',1,'','','','ansehen','','','','2002-12-04 13:20:46'),(737,'es','mirar','',1,'','','','','','','','2002-12-04 13:20:46'),(738,'de','schreiben','',1,'','','','','','','','2002-12-04 13:22:05'),(738,'es','escribir','',1,'','','','','','','','2002-12-04 13:22:05'),(739,'de','Alphabet','das',1,'','','','','','','','2002-12-04 13:23:37'),(739,'es','alfabeto','el',1,'','','','','','','','2002-12-04 13:23:37'),(740,'de','Akzent','der',1,'','','','','','','','2002-12-04 13:24:09'),(740,'es','acento','el',1,'','','','','','','','2002-12-04 13:24:09'),(741,'de','Großbuchstabe','der',1,'','','','','','','','2002-12-04 13:25:00'),(741,'es','mayúscula','la',1,'','','','','','','','2002-12-04 13:25:00'),(742,'de','Kleinbuchstabe','',1,'','','','','','','','2002-12-04 13:26:09'),(742,'es','minúscula','',1,'','','','','','','','2002-12-04 13:26:09'),(743,'de','Kasette','die',1,'','','','','','','','2002-12-04 13:26:51'),(743,'es','casete','la',1,'','','','','','','','2002-12-04 13:26:51'),(744,'de','eins','',1,'','','','','','','','2002-12-04 13:32:33'),(744,'es','uno','',1,'','','','','','','','2002-12-04 13:32:33'),(745,'de','zwei','',1,'','','','','','','','2002-12-04 13:33:27'),(745,'es','dos','',1,'','','','','','','','2002-12-04 13:33:27'),(746,'de','fünf','',1,'','','','','','','','2002-12-04 13:35:21'),(746,'es','cinco','',1,'','','','','','','','2002-12-04 13:35:21'),(747,'de','sechs','',1,'','','','','','','','2002-12-04 13:36:12'),(747,'es','seis','',1,'','','','','','','','2002-12-04 13:36:12'),(748,'de','acht','',1,'','','','','','','','2002-12-04 13:36:54'),(748,'es','ocho','',1,'','','','','','','','2002-12-04 13:36:54'),(749,'de','zehn','',1,'','','','','','','','2002-12-04 13:37:22'),(749,'es','diez','',1,'','','','','','','','2002-12-04 13:37:22'),(750,'de','elf','',1,'','','','','','','','2002-12-04 13:37:43'),(750,'es','once','',1,'','','','','','','','2002-12-04 13:37:43'),(751,'de','null','',1,'','','','','','','','2002-12-04 13:38:07'),(751,'es','cero','',1,'','','','','','','','2002-12-04 13:38:07'),(752,'de','zwölf','',1,'','','','','','','','2002-12-04 13:39:05'),(752,'es','doce','',1,'','','','','','','','2002-12-04 13:39:05'),(753,'de','fünfzehn','',1,'','','','','','','','2002-12-04 13:40:15'),(753,'es','quince','',1,'','','','','','','','2002-12-04 13:40:15'),(754,'de','vierzehn','',1,'','','','','','','','2002-12-04 13:41:08'),(754,'es','catorce','',1,'','','','','','','','2002-12-04 13:41:08'),(755,'de','sechszehn','',1,'','','','','','','','2002-12-04 13:41:38'),(755,'es','dieciséis','',1,'','','','','','','','2002-12-04 13:41:38'),(756,'de','siebzehn','',1,'','','','','','','','2002-12-04 13:42:10'),(756,'es','diecisiete','',1,'','','','','','','','2002-12-04 13:42:10'),(757,'de','achtzehn','',1,'','','','','','','','2002-12-04 13:42:33'),(757,'es','dieciocho','',1,'','','','','','','','2002-12-04 13:42:33'),(758,'de','neunzehn','',1,'','','','','','','','2002-12-04 13:43:03'),(758,'es','diecinueve','',1,'','','','','','','','2002-12-04 13:43:03'),(759,'de','zwanzig','',1,'','','','','','','','2002-12-04 13:43:41'),(759,'es','veinte','',1,'','','','','','','','2002-12-04 13:43:41'),(760,'de','dreißig','',1,'','','','','','','','2002-12-04 13:44:22'),(760,'es','treinta','',1,'','','','','','','','2002-12-04 13:44:22'),(761,'de','vierzig','',1,'','','','','','','','2002-12-04 13:44:49'),(761,'es','cuarenta','',1,'','','','','','','','2002-12-04 13:44:49'),(762,'de','siebzig','',1,'','','','','','','','2002-12-04 13:46:05'),(762,'es','setenta','',1,'','','','','','','','2002-12-04 13:46:05'),(763,'de','achzig','',1,'','','','','','','','2002-12-04 13:46:30'),(763,'es','ochenta','',1,'','','','','','','','2002-12-04 13:46:30'),(764,'de','neunzig','',1,'','','','','','','','2002-12-04 13:46:43'),(764,'es','noventa','',1,'','','','','','','','2002-12-04 13:46:43'),(765,'de','Kurs','der',1,'','','','','','','','2002-12-04 14:00:39'),(765,'es','curso','el',1,'','','','','','','','2002-12-04 14:00:39'),(766,'de','lang','',1,'','','','','','','','2002-12-04 14:01:34'),(766,'es','larga','',1,'','','','','','','','2002-12-04 14:01:34'),(767,'de','kurz','',1,'','','','','','','','2002-12-04 14:02:33'),(767,'es','corta','',1,'','','','','','','','2002-12-04 14:02:33'),(768,'de','Was machen Sie?','',1,'beruflich','','','','','','','2002-12-04 14:03:20'),(768,'es','¿Qué hace usted?','',1,'inf: hacer','','','','','','','2002-12-04 14:03:20'),(769,'de','Firma','',1,'','','','Unternehmen','','','','2002-12-04 14:03:55'),(769,'es','empresa','',1,'','','','','','','','2002-12-04 14:03:55'),(770,'de','Zeichner','der',1,'','','','','','','','2002-12-04 14:18:54'),(770,'es','dibuchante','el',1,'','','','','','','','2002-12-04 14:18:54'),(771,'de','unerlässlich','',1,'','','','','','','','2002-12-04 14:19:56'),(771,'es','indispensable','',1,'','','','','','','','2002-12-04 14:19:56'),(772,'de','Erfahrung','die',1,'','','','','','','','2002-12-04 14:21:05'),(772,'es','experiencia','la',1,'','','','','','','','2002-12-04 14:21:05'),(773,'de','Verfügbarkeit','',1,'','','','','','','','2002-12-04 14:21:53'),(773,'es','disponibilidad','',1,'','','','','','','','2002-12-04 14:21:53'),(774,'de','Arzt','der',1,'','','','','','','','2002-12-04 14:25:05'),(774,'es','médico','el',1,'','','','','','','','2002-12-04 14:25:05'),(775,'de','Konstrukteur','',1,'','','','','','','','2002-12-04 14:25:30'),(775,'es','constructor','',1,'','','','','','','','2002-12-04 14:25:30'),(776,'de','Verteter','',1,'','','','','','','','2002-12-04 14:26:03'),(776,'es','representante','',1,'','','','','','','','2002-12-04 14:26:03'),(777,'de','Krankenpfleger','der',1,'','','','','','','','2002-12-04 14:27:28'),(777,'es','enfermero','el',1,'','','','','','','','2002-12-04 14:27:28'),(778,'de','Kassierer','der',1,'','','','','','','','2002-12-04 14:28:46'),(778,'es','cajero','el',1,'','','','','','','','2002-12-04 14:28:46'),(779,'de','Supermarkt','der',1,'','','','','','','','2002-12-04 14:29:41'),(779,'es','supermercado','el',1,'','','','','','','','2002-12-04 14:29:41'),(780,'de','Alter','das',1,'','','','','','','','2002-12-04 14:30:14'),(780,'es','edad','la',1,'','','','','','','','2002-12-04 14:30:14'),(781,'de','Biologe','der',1,'','','','','','','','2002-12-04 14:31:46'),(781,'es','biólogo','el',1,'','','','','','','','2002-12-04 14:31:46'),(782,'de','um zu arbeiten','',1,'','','','','','','','2002-12-04 14:32:00'),(782,'es','para trabajar','',1,'','','','','','','','2002-12-04 14:32:00'),(783,'de','Chaffeur','der',1,'','','','Fahrer','','','','2002-12-04 14:32:58'),(783,'es','chófer','el',1,'','','','','','','','2002-12-04 14:32:58'),(784,'de','Ingenieur','der',1,'','','','','','','','2002-12-04 14:33:38'),(784,'es','ingeniero','el',1,'','','','','','','','2002-12-04 14:33:38'),(785,'de','Bedienung','die',1,'','','','','','','','2002-12-04 14:34:42'),(785,'es','manejo','el',1,'','','','','','','','2002-12-04 14:34:42'),(786,'de','Programmierung','die',1,'','','','','','','','2002-12-04 14:35:10'),(786,'es','programación','la',1,'','','','','','','','2002-12-04 14:35:10'),(787,'de','Sekretär','der',1,'','','','','','','','2002-12-04 14:35:44'),(787,'es','secretario','el',1,'','','','','','','','2002-12-04 14:35:44'),(788,'de','Rechtsanwalt','der',1,'','','','Anwalt','','','','2002-12-04 14:36:38'),(788,'es','abogado','el',1,'','','','','','','','2002-12-04 14:36:38'),(789,'de','Pförtner','der',1,'','','','Hausmeister','','','','2002-12-04 14:37:48'),(789,'es','portero','el',1,'','','','','','','','2002-12-04 14:37:48'),(790,'de','sich vorstellen','',1,'','','','','','','','2002-12-04 14:38:14'),(790,'es','presentarse','',1,'','','','','','','','2002-12-04 14:38:14'),(791,'de','Lebenslauf','der',1,'','','','','','','','2002-12-04 14:38:50'),(791,'es','curriculum','el',1,'','','','','','','','2002-12-04 14:38:50'),(792,'de','Zertifikat','das',1,'','','','Zeugnis','','','','2002-12-04 14:39:26'),(792,'es','certificado','el',1,'','','','','','','','2002-12-04 14:39:26'),(793,'de','Zahnarzt','der',1,'','','','','','','','2002-12-04 14:40:25'),(793,'es','dentista','el',1,'fem: la dentista','','','','','','','2002-12-04 14:40:25'),(794,'de','einige','',1,'','','','','','','','2002-12-04 14:41:22'),(794,'es','unos','',1,'fem: unas','','','','','','','2002-12-04 14:41:22'),(817,'es','lindo','',1,'','','','','','','','2002-12-04 15:10:14'),(817,'de','schön','',1,'','','','','','','','2002-12-04 15:10:14'),(796,'de','Klasse','die',1,'','','','','','','','2002-12-04 14:42:24'),(796,'es','clase','la',1,'','','','','','','','2002-12-04 14:42:25'),(797,'de','Kollege','der',1,'','','','','','','','2002-12-04 14:43:22'),(797,'es','compañero','el',1,'','','','','','','','2002-12-04 14:43:22'),(799,'de','Wie schade!','',1,'','','','','','','','2002-12-04 14:48:53'),(799,'es','¡Qué lástima!','',1,'','','','','','','','2002-12-04 14:48:53'),(800,'de','Wie schön','',1,'','','','','','','','2002-12-04 14:50:40'),(800,'es','¡Qué bien!','',1,'','','','','','','','2002-12-04 14:50:40'),(801,'de','Freund','der',1,'','','','','','','','2002-12-04 14:52:19'),(801,'es','novio','el',1,'','','','','','','','2002-12-04 14:52:19'),(802,'de','Hausfrau','die',1,'','','','','','','','2002-12-04 14:52:48'),(802,'es','ama de casa','la',1,'','','','','','','','2002-12-04 14:52:48'),(803,'de','Sohn','der',1,'','','','','','','','2002-12-04 14:53:25'),(803,'es','hijo','el',1,'','','','','','','','2002-12-04 14:53:25'),(804,'de','Tochter','die',1,'','','','','','','','2002-12-04 14:53:46'),(804,'es','hija','la',1,'','','','','','','','2002-12-04 14:53:46'),(805,'de','Kinder','die',1,'','','','','','','','2002-12-04 14:54:15'),(805,'es','hijos','los',1,'','','','','','','','2002-12-04 14:54:15'),(806,'de','verheiratet','',1,'','','','','er ist verheiratet (mit)','','','2002-12-04 14:55:30'),(806,'es','casado','',1,'','','','','el está casado (con)','','','2002-12-04 14:55:30'),(807,'de','vervollständigen','',1,'','','','','','','','2002-12-04 14:56:18'),(807,'es','completar','',1,'','','','','','','','2002-12-04 14:56:18'),(808,'de','wir','',1,'','','','','','','','2002-12-04 14:56:57'),(808,'es','nosotros','',1,'','','','','','','','2002-12-04 14:56:57'),(809,'de','ihr','',1,'','','','','','','','2002-12-04 14:57:15'),(809,'es','vosotros','',1,'','','','','','','','2002-12-04 14:57:15'),(810,'de','Verkäufer','der',1,'','','','','','','','2002-12-04 14:58:24'),(810,'es','dependiente','el',1,'fem: dependienta','','','','','','','2002-12-04 14:58:24'),(811,'de','Fabrik','',1,'','','','','','','','2002-12-04 14:59:53'),(811,'es','fábrica','',1,'','','','','','','','2002-12-04 14:59:53'),(812,'de','Medizin','die',1,'','','','','','','','2002-12-04 15:00:59'),(812,'es','medicina','la',1,'','','','','','','','2002-12-04 15:00:59'),(813,'de','verbringen','',1,'','','','geschehen, los sein','','','','2002-12-04 15:04:18'),(813,'es','pasar','',1,'','','','','','','','2002-12-04 15:04:18'),(814,'de','nahe','',1,'','','','','nahe bei','','','2002-12-04 15:05:23'),(814,'es','cerca','',1,'','','','','cerca de','','','2002-12-04 15:05:23'),(815,'de','Reise','die',1,'','','','','','','','2002-12-04 15:06:09'),(815,'es','viaje','',1,'','','','','','','','2002-12-04 15:06:09'),(816,'de','Wasserfall','der',1,'','','','','','','','2002-12-04 15:07:29'),(816,'es','catarata','la',1,'','','','','','','','2002-12-04 15:07:29'),(818,'de','Gewinnzahlen','die',1,'','','','','','','','2002-12-04 15:12:05'),(818,'es','números premiados','los',1,'','','','','','','','2002-12-04 15:12:05'),(819,'de','Lotterie','die',1,'','','','Lotto','','','','2002-12-04 15:12:59'),(819,'es','loteria','la',1,'','','','','','','','2002-12-04 15:12:59'),(820,'de','Polizei','die',1,'','','','','','','','2002-12-04 15:13:33'),(820,'es','policía','la',1,'','','','','','','','2002-12-04 15:13:33'),(821,'de','Krankenwagen','der',1,'','','','','','','','2002-12-04 15:14:21'),(821,'es','ambulancia','la',1,'','','','','','','','2002-12-04 15:14:21'),(822,'de','Feuerwehr','die',1,'','','','','','','','2002-12-04 15:14:43'),(822,'es','bomberos','los',1,'','','','','','','','2002-12-04 15:14:43'),(823,'de','Gedicht','das',1,'','','','','','','','2002-12-04 15:15:20'),(823,'es','poema','el',1,'','','','','','','','2002-12-04 15:15:20'),(824,'es','mucho','',1,'','','','','','','','2002-12-04 17:55:07'),(825,'de','viele','',1,'','','','','','','','2002-12-04 17:57:27'),(825,'es','enorme','',1,'','','','','','','','2002-12-04 17:57:27'),(826,'de','so viel','',1,'','','','','','','','2002-12-04 17:57:46'),(826,'es','tanto','',1,'','','','','','','','2002-12-04 17:57:46'),(827,'de','fantastisch','',1,'','','','','','','','2002-12-04 18:00:26'),(827,'es','fantástico','',1,'','','','','','','','2002-12-04 18:00:26'),(828,'de','vielleicht','',1,'','','','','','','','2002-12-04 18:01:22'),(828,'es','quizás','',1,'','','','','','','','2002-12-04 18:01:22'),(829,'de','mehrere','',1,'','','','','','','','2002-12-04 18:02:10'),(829,'es','varios','',1,'','','','','','','','2002-12-04 18:02:10'),(830,'de','eindrucksvoll','',1,'','','','beeindruckend','','','','2002-12-05 15:57:13'),(830,'es','impresionante','',1,'','','','','','','','2002-12-05 15:57:13'),(831,'de','Aktivität','die',1,'','','','','','','','2002-12-05 15:58:11'),(831,'es','actividad','la',1,'','','','','','','','2002-12-05 15:58:11'),(832,'de','Einkaufszentrum','das',1,'','','','','','','','2002-12-05 15:58:51'),(832,'es','centro comercial','el',1,'','','','','','','','2002-12-05 15:58:51'),(833,'de','Kino','das',1,'','','','','','','','2002-12-05 15:59:34'),(833,'es','cine','el',1,'','','','','','','','2002-12-05 15:59:34'),(834,'de','interessant','',1,'','','','','','','','2002-12-05 15:59:58'),(834,'es','interesante','',1,'','','','','','','','2002-12-05 15:59:58'),(835,'de','wie überall','',1,'','','','','','','','2002-12-05 16:00:31'),(835,'es','como en todas partes','',1,'','','','','','','','2002-12-05 16:00:31'),(836,'de','reich','',1,'','','','','','','','2002-12-05 16:01:27'),(836,'es','rico','',1,'','','','','','','','2002-12-05 16:01:27'),(837,'de','arm','',1,'','','','','','','','2002-12-05 16:01:42'),(837,'es','pobre','',1,'','','','','','','','2002-12-05 16:01:42'),(838,'de','Gegensatz','der',1,'','','','','','','','2002-12-05 16:02:15'),(838,'es','contraste','el',1,'','','','','','','','2002-12-05 16:02:15'),(839,'de','besondere','',1,'','','','','','','','2002-12-05 16:02:45'),(839,'es','especial','',1,'','','','','','','','2002-12-05 16:02:45'),(840,'de','Stress','der',1,'','','','','','','','2002-12-05 16:03:48'),(840,'es','estrés','el',1,'','','','','','','','2002-12-05 16:03:48'),(841,'de','entkommen','',1,'','','','entgehen','','','','2002-12-05 16:04:27'),(841,'es','escapar','',1,'','','','','','','','2002-12-05 16:04:27'),(842,'de','weiß','',1,'','','','','','','','2002-12-05 16:04:55'),(842,'es','blanco','',1,'','','','','','','','2002-12-05 16:04:55'),(843,'de','wenig','',1,'','','','','','','','2002-12-05 16:07:20'),(843,'es','poco','',1,'','','','','','','','2002-12-05 16:07:20'),(844,'de','Bar','die',1,'','','','Kneipe, Beisl','','','','2002-12-05 16:07:50'),(844,'es','bar','el',1,'','','','','','','','2002-12-05 16:07:50'),(845,'de','Strand','der',1,'','','','','','','','2002-12-05 16:09:06'),(845,'es','playa','la',1,'','','','','','','','2002-12-05 16:09:06'),(846,'de','Museum','das',1,'','','','','','','','2002-12-05 16:09:34'),(846,'es','museo','el',1,'','','','','','','','2002-12-05 16:09:34'),(847,'de','Kunst','die',1,'','','','','','','','2002-12-05 16:10:09'),(847,'es','arte','el',1,'','','','','','','','2002-12-05 16:10:09'),(848,'de','Fußball','',1,'','','','','','','','2002-12-05 16:10:58'),(848,'es','fútbol','',1,'','','','','','','','2002-12-05 16:10:58'),(849,'de','hässlich','',1,'','','','','','','','2002-12-05 16:11:28'),(849,'es','feo','',1,'','','','','','','','2002-12-05 16:11:28'),(850,'de','gleich','',1,'','','','genau','','','','2002-12-05 16:13:06'),(850,'es','justo','',1,'','','','','','','','2002-12-05 16:13:06'),(851,'de','hinter','',1,'','','','','','','','2002-12-05 16:13:34'),(851,'es','detrás de','',1,'','','','','','','','2002-12-05 16:13:34'),(852,'de','bis','',1,'','','','zu','','','','2002-12-05 16:16:30'),(852,'es','hasta','',1,'','','','','','','','2002-12-05 16:16:30'),(853,'de','folgen','',1,'','','','weitergehen','','','','2002-12-06 13:11:47'),(853,'es','seguir','',1,'','','','','','','','2002-12-06 13:11:47'),(854,'de','Ampel','die',1,'','','','','','','','2002-12-06 13:12:23'),(854,'es','semáfora','la',1,'','','','','','','','2002-12-06 13:12:23'),(855,'de','abbiegen','',1,'','','','','','','','2002-12-06 13:12:48'),(855,'es','torcer','',1,'','','','','','','','2002-12-06 13:12:48'),(856,'de','links','',1,'','','','','','','','2002-12-06 13:14:11'),(856,'es','a la izquierda','',1,'','','','','','','','2002-12-06 13:14:11'),(857,'de','Telefonzelle','die',1,'','','','','','','','2002-12-06 13:14:55'),(857,'es','cabina de teléfonos','la',1,'','','','','','','','2002-12-06 13:14:55'),(858,'de','neben','',1,'','','','','','','','2002-12-06 13:18:08'),(858,'es','a lado de','',1,'','','','','','','','2002-12-06 13:18:08'),(859,'de','zwischen','',1,'','','','','','','','2002-12-06 13:18:31'),(859,'es','entre','',1,'','','','','','','','2002-12-06 13:18:31'),(860,'de','Zu Fuß','',1,'','','','','','','','2002-12-06 13:19:07'),(860,'es','a pie','',1,'','','','','','','','2002-12-06 13:19:07'),(861,'de','Promenade','die',1,'','','','Spaziergang','','','','2002-12-06 13:19:38'),(861,'es','paseo','el',1,'','','','','','','','2002-12-06 13:19:38'),(862,'de','historisch','',1,'','','','','','','','2002-12-06 13:20:08'),(862,'es','histórico','',1,'','','','','','','','2002-12-06 13:20:08'),(863,'de','Ecke','die',1,'','','','Straßenecke','','','','2002-12-06 13:20:47'),(863,'es','esquina','la',1,'','','','','','','','2002-12-06 13:20:47'),(864,'de','Tradition','die',1,'','','','','','','','2002-12-06 13:21:25'),(864,'es','tradición','la',1,'','','','','','','','2002-12-06 13:21:25'),(865,'de','geradeaus','',1,'','','','','','','','2002-12-06 13:21:47'),(865,'es','recto','',1,'','','','','','','','2002-12-06 13:21:47'),(866,'de','alt','',1,'','','','','','','','2002-12-06 13:22:13'),(866,'es','antiquo','',1,'','','','','','','','2002-12-06 13:22:13'),(867,'de','Monument','das',1,'','','','','','','','2002-12-06 13:22:38'),(867,'es','monumento','el',1,'','','','','','','','2002-12-06 13:22:38'),(868,'de','schließlich','',1,'','','','','','','','2002-12-06 13:23:03'),(868,'es','finalmente','',1,'','','','','','','','2002-12-06 13:23:03'),(869,'de','Bild','das',1,'','','','das Gemälde','','','','2002-12-06 13:23:30'),(869,'es','cuadro','el',1,'','','','','','','','2002-12-06 13:23:30'),(870,'de','berühmt','',1,'','','','','','','','2002-12-06 13:23:51'),(870,'es','famoso','',1,'','','','','','','','2002-12-06 13:23:51'),(871,'de','Auto fahren','',1,'','','','','','','','2002-12-06 13:24:39'),(871,'es','ir en coche','',1,'','','','','','','','2002-12-06 13:24:39'),(872,'de','fliegen','',1,'','','','','','','','2002-12-06 13:24:57'),(872,'es','ir en avión','',1,'','','','','','','','2002-12-06 13:24:57'),(873,'de','Flugzeug','das',1,'','','','','','','','2002-12-06 13:25:38'),(873,'es','avión','el',1,'','','','','','','','2002-12-06 13:25:38'),(874,'de','Fahrrad','das',1,'','','','','','','','2002-12-06 13:26:19'),(874,'es','bicicleta','la',1,'','','','','','','','2002-12-06 13:26:19'),(875,'de','Rad fahren','',1,'','','','','','','','2002-12-06 13:26:41'),(875,'es','ir en bicicleta','',1,'','','','','','','','2002-12-06 13:26:41'),(876,'de','Kette','die',1,'','','','','','','','2002-12-06 13:27:13'),(876,'es','cadena','la',1,'','','','','','','','2002-12-06 13:27:13'),(877,'de','Leserbrief','der',1,'','','','','','','','2002-12-06 13:29:17'),(877,'es','carta al director','la',1,'','','','','','','','2002-12-06 13:29:17'),(878,'de','Leben','das',1,'','','','','','','','2002-12-06 13:30:23'),(878,'es','vida','la',1,'','','','','','','','2002-12-06 13:30:23'),(879,'de','alltäglich','',1,'','','','','','','','2002-12-06 13:30:53'),(879,'es','cotidiano','',1,'','','','','','','','2002-12-06 13:30:53'),(880,'de','Bewegung','die',1,'','','','das Treiben','','','','2002-12-06 13:31:49'),(880,'es','movimiento','el',1,'','','','','','','','2002-12-06 13:31:49'),(881,'de','Konzert','das',1,'','','','','','','','2002-12-06 13:32:42'),(881,'es','concierto','el',1,'','','','','','','','2002-12-06 13:32:42'),(882,'de','Ausstellung','die',1,'','','','','','','','2002-12-06 13:33:26'),(882,'es','exposición','la',1,'','','','','','','','2002-12-06 13:33:26'),(883,'de','Aspekt','der',1,'','','','','','','','2002-12-06 13:34:17'),(883,'es','aspecto','el',1,'','','','','','','','2002-12-06 13:34:17'),(884,'de','negativ','',1,'','','','','','','','2002-12-06 13:34:36'),(884,'es','negativo','',1,'','','','','','','','2002-12-06 13:34:36'),(885,'de','aggressiv','',1,'','','','','','','','2002-12-06 13:35:07'),(885,'es','agresivo','',1,'','','','','','','','2002-12-06 13:35:07'),(886,'de','Kriminalität','die',1,'','','','','','','','2002-12-06 13:35:47'),(886,'es','criminalidad','la',1,'','','','','','','','2002-12-06 13:35:47'),(887,'de','vor allem','',1,'','','','','','','','2002-12-06 13:36:08'),(887,'es','sobre todo','',1,'','','','','','','','2002-12-06 13:36:08'),(888,'de','Baum','der',1,'','','','','','','','2002-12-06 13:36:51'),(888,'es','árbol','el',1,'','','','','','','','2002-12-06 13:36:51'),(889,'de','positiv','',1,'','','','','','','','2002-12-06 13:37:30'),(889,'es','positivo','',1,'','','','','','','','2002-12-06 13:37:30'),(890,'de','Chaos','das',1,'','','','','','','','2002-12-06 13:37:53'),(890,'es','caos','el',1,'','','','','','','','2002-12-06 13:37:53'),(891,'de','chinesisch','',1,'','','','','','','','2002-12-06 13:38:19'),(891,'es','chino','',1,'','','','','','','','2002-12-06 13:38:19'),(892,'de','nur noch','',1,'','','','','','','','2002-12-06 13:39:36'),(892,'es','ya sólo','',1,'','','','','','','','2002-12-06 13:39:36'),(893,'de','Ziffer','die',1,'','','','die Zahl','','','','2002-12-06 13:40:15'),(893,'es','cifra','la',1,'','','','','','','','2002-12-06 13:40:15'),(894,'de','laut','',1,'mit lauter Stimme','','','','','','','2002-12-06 13:40:49'),(894,'es','en voz alta','',1,'','','','','','','','2002-12-06 13:40:49'),(895,'de','Rentner','der',1,'','','','Pensionist','','','','2002-12-06 13:41:40'),(895,'es','pensionista','el',1,'fem: la pensionista','','','','','','','2002-12-06 13:41:40'),(896,'de','Fernseher','der',1,'','','','Fernsehapparat','','','','2002-12-06 13:42:43'),(896,'es','televisor','el',1,'','','','','','','','2002-12-06 13:42:43'),(897,'de','jeder','',1,'','','','','','','','2002-12-06 13:43:09'),(897,'es','cada','',1,'','','','','','','','2002-12-06 13:43:09'),(898,'de','Kilometer','der',1,'','','','','','','','2002-12-06 13:43:36'),(898,'es','kilómetro','el',1,'','','','','','','','2002-12-06 13:43:36'),(899,'de','Bibliothek','die',1,'','','','','','','','2002-12-06 13:44:13'),(899,'es','biblioteca','la',1,'','','','','','','','2002-12-06 13:44:13'),(900,'de','Fläche','die',1,'','','','Oberfläche','','','','2002-12-06 13:45:03'),(900,'es','superficie','la',1,'','','','','','','','2002-12-06 13:45:03'),(901,'de','anrufen','',1,'','','','rufen','','','','2002-12-06 14:02:36'),(901,'es','llamar','',1,'','','','','','','','2002-12-06 14:02:36'),(902,'de','schwierig','',1,'','','','','','','','2002-12-06 14:03:34'),(902,'es','dificil','',1,'','','','','','','','2002-12-06 14:03:34'),(903,'de','Theater','das',1,'','','','','','','','2002-12-06 14:08:47'),(903,'es','teatro','el',1,'','','','','','','','2002-12-06 14:08:47'),(904,'de','Freiheit','die',1,'','','','','','','','2002-12-06 14:09:15'),(904,'es','liberdad','la',1,'','','','','','','','2002-12-06 14:09:15'),(905,'de','Freundschaft','die',1,'','','','','','','','2002-12-06 14:09:55'),(905,'es','amistad','la',1,'','','','','','','','2002-12-06 14:09:55'),(906,'de','Schiff','das',1,'','','','','','','','2002-12-06 14:10:23'),(906,'es','nave','la',1,'','','','','','','','2002-12-06 14:10:23'),(907,'de','Fenster','das',1,'','','','','','','','2002-12-06 14:10:53'),(907,'es','ventana','la',1,'','','','','','','','2002-12-06 14:10:53'),(908,'de','Tasse','die',1,'','','','','','','','2002-12-06 14:12:01'),(908,'es','taza','la',1,'','','','','','','','2002-12-06 14:12:01'),(909,'de','Sessel','der',1,'','','','','','','','2002-12-06 14:12:24'),(909,'es','silla','la',1,'','','','','','','','2002-12-06 14:12:24'),(910,'de','Türe','die',1,'','','','','','','','2002-12-06 14:13:43'),(910,'es','puerta','la',1,'','','','','','','','2002-12-06 14:13:43'),(911,'de','Teller','das',1,'','','','','','','','2002-12-06 14:14:17'),(911,'es','plato','el',1,'','','','','','','','2002-12-06 14:14:17'),(912,'de','traurig','',1,'','','','','','','','2002-12-06 14:18:49'),(912,'es','triste','',1,'','','','','','','','2002-12-06 14:18:49'),(913,'de','klug','',1,'','','','schlau, fertig','','','','2002-12-06 14:23:12'),(913,'es','listo','',1,'','','','','','','','2002-12-06 14:23:12'),(914,'de','Zucker','der',1,'','','','','','','','2002-12-06 14:28:53'),(914,'es','azucar','el',1,'','','','','','','','2002-12-06 14:28:53'),(916,'de','blond','',1,'','','','','','','','2002-12-06 14:58:00'),(916,'es','rubio','',1,'','','','','','','','2002-12-06 14:58:00'),(917,'de','dunkel','',1,'','','','dunkelhaarig','','','','2002-12-06 14:58:36'),(917,'es','moreno','',1,'','','','','','','','2002-12-06 14:58:36'),(918,'de','betrunken','',1,'','','','','','','','2002-12-06 14:59:26'),(918,'es','borracho','',1,'','','','','','','','2002-12-06 14:59:26'),(919,'de','tanzen','',1,'','','','','','','','2002-12-06 15:08:42'),(919,'es','bailar','',1,'','','','','','','','2002-12-06 15:08:42'),(920,'de','gehen','',1,'','','','','','','','2002-12-06 15:09:29'),(920,'es','caminar','',1,'','','','ir','','','','2002-12-06 15:09:29'),(921,'de','malen','',1,'','','','','','','','2002-12-06 15:10:02'),(921,'es','pintar','',1,'','','','','','','','2002-12-06 15:10:02'),(922,'de','konversieren','',1,'','','','','','','','2002-12-06 15:10:43'),(922,'es','conversar','',1,'','','','','','','','2002-12-06 15:10:43'),(923,'de','plaudern','',1,'','','','','','','','2002-12-06 15:10:56'),(923,'es','plagitar','',1,'','','','','','','','2002-12-06 15:10:56'),(924,'de','helfen','',1,'','','','','','','','2002-12-06 15:11:20'),(924,'es','ayudar','',1,'','','','','','','','2002-12-06 15:11:20'),(925,'de','waschen','',1,'','','','','','','','2002-12-06 15:11:52'),(925,'es','lavar','',1,'','','','','','','','2002-12-06 15:11:52'),(926,'de','weinen','',1,'','','','','','','','2002-12-06 15:12:11'),(926,'es','llorar','',1,'','','','','','','','2002-12-06 15:12:11'),(927,'de','kaufen','',1,'','','','','','','','2002-12-06 15:12:41'),(927,'es','comprar','',1,'','','','','','','','2002-12-06 15:12:41'),(928,'de','zeichnen','',1,'','','','','','','','2002-12-06 15:13:11'),(928,'es','dibujar','',1,'','','','','','','','2002-12-06 15:13:11'),(929,'de','schwimmen','',1,'','','','','','','','2002-12-06 15:13:33'),(929,'es','nadar','',1,'','','','','','','','2002-12-06 15:13:33'),(930,'de','ziehen','',1,'','','','','','','','2002-12-06 15:14:22'),(930,'es','jalar','',1,'','','','','','','','2002-12-06 15:14:22'),(931,'de','drücken','',1,'','','','stossen','','','','2002-12-06 15:14:47'),(931,'es','empujar','',1,'','','','','','','','2002-12-06 15:14:47'),(932,'de','ruhen','',1,'','','','ausruhen','','','','2002-12-06 15:15:22'),(932,'es','descansar','',1,'','','','','','','','2002-12-06 15:15:22'),(933,'de','putzen','',1,'','','','','','','','2002-12-06 15:16:17'),(933,'es','limpiar','',1,'','','','','','','','2002-12-06 15:16:17'),(934,'de','schreien','',1,'','','','','','','','2002-12-06 15:17:21'),(934,'es','gritar','',1,'','','','','','','','2002-12-06 15:17:21'),(935,'de','Woher','',1,'','','','','','','','2002-12-06 15:19:08'),(935,'es','De dónde','',1,'','','','','','','','2002-12-06 15:19:08');

/*!40000 ALTER TABLE Entries ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Entries_in_Lessions'
--

DROP TABLE IF EXISTS Entries_in_Lessions;
CREATE TABLE Entries_in_Lessions (
  lessionid int(11) NOT NULL default '0',
  entryid int(11) NOT NULL default '0',
  entrylangcode char(2) NOT NULL default '',
  PRIMARY KEY  (lessionid,entryid,entrylangcode)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Entries_in_Lessions DISABLE KEYS */;

--
-- Dumping data for table 'Entries_in_Lessions'
--


LOCK TABLES Entries_in_Lessions WRITE;

/*!40000 ALTER TABLE Entries_in_Lessions ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Entries_in_Levels'
--

DROP TABLE IF EXISTS Entries_in_Levels;
CREATE TABLE Entries_in_Levels (
  levelid int(11) NOT NULL default '0',
  entryid int(11) NOT NULL default '0',
  PRIMARY KEY  (levelid,entryid)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Entries_in_Levels DISABLE KEYS */;

--
-- Dumping data for table 'Entries_in_Levels'
--


LOCK TABLES Entries_in_Levels WRITE;
INSERT INTO Entries_in_Levels VALUES (1,1),(1,21),(1,23),(1,25),(1,34),(1,51),(1,56),(1,57),(1,81),(1,92),(1,93),(1,95),(1,98),(1,102),(1,104),(1,108),(1,110),(1,119),(1,133),(1,158),(1,169),(1,173),(1,177),(1,178),(1,218),(1,228),(1,234),(1,251),(1,256),(1,279),(1,280),(1,281),(1,301),(1,310),(1,321),(1,325),(1,334),(1,335),(1,338),(1,340),(1,344),(1,353),(1,369),(1,376),(1,391),(1,398),(1,409),(1,433),(1,436),(1,438),(1,439),(1,441),(1,443),(1,446),(1,447),(1,461),(1,464),(1,466),(1,473),(1,474),(1,487),(1,494),(1,501),(1,512),(1,513),(1,518),(1,523),(1,540),(1,541),(1,550),(1,552),(1,553),(1,565),(1,571),(1,573),(1,584),(1,588),(1,609),(1,611),(1,615),(1,616),(1,618),(1,623),(1,626),(1,632),(1,635),(1,642),(1,665),(1,667),(1,668),(1,669),(1,670),(1,671),(1,672),(1,673),(1,674),(1,675),(1,676),(1,677),(1,678),(1,679),(1,680),(1,681),(1,682),(1,683),(1,684),(1,685),(1,686),(1,687),(1,688),(1,689),(1,690),(1,691),(1,692),(1,693),(1,694),(1,695),(1,696),(1,697),(1,698),(1,699),(1,700),(1,701),(1,702),(1,703),(1,704),(1,705),(1,706),(1,707),(1,708),(1,709),(1,710),(1,711),(1,712),(1,713),(1,714),(1,715),(1,716),(1,717),(1,718),(1,719),(1,720),(1,721),(1,722),(1,744),(1,745),(1,746),(1,747),(1,748),(1,749),(1,751),(1,901),(1,902),(2,6),(2,24),(2,32),(2,50),(2,55),(2,60),(2,61),(2,66),(2,85),(2,88),(2,107),(2,116),(2,121),(2,129),(2,137),(2,149),(2,151),(2,171),(2,201),(2,209),(2,214),(2,236),(2,253),(2,257),(2,272),(2,284),(2,286),(2,320),(2,328),(2,331),(2,339),(2,342),(2,348),(2,354),(2,374),(2,375),(2,377),(2,379),(2,386),(2,387),(2,407),(2,416),(2,417),(2,418),(2,424),(2,437),(2,440),(2,449),(2,451),(2,469),(2,478),(2,484),(2,485),(2,486),(2,491),(2,499),(2,508),(2,515),(2,525),(2,532),(2,545),(2,547),(2,548),(2,549),(2,554),(2,572),(2,577),(2,610),(2,613),(2,614),(2,627),(2,628),(2,633),(2,636),(2,641),(2,645),(2,651),(2,655),(2,659),(2,660),(2,661),(2,723),(2,724),(2,725),(2,726),(2,727),(2,728),(2,729),(2,730),(2,731),(2,732),(2,733),(2,734),(2,735),(2,736),(2,737),(2,738),(2,739),(2,740),(2,741),(2,742),(2,743),(2,750),(2,752),(2,753),(2,754),(2,755),(2,756),(2,757),(2,758),(2,759),(2,760),(2,761),(2,762),(2,763),(2,764),(2,765),(2,766),(2,767),(2,768),(2,769),(2,770),(2,771),(2,772),(2,773),(2,774),(2,775),(2,776),(2,777),(2,778),(2,779),(2,780),(2,781),(2,782),(2,783),(2,784),(2,785),(2,786),(2,787),(2,788),(2,789),(2,790),(2,791),(2,792),(2,793),(2,794),(2,796),(2,797),(2,798),(2,799),(2,800),(2,801),(2,802),(2,803),(2,804),(2,805),(2,806),(2,807),(2,808),(2,809),(2,810),(2,811),(2,812),(2,813),(2,814),(2,815),(2,816),(2,817),(2,818),(2,819),(2,820),(2,821),(2,822),(2,823),(2,915),(2,927),(2,935),(3,2),(3,14),(3,15),(3,26),(3,28),(3,33),(3,35),(3,40),(3,46),(3,49),(3,52),(3,74),(3,75),(3,82),(3,99),(3,100),(3,113),(3,126),(3,138),(3,141),(3,147),(3,148),(3,174),(3,180),(3,186),(3,190),(3,192),(3,216),(3,223),(3,226),(3,231),(3,238),(3,245),(3,252),(3,278),(3,290),(3,293),(3,306),(3,322),(3,336),(3,352),(3,372),(3,388),(3,392),(3,394),(3,399),(3,402),(3,415),(3,422),(3,432),(3,456),(3,458),(3,475),(3,482),(3,500),(3,505),(3,534),(3,538),(3,539),(3,579),(3,582),(3,600),(3,601),(3,619),(3,622),(3,631),(3,646),(3,653),(3,663),(3,824),(3,825),(3,826),(3,827),(3,828),(3,829),(3,830),(3,831),(3,832),(3,833),(3,834),(3,835),(3,836),(3,837),(3,838),(3,839),(3,840),(3,841),(3,842),(3,843),(3,844),(3,845),(3,846),(3,847),(3,848),(3,849),(3,850),(3,851),(3,852),(3,853),(3,854),(3,855),(3,856),(3,857),(3,858),(3,859),(3,860),(3,861),(3,862),(3,863),(3,864),(3,865),(3,866),(3,867),(3,868),(3,869),(3,870),(3,871),(3,872),(3,873),(3,874),(3,875),(3,876),(3,877),(3,878),(3,879),(3,880),(3,881),(3,882),(3,883),(3,884),(3,885),(3,886),(3,887),(3,888),(3,889),(3,890),(3,891),(3,892),(3,893),(3,894),(3,895),(3,896),(3,897),(3,898),(3,899),(3,900),(3,903),(3,904),(3,905),(3,906),(3,907),(3,908),(3,909),(3,910),(3,911),(3,912),(3,913),(3,914),(3,916),(3,917),(3,918),(3,919),(3,920),(3,921),(3,922),(3,923),(3,924),(3,925),(3,926),(3,928),(3,929),(3,930),(3,931),(3,932),(3,933),(3,934),(21,3),(21,4),(21,5),(21,7),(21,8),(21,9),(21,10),(21,11),(21,12),(21,13),(21,16),(21,17),(21,18),(21,19),(21,20),(21,22),(21,27),(21,29),(21,30),(21,31),(21,36),(21,37),(21,38),(21,39),(21,41),(21,42),(21,43),(21,44),(21,45),(21,47),(21,48),(21,53),(21,54),(21,58),(21,59),(21,62),(21,63),(21,64),(21,65),(21,67),(21,68),(21,69),(21,70),(21,71),(21,72),(21,73),(21,76),(21,77),(21,78),(21,79),(21,80),(21,83),(21,84),(21,86),(21,87),(21,89),(21,90),(21,91),(21,94),(21,96),(21,97),(21,101),(21,103),(21,105),(21,106),(21,109),(21,111),(21,112),(21,114),(21,115),(21,117),(21,118),(21,120),(21,122),(21,123),(21,124),(21,125),(21,127),(21,128),(21,130),(21,131),(21,132),(21,134),(21,135),(21,136),(21,139),(21,140),(21,142),(21,143),(21,144),(21,145),(21,146),(21,150),(21,152),(21,153),(21,154),(21,155),(21,156),(21,157),(21,159),(21,160),(21,161),(21,162),(21,163),(21,164),(21,165),(21,166),(21,167),(21,168),(21,170),(21,172),(21,175),(21,176),(21,179),(21,181),(21,182),(21,183),(21,184),(21,185),(21,187),(21,188),(21,189),(21,191),(21,193),(21,194),(21,195),(21,196),(21,197),(21,198),(21,199),(21,200),(21,202),(21,203),(21,204),(21,205),(21,206),(21,207),(21,208),(21,210),(21,211),(21,212),(21,213),(21,215),(21,217),(21,219),(21,220),(21,221),(21,222),(21,224),(21,225),(21,227),(21,229),(21,230),(21,232),(21,233),(21,235),(21,237),(21,239),(21,240),(21,241),(21,242),(21,243),(21,244),(21,246),(21,247),(21,248),(21,249),(21,250),(21,254),(21,255),(21,258),(21,259),(21,260),(21,261),(21,262),(21,263),(21,264),(21,265),(21,266),(21,267),(21,268),(21,269),(21,270),(21,271),(21,273),(21,274),(21,275),(21,276),(21,277),(21,282),(21,283),(21,285),(21,287),(21,288),(21,289),(21,291),(21,292),(21,294),(21,295),(21,296),(21,297),(21,298),(21,299),(21,300),(21,302),(21,303),(21,304),(21,305),(21,307),(21,308),(21,309),(21,311),(21,312),(21,313),(21,314),(21,315),(21,316),(21,317),(21,318),(21,319),(21,323),(21,324),(21,326),(21,327),(21,329),(21,330),(21,332),(21,333),(21,337),(21,341),(21,343),(21,345),(21,346),(21,347),(21,349),(21,350),(21,351),(21,355),(21,356),(21,357),(21,358),(21,359),(21,360),(21,361),(21,362),(21,363),(21,364),(21,365),(21,366),(21,367),(21,368),(21,370),(21,371),(21,373),(21,378),(21,380),(21,381),(21,382),(21,383),(21,384),(21,385),(21,389),(21,390),(21,393),(21,395),(21,396),(21,397),(21,400),(21,401),(21,403),(21,404),(21,405),(21,406),(21,408),(21,410),(21,411),(21,412),(21,413),(21,414),(21,419),(21,420),(21,421),(21,423),(21,425),(21,426),(21,427),(21,428),(21,429),(21,430),(21,431),(21,434),(21,435),(21,442),(21,444),(21,445),(21,448),(21,450),(21,452),(21,453),(21,454),(21,455),(21,457),(21,459),(21,460),(21,462),(21,463),(21,465),(21,468),(21,470),(21,471),(21,472),(21,476),(21,477),(21,479),(21,480),(21,481),(21,483),(21,488),(21,489),(21,490),(21,492),(21,493),(21,495),(21,496),(21,497),(21,498),(21,502),(21,503),(21,504),(21,506),(21,507),(21,509),(21,510),(21,511),(21,514),(21,516),(21,517),(21,519),(21,520),(21,521),(21,522),(21,524),(21,526),(21,527),(21,528),(21,529),(21,530),(21,531),(21,533),(21,535),(21,536),(21,537),(21,542),(21,543),(21,544),(21,546),(21,551),(21,555),(21,556),(21,557),(21,558),(21,559),(21,560),(21,561),(21,562),(21,563),(21,564),(21,566),(21,567),(21,568),(21,569),(21,570),(21,574),(21,575),(21,576),(21,578),(21,580),(21,581),(21,583),(21,585),(21,586),(21,587),(21,589),(21,590),(21,591),(21,592),(21,593),(21,594),(21,595),(21,596),(21,597),(21,598),(21,599),(21,602),(21,603),(21,604),(21,605),(21,606),(21,607),(21,608),(21,612),(21,617),(21,620),(21,621),(21,624),(21,625),(21,629),(21,630),(21,634),(21,637),(21,638),(21,640),(21,643),(21,644),(21,647),(21,648),(21,649),(21,650),(21,652),(21,654),(21,656),(21,657),(21,658),(21,662),(21,664),(21,666);

/*!40000 ALTER TABLE Entries_in_Levels ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Languages'
--

DROP TABLE IF EXISTS Languages;
CREATE TABLE Languages (
  code char(2) NOT NULL default '',
  language varchar(32) NOT NULL default '',
  PRIMARY KEY  (code)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Languages DISABLE KEYS */;

--
-- Dumping data for table 'Languages'
--


LOCK TABLES Languages WRITE;
INSERT INTO Languages VALUES ('de','Deutsch'),('es','Espaol');

/*!40000 ALTER TABLE Languages ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Lessions'
--

DROP TABLE IF EXISTS Lessions;
CREATE TABLE Lessions (
  id int(11) NOT NULL auto_increment,
  name varchar(32) NOT NULL default '-',
  level int(11) NOT NULL default '0',
  createdate timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Lessions DISABLE KEYS */;

--
-- Dumping data for table 'Lessions'
--


LOCK TABLES Lessions WRITE;

/*!40000 ALTER TABLE Lessions ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Levels'
--

DROP TABLE IF EXISTS Levels;
CREATE TABLE Levels (
  id int(11) NOT NULL auto_increment,
  name varchar(128) NOT NULL default '',
  seqnr int(11) NOT NULL default '0',
  status char(1) NOT NULL default 'N',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Levels DISABLE KEYS */;

--
-- Dumping data for table 'Levels'
--


LOCK TABLES Levels WRITE;
INSERT INTO Levels VALUES (1,'Level 1',1,'F'),(2,'Level 2',2,'F'),(3,'Level 3',3,'F'),(4,'Level 4',4,'N'),(5,'Level 5',5,'N'),(6,'Level 6',6,'N'),(7,'Level 7',7,'N'),(8,'Level 8',8,'N'),(9,'Level 9',9,'N'),(10,'Level 10',10,'N'),(21,'Alle Level',99,'N');

/*!40000 ALTER TABLE Levels ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Pronouns'
--

DROP TABLE IF EXISTS Pronouns;
CREATE TABLE Pronouns (
  conjugationcode varchar(4) NOT NULL default '',
  langcode char(2) NOT NULL default '',
  pronoun varchar(16) NOT NULL default '',
  common int(1) NOT NULL default '0',
  PRIMARY KEY  (conjugationcode,langcode)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Pronouns DISABLE KEYS */;

--
-- Dumping data for table 'Pronouns'
--


LOCK TABLES Pronouns WRITE;
INSERT INTO Pronouns VALUES ('s1','de','ich',0),('s2','de','du',0),('s3f','de','sie',0),('s3m','de','er',0),('s3n','de','es',0),('p1','de','wir',0),('p2','de','ihr',0),('p3f','de','sie',1),('p3m','de','sie',0),('p3n','de','sie',0),('s1','es','yo',0),('s2','es','tú',0),('s3f','es','él',0),('s3m','es','ella',0),('s3n','es','usted',0),('p1','es','nosotros',0),('p2','es','vosotros',0),('p3f','es','ellos',0),('p3m','es','ellas',0),('p3n','es','ustedes',0);

/*!40000 ALTER TABLE Pronouns ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Types'
--

DROP TABLE IF EXISTS Types;
CREATE TABLE Types (
  id int(11) NOT NULL auto_increment,
  langcode char(2) NOT NULL default '',
  name varchar(64) NOT NULL default '',
  PRIMARY KEY  (id,langcode)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Types DISABLE KEYS */;

--
-- Dumping data for table 'Types'
--


LOCK TABLES Types WRITE;
INSERT INTO Types VALUES (1,'de','-'),(1,'es','-');

/*!40000 ALTER TABLE Types ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'User_Lessions'
--

DROP TABLE IF EXISTS User_Lessions;
CREATE TABLE User_Lessions (
  id int(11) NOT NULL auto_increment,
  userid int(11) NOT NULL default '0',
  lessionid int(11) NOT NULL default '0',
  lessiongrade decimal(5,2) NOT NULL default '0.00',
  lessiondate timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

/*!40000 ALTER TABLE User_Lessions DISABLE KEYS */;

--
-- Dumping data for table 'User_Lessions'
--


LOCK TABLES User_Lessions WRITE;

/*!40000 ALTER TABLE User_Lessions ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'User_Lessions_Entries'
--

DROP TABLE IF EXISTS User_Lessions_Entries;
CREATE TABLE User_Lessions_Entries (
  userlessionid int(11) NOT NULL default '0',
  entryid int(11) NOT NULL default '0',
  entrylangcode char(2) NOT NULL default '',
  correct int(1) NOT NULL default '0',
  addpoint int(1) NOT NULL default '0',
  PRIMARY KEY  (userlessionid,entryid,entrylangcode)
) TYPE=MyISAM;

/*!40000 ALTER TABLE User_Lessions_Entries DISABLE KEYS */;

--
-- Dumping data for table 'User_Lessions_Entries'
--


LOCK TABLES User_Lessions_Entries WRITE;

/*!40000 ALTER TABLE User_Lessions_Entries ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table 'Users'
--

DROP TABLE IF EXISTS Users;
CREATE TABLE Users (
  id int(11) NOT NULL auto_increment,
  name varchar(12) NOT NULL default '',
  password varchar(12) NOT NULL default '',
  firstname varchar(32) NOT NULL default '',
  lastname varchar(32) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  level int(11) default NULL,
  isadmin int(1) NOT NULL default '0',
  reminder int(1) default NULL,
  sessionid varchar(16) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

/*!40000 ALTER TABLE Users DISABLE KEYS */;

--
-- Dumping data for table 'Users'
--


LOCK TABLES Users WRITE;

/*!40000 ALTER TABLE Users ENABLE KEYS */;
UNLOCK TABLES;

